(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    144303,       3993]
NotebookOptionsPosition[    139295,       3831]
NotebookOutlinePosition[    139890,       3854]
CellTagsIndexPosition[    139784,       3849]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"<<", 
  "\"\<C:\\\\Users\\\\Jamal\\\\Desktop\\\\main\\\\Research\\\\Codes\\\\IDOs\\\
\\ArtesteinsReduction\\\\TenReS.m\>\""}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694167372350441*^9, 3.694167385792696*^9}, {
   3.6993427658432713`*^9, 3.6993428272217827`*^9}, 3.726295541445579*^9, 
   3.7353630221171727`*^9, 3.7353631090608263`*^9, {3.739209341270771*^9, 
   3.739209358436659*^9}, 3.7395311202524767`*^9, 3.7396016592488675`*^9, 
   3.739716307000428*^9}],

Cell[CellGroupData[{

Cell[BoxData["\<\"Package TenReS version 0.2.4\\nwritten by Clemens G. \
Raab\\nCopyright 2016, RICAM, Austrian Academy of Sciences\"\>"], "Print",
 CellChangeTimes->CompressedData["
1:eJwdz2lIE3AYBvCxwmarSWZSi8q8yqOt0gWJCMuJZH4Q3UJct5q1MrHyYJVU
5NyalBfaojymyw5yRqm1L0YeJVRiRlRT84LaFulsamZZ/+f98PLjgefD8248
kpWYzuVwOBJ28IxrsG/O6pBuj218D8vjUycqBxzSWoOF1OSVzsJ42xCZdmlc
V8Vs1uy4CnlBskwDMzipgnwu6Gl6yswLX2SGEUHmdmg/N0bmvdYqnUxf92Ey
rs4vFW7OOklqFbkF8Jq8nfS8IC6EIu9MHVxvqq6GOYV2ctcKfTM8bvtAcrby
XsBb3UnknC31JfR2mEmXw1DgYs60TZBfOvwroMiYTeZfv/gQ7tO8IUPVbq1w
Q20CyfkzOgVdM1t+wsCqrgXqufq50/h3KGUJLHIe48Phg20e8PfulpUw9Kif
EHpanOso+0T6wrj+jgCoeCwTQ+1IGblJnBwG9SUmUq2siYIeXd9J1eqvMt6g
Q2rM2hkDax5UJkELd4TszOCegPK7e8ibC74aqL6ylzwbPamH9SH+xfCX0ORY
yoyonyAnz2u9+MyPM33kj881p+CzXhspKHPlwBRnVC4c5ShvQ9EhE+kd03sH
jgmEjbBvVYcVuk8tG4BxydsSljNj5y+ThvJxJ7SuFU9BAV83C/M7+8nudLc1
AqZqIYG8/zdD7smM7qkjLdlyJSzx0ZKJzrfBXszST24hsEHxKFzI5BX/Ixuk
+1Vw8XQTmduaZoIB82byVeCwJgw77kmKoMj47QlUvZO0wMPSA6cjmaH2G+R/
0ojksg==
  "]],

Cell[BoxData[
 StyleBox["\<\"A few definitions need to be made by the user. Type ?CoeffQ, \
?Specialization, and ?CyclicModules for more information.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.7398701008455896`*^9},
 CellTags->"Info-974383ca-908d-4292-9fc1-adc8bd2d33b1"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Basic definitions", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.6400787807134733`*^9, 3.640078788888632*^9}, {
  3.659170131248847*^9, 3.659170137303594*^9}, {3.682830115630125*^9, 
  3.6828301266446743`*^9}}],

Cell[TextData[{
 "We want to compute in the tensor ring over ",
 Cell[BoxData[
  FormBox["K", TraditionalForm]]],
 "-bimodules. However, bimodules are not implemented, so the implementation \
uses the tensor algebra product over ",
 Cell[BoxData[
  FormBox["\[DoubleStruckCapitalZ]", TraditionalForm]]],
 "-modules. Consequently, the cyclic ",
 Cell[BoxData[
  FormBox["K", TraditionalForm]]],
 "-bimodule ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["M", "K"], TraditionalForm]]],
 " is not a cyclic ",
 Cell[BoxData[
  FormBox["\[DoubleStruckCapitalZ]", TraditionalForm]]],
 "-module."
}], "Text",
 CellChangeTimes->{{3.674799362782167*^9, 3.674799486021337*^9}, {
  3.674799838708332*^9, 3.674799892900877*^9}, {3.687079520040925*^9, 
  3.687079543347366*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Specialization", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"R", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"K", ",", 
        OverscriptBox["R", "~"]}], "}"}]}], ",", 
     RowBox[{"\[CapitalPhi]", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<E\>\"", ",", 
        OverscriptBox["\[CapitalPhi]", "~"]}], "}"}]}], ",", 
     RowBox[{"G", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"N", ",", 
        OverscriptBox["G", "~"]}], "}"}]}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6398890163113747`*^9, 3.639889054043709*^9}, {
   3.639889737312602*^9, 3.639889744112504*^9}, {3.6398940881500607`*^9, 
   3.639894098174966*^9}, {3.659086827358851*^9, 3.659086831494749*^9}, {
   3.659088973275432*^9, 3.659088977842003*^9}, {3.6590976281633368`*^9, 
   3.659097642819615*^9}, {3.670244973878394*^9, 3.670245032387117*^9}, {
   3.670247219591683*^9, 3.670247222415421*^9}, 3.6871531306206007`*^9, {
   3.689592234536019*^9, 3.6895922372660227`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"CyclicModules", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"K", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<E\>\"", ",", "Eval"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"D", ",", "Diff"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<I\>\"", ",", "Int"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"N", ",", 
       RowBox[{"S", "[", 
        RowBox[{"1", ",", "0"}], "]"}]}], "}"}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.659096534797022*^9, 3.6590965352753773`*^9}, {
   3.659096673633688*^9, 3.659096675368188*^9}, {3.670245062107257*^9, 
   3.6702451117240057`*^9}, {3.670245295686005*^9, 3.67024532450555*^9}, {
   3.670247225231395*^9, 3.6702472253272943`*^9}, 3.687153154519842*^9}],

Cell[CellGroupData[{

Cell["Bimodule structure", "Subsection",
 CellChangeTimes->{{3.683001088920826*^9, 3.68300109299426*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Prod", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"b", ":", 
     RowBox[{"Diff", "|", "Int", "|", "Eval", "|", 
      RowBox[{"\[CapitalPhi]", "[", "_Integer", "]"}], "|", 
      RowBox[{"S", "[", 
       RowBox[{
        RowBox[{"_", "?", 
         SubscriptBox["MemberQ", "Z"]}], ",", 
        RowBox[{"_", "?", 
         SubscriptBox["MemberQ", "Z"]}]}], "]"}]}]}], ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"c_", "?", 
       SubscriptBox["MemberQ", "K"]}], ")"}], 
     RowBox[{"Prod", "[", "]"}]}], ",", "d___"}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{"a", ",", 
    RowBox[{"c", " ", 
     RowBox[{"Prod", "[", "]"}]}], ",", "b", ",", "d"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Prod", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"b_", "?", 
     SubscriptBox["MemberQ", "R"]}], ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"c_", "?", 
       SubscriptBox["MemberQ", "K"]}], ")"}], 
     RowBox[{"Prod", "[", "]"}]}], ",", "d___"}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{"a", ",", 
    RowBox[{"mul", "[", 
     RowBox[{"b", ",", "c"}], "]"}], ",", "d"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Prod", "[", 
   RowBox[{"a___", ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"b_", "?", 
       SubscriptBox["MemberQ", "K"]}], ")"}], 
     RowBox[{"Prod", "[", "]"}]}], ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"c_", "?", 
       SubscriptBox["MemberQ", "K"]}], ")"}], 
     RowBox[{"Prod", "[", "]"}]}], ",", "d___"}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{"a", ",", 
    RowBox[{
     RowBox[{"mul", "[", 
      RowBox[{"b", ",", "c"}], "]"}], 
     RowBox[{"Prod", "[", "]"}]}], ",", "d"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Prod", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"mul", "[", 
     RowBox[{
      RowBox[{"c_", "?", 
       SubscriptBox["MemberQ", "K"]}], ",", "f__"}], "]"}], ",", "b___"}], 
   "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{"a", ",", 
    RowBox[{"c", " ", 
     RowBox[{"Prod", "[", "]"}]}], ",", 
    RowBox[{"mul", "[", "f", "]"}], ",", "b"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"Prod", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"b_", "*", "c_Plus"}], ",", "d___"}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{"a", ",", 
    RowBox[{"Map", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"b", "*", "#"}], "&"}], ",", "c"}], "]"}], ",", "d"}], 
   "]"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.682838778862541*^9, 3.682838843044186*^9}, 
   3.68283887404455*^9, {3.682838905347752*^9, 3.682838945747851*^9}, {
   3.6828389863455553`*^9, 3.682839001603705*^9}, {3.682839064639946*^9, 
   3.682839067127886*^9}, {3.6829202148020077`*^9, 3.682920246908084*^9}, {
   3.6829202861393833`*^9, 3.682920383404994*^9}, {3.6829204540780697`*^9, 
   3.6829204543463497`*^9}, {3.682920550373654*^9, 3.682920568978134*^9}, {
   3.687153170837471*^9, 3.6871531990579205`*^9}, 3.6871532388223906`*^9, {
   3.6871532710520473`*^9, 3.687153299007296*^9}, {3.6871537992221746`*^9, 
   3.6871538033249817`*^9}, 3.6895922436960316`*^9, {3.7397751466232314`*^9, 
   3.739775147407276*^9}, {3.7397999423409195`*^9, 3.7397999438650064`*^9}, {
   3.73985180453522*^9, 3.739851817343952*^9}, {3.7398520967279325`*^9, 
   3.73985210438237*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Membership checks", "Subsection",
 CellChangeTimes->{{3.6591723429752007`*^9, 3.6591723786702147`*^9}, {
  3.670250652868689*^9, 3.6702506619234743`*^9}}],

Cell["Check for constants:", "Text",
 CellChangeTimes->{{3.659163098154707*^9, 3.659163115075246*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "K"], "[", "f_", "]"}], ":=", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"Diff", "[", "f", "]"}], "===", "0"}], ")"}]}]], "Input",
 CellChangeTimes->{{3.638682699993037*^9, 3.638682727301762*^9}, 
   3.67024541657796*^9, {3.68715821445373*^9, 3.6871582755278373`*^9}, {
   3.6871584196564903`*^9, 3.6871584226048956`*^9}, {3.6895922571560507`*^9, 
   3.6895922587360525`*^9}}],

Cell[TextData[{
 "We denote  ",
 Cell[BoxData[
  FormBox[
   RowBox[{"K", "\[Intersection]", 
    RowBox[{"Z", 
     RowBox[{"(", "R", ")"}]}]}], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " ( intersection of constants ",
 Cell[BoxData[
  FormBox["K", TraditionalForm]],
  FormatType->"TraditionalForm"],
 " with the center of ring ",
 Cell[BoxData[
  FormBox["R", TraditionalForm]],
  FormatType->"TraditionalForm"],
 ") by ",
 Cell[BoxData[
  FormBox["Z", TraditionalForm]],
  FormatType->"TraditionalForm"],
 " ."
}], "Text",
 CellChangeTimes->{{3.674799362782167*^9, 3.674799486021337*^9}, {
  3.674799838708332*^9, 3.674799892900877*^9}, {3.687079520040925*^9, 
  3.687079543347366*^9}, {3.689593404990744*^9, 3.689593572110978*^9}, {
  3.689593694373726*^9, 3.689593705262348*^9}, {3.689593735991106*^9, 
  3.689593739998335*^9}, {3.6895939396953936`*^9, 3.6895939510054097`*^9}, {
  3.6895939847354565`*^9, 3.6895940841055956`*^9}, {3.6896046549968677`*^9, 
  3.6896046575160117`*^9}, {3.690104488854461*^9, 3.690104489477497*^9}, {
  3.739773295370346*^9, 3.739773320288771*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "Z"], "[", "_Integer", "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "Z"], "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"A", "|", "B"}], ")"}], "[", "_Integer", "]"}], "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "Z"], "[", "f_Plus", "]"}], ":=", 
  RowBox[{"(", 
   RowBox[{"And", "@@", 
    RowBox[{"Map", "[", 
     RowBox[{
      SubscriptBox["MemberQ", "Z"], ",", 
      RowBox[{"List", "@@", "f"}]}], "]"}]}], ")"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "Z"], "[", "f_Times", "]"}], ":=", 
  RowBox[{"(", 
   RowBox[{"And", "@@", 
    RowBox[{"Map", "[", 
     RowBox[{
      SubscriptBox["MemberQ", "Z"], ",", 
      RowBox[{"List", "@@", "f"}]}], "]"}]}], ")"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "Z"], "[", 
   RowBox[{"Power", "[", 
    RowBox[{
     RowBox[{"f_", "?", 
      SubscriptBox["MemberQ", "Z"]}], ",", "_Integer"}], "]"}], "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "Z"], "[", "_", "]"}], ":=", "False"}]}], "Input",
 CellChangeTimes->{{3.6871538216862144`*^9, 3.6871538556786737`*^9}, {
  3.6871539025411563`*^9, 3.6871539328676095`*^9}, {3.68715458797616*^9, 
  3.687154597492177*^9}, {3.6871546640262938`*^9, 3.6871547075035706`*^9}, {
  3.687154777220093*^9, 3.6871547861433086`*^9}, {3.6871555406854334`*^9, 
  3.6871555997939377`*^9}, {3.6871563694686894`*^9, 3.687156379515107*^9}, {
  3.687156456938043*^9, 3.687156473084071*^9}, {3.6871577340186863`*^9, 
  3.6871577500867147`*^9}, {3.687157862094911*^9, 3.687157864388115*^9}, {
  3.6871579003773785`*^9, 3.6871579124049997`*^9}, {3.687157944572256*^9, 
  3.6871579629802885`*^9}, {3.6895922636660595`*^9, 3.689592264856061*^9}}],

Cell["Check for membership in the function algebra:", "Text",
 CellChangeTimes->{{3.6591631194512157`*^9, 3.6591631291876383`*^9}, 
   3.659163217493614*^9, {3.6591724206231956`*^9, 3.659172422789729*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", 
   RowBox[{"F", "[", "_Integer", "]"}], "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", 
   RowBox[{"Diff", "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", 
   RowBox[{"Int", "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", "f_mul", "]"}], ":=", 
  RowBox[{"And", "@@", 
   RowBox[{"(", 
    RowBox[{
     SubscriptBox["MemberQ", "R"], "/@", 
     RowBox[{"(", 
      RowBox[{"List", "@@", "f"}], ")"}]}], ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"s_", "?", 
      SubscriptBox["MemberQ", "G"]}], ")"}], "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", 
   RowBox[{"inv", "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"R", "[", "k_Integer", "]"}], ":=", 
  RowBox[{"F", "[", "k", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", 
   RowBox[{"f_", "?", 
    SubscriptBox["MemberQ", "K"]}], "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"c_", "?", "CoeffQ"}], ")"}], "f_"}], "]"}], ":=", 
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", "f", "]"}]}], "\n", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", "f__Plus", "]"}], ":=", 
  RowBox[{"And", "@@", 
   RowBox[{"(", 
    RowBox[{
     SubscriptBox["MemberQ", "R"], "/@", 
     RowBox[{"(", 
      RowBox[{"List", "@@", "f"}], ")"}]}], ")"}]}]}], "\n", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", 
   RowBox[{"f_", "?", "MatrixQ"}], "]"}], ":=", 
  RowBox[{"And", "@@", 
   RowBox[{"(", 
    RowBox[{
     SubscriptBox["MemberQ", "R"], "/@", 
     RowBox[{"Flatten", "[", 
      RowBox[{"f", ",", "1"}], "]"}]}], ")"}]}]}]}], "Input",
 CellChangeTimes->{{3.669455790328519*^9, 3.6694557970644712`*^9}, {
   3.669543619267727*^9, 3.669543632574329*^9}, {3.670245501045932*^9, 
   3.670245606567086*^9}, 3.670246245762525*^9, 3.682830172179517*^9, {
   3.6828355629428263`*^9, 3.682835600736021*^9}, {3.6871533509085875`*^9, 
   3.687153351704189*^9}, {3.689592274976075*^9, 3.689592324676145*^9}, {
   3.6895923885585527`*^9, 3.689592428534314*^9}, {3.698728886447846*^9, 
   3.698728918015327*^9}, {3.698730164873973*^9, 3.698730171312064*^9}, {
   3.698730495221025*^9, 3.6987304978995113`*^9}, {3.69873057212881*^9, 
   3.698730576040122*^9}, {3.739715930342885*^9, 3.7397159317089634`*^9}, {
   3.7397691038264036`*^9, 3.7397691041814237`*^9}, {3.7397751276401453`*^9, 
   3.739775128208178*^9}}],

Cell["Check for functionals:", "Text",
 CellChangeTimes->{{3.670245973081357*^9, 3.670245977713456*^9}, {
  3.7397751207367506`*^9, 3.7397751211667757`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "\[CapitalPhi]"], "[", "Eval", "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "\[CapitalPhi]"], "[", 
   RowBox[{"\[CapitalPhi]", "[", "_Integer", "]"}], "]"}], ":=", 
  "True"}]}], "Input",
 CellChangeTimes->{{3.669455877198039*^9, 3.669455894498609*^9}, 
   3.669543189868985*^9, {3.6702459832458897`*^9, 3.670246019832996*^9}, {
   3.687103716685647*^9, 3.687103749558527*^9}, {3.6871039884201894`*^9, 
   3.6871039890202236`*^9}, 3.687153387038251*^9}],

Cell["Check for substitutions:", "Text",
 CellChangeTimes->{{3.6871534023886776`*^9, 3.6871534127626963`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "G"], "[", 
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"a_", "?", 
      SubscriptBox["MemberQ", "Z"]}], ",", 
     RowBox[{"b_", "?", 
      SubscriptBox["MemberQ", "Z"]}]}], "]"}], "]"}], ":=", 
  RowBox[{"(", 
   RowBox[{"a", "=!=", "0"}], ")"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "G"], "[", 
   RowBox[{"G", "[", "_Integer", "]"}], "]"}], ":=", "True"}]}], "Input",
 CellChangeTimes->{3.6871533833098445`*^9, 3.6871537713293257`*^9}],

Cell["Check for membership in the other cyclic modules:", "Text",
 CellChangeTimes->{{3.6702458564563427`*^9, 3.670245866975058*^9}, {
  3.670245946760453*^9, 3.670245947584765*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "D"], "[", "Diff", "]"}], ":=", "True"}], "\n", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "\"\<I\>\""], "[", "Int", "]"}], ":=", 
  "True"}], "\n", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "\"\<E\>\""], "[", "Eval", "]"}], ":=", 
  "True"}], "\n", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "N"], "[", 
   RowBox[{"S", "[", 
    RowBox[{"1", ",", "0"}], "]"}], "]"}], ":=", "True"}]}], "Input",
 CellChangeTimes->{{3.739775108515052*^9, 3.73977511407837*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Function algebra", "Subsection",
 CellChangeTimes->{{3.638691610025188*^9, 3.638691614921186*^9}, {
  3.659165795915909*^9, 3.6591657979705772`*^9}}],

Cell[CellGroupData[{

Cell["Multiplication", "Subsubsection",
 CellChangeTimes->{{3.659165569776952*^9, 3.659165577588789*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", "b_Plus", ",", "c___"}], "]"}], ":=", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"mul", "[", 
      RowBox[{"a", ",", "#", ",", "c"}], "]"}], "&"}], "/@", "b"}], 
   ")"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", "b_Integer", ",", "c__"}], "]"}], ":=", 
  RowBox[{"b", " ", 
   RowBox[{"mul", "[", 
    RowBox[{"a", ",", "c"}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a__", ",", "b_Integer", ",", "c___"}], "]"}], ":=", 
  RowBox[{"b", " ", 
   RowBox[{"mul", "[", 
    RowBox[{"a", ",", "c"}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"d_Integer", "*", "b_"}], ",", "c___"}], "]"}], ":=", 
  RowBox[{"d", " ", 
   RowBox[{"mul", "[", 
    RowBox[{"a", ",", "b", ",", "c"}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"mul", "[", "b__", "]"}], ",", "c___"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", "b", ",", "c"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mul", "[", "a_", "]"}], ":=", "a"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"b_", "?", 
     SubscriptBox["MemberQ", "Z"]}], ",", 
    RowBox[{"c_", "?", 
     SubscriptBox["MemberQ", "Z"]}], ",", "d___"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", 
    RowBox[{"b", "*", "c"}], ",", "d"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"b_", "?", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{
         SubscriptBox["MemberQ", "R"], "[", "#", "]"}], "&&", 
        RowBox[{"!", 
         RowBox[{
          SubscriptBox["MemberQ", "Z"], "[", "#", "]"}]}]}], "&"}], ")"}]}], 
    ",", 
    RowBox[{"c_", "?", 
     SubscriptBox["MemberQ", "Z"]}], ",", "d___"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", "c", ",", "b", ",", "d"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], ",", 
    RowBox[{"inv", "[", "f_", "]"}], ",", "b___"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", "b"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"inv", "[", "f_", "]"}], ",", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], ",", "b___"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", "b"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"mul", "[", "]"}], ":=", "1"}]}], "Input",
 CellChangeTimes->{{3.638684986800296*^9, 3.638685023740603*^9}, {
   3.638685085399458*^9, 3.6386851016267347`*^9}, {3.6386852559617443`*^9, 
   3.638685292086501*^9}, {3.638685328564872*^9, 3.63868533076567*^9}, {
   3.638685453632114*^9, 3.638685456591627*^9}, {3.638685773732319*^9, 
   3.63868577618708*^9}, 3.6386858741418343`*^9, {3.63869290635741*^9, 
   3.6386929232045727`*^9}, {3.6387824422362843`*^9, 3.638782493065415*^9}, {
   3.6388722777325487`*^9, 3.6388722903501*^9}, {3.639212523253624*^9, 
   3.639212586876335*^9}, 3.639980360207717*^9, {3.739775082471562*^9, 
   3.739775083382614*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Differentiation", "Subsubsection",
 CellChangeTimes->{{3.659163141267557*^9, 3.6591631488521423`*^9}, 
   3.659165586346394*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Diff", "[", 
   RowBox[{"f_", "?", "NumericQ"}], "]"}], ":=", "0"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Diff", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"\[CurlyPhi]_", "?", 
      SubscriptBox["MemberQ", "\[CapitalPhi]"]}], ")"}], "[", "f_", "]"}], 
   "]"}], ":=", "0"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Diff", "[", 
   RowBox[{"f_", "?", 
    SubscriptBox["MemberQ", "Z"]}], "]"}], ":=", "0"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Diff", "[", 
   RowBox[{"Int", "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  "f"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Diff", "[", "a_mul", "]"}], ":=", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{"MapAt", "[", 
     RowBox[{"Diff", ",", "a", ",", "i"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", 
      RowBox[{"Length", "[", "a", "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Diff", "[", "f_Plus", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{"Diff", ",", "f"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"Diff", "[", 
   RowBox[{"inv", "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  RowBox[{"-", 
   RowBox[{"mul", "[", 
    RowBox[{
     RowBox[{"inv", "[", "f", "]"}], ",", 
     RowBox[{"Diff", "[", "f", "]"}], ",", 
     RowBox[{"inv", "[", "f", "]"}]}], "]"}]}]}], "\n", 
 RowBox[{
  RowBox[{"Diff", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"c_", "?", "CoeffQ"}], ")"}], 
    RowBox[{"(", 
     RowBox[{"f_", "?", 
      SubscriptBox["MemberQ", "R"]}], ")"}]}], "]"}], ":=", 
  RowBox[{"c", " ", 
   RowBox[{"Diff", "[", "f", "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.638682746051725*^9, 3.638682788960909*^9}, {
   3.638682825870358*^9, 3.638682962118843*^9}, {3.6386831317951612`*^9, 
   3.638683190849043*^9}, {3.638683239496002*^9, 3.638683300736999*^9}, {
   3.638683391426631*^9, 3.6386834461159897`*^9}, {3.638782252717188*^9, 
   3.638782253282292*^9}, {3.638782504556032*^9, 3.6387825049058027`*^9}, {
   3.639212762878365*^9, 3.639212788512412*^9}, {3.640058908518703*^9, 
   3.640058989848414*^9}, {3.6400590763931026`*^9, 3.640059144710424*^9}, {
   3.659159838349127*^9, 3.659159839787879*^9}, {3.659701295933262*^9, 
   3.6597012991698523`*^9}, {3.659701749337516*^9, 3.6597017541360083`*^9}, {
   3.659701785652364*^9, 3.6597017880263767`*^9}, {3.659701846596245*^9, 
   3.6597018492038803`*^9}, {3.670246185189465*^9, 3.670246215676208*^9}, {
   3.670246254518935*^9, 3.670246256356043*^9}, {3.670246334717093*^9, 
   3.670246369529475*^9}, 3.670246738163018*^9, {3.670249771073493*^9, 
   3.6702497719200172`*^9}, {3.68283571585677*^9, 3.682835730684732*^9}, {
   3.6829379750055523`*^9, 3.682937975485763*^9}, {3.6829429368147717`*^9, 
   3.68294293771128*^9}, {3.6871559666597815`*^9, 3.687155983913412*^9}, {
   3.6871561575257173`*^9, 3.6871561891167727`*^9}, {3.6871583790964193`*^9, 
   3.687158413042079*^9}, 3.6895924605543594`*^9, {3.7262066801423664`*^9, 
   3.726206691530386*^9}, {3.7262067287676516`*^9, 3.726206739937271*^9}, {
   3.739774940767457*^9, 3.7397749417545137`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Integration", "Subsubsection",
 CellChangeTimes->{{3.6591631541798153`*^9, 3.6591631569643307`*^9}, 
   3.6591655902493143`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{"f_", "?", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{
        SubscriptBox["MemberQ", "K"], "[", "#", "]"}], "&&", 
       RowBox[{"(", 
        RowBox[{"#", "=!=", "1"}], ")"}]}], "&"}], ")"}]}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"f", ",", " ", 
    RowBox[{"Int", "[", "1", "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{"mul", "[", 
    RowBox[{"f__", ",", 
     RowBox[{"c_", "?", 
      SubscriptBox["MemberQ", "K"]}]}], "]"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{
    RowBox[{"Int", "[", 
     RowBox[{"mul", "[", "f", "]"}], "]"}], ",", "c"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{"Diff", "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  RowBox[{"f", "-", 
   RowBox[{"Eval", "[", "f", "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"Int", "/:", 
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"Int", "[", "f_", "]"}], ",", 
    RowBox[{"Int", "[", "g_", "]"}], ",", "b___"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"mul", "[", 
    RowBox[{"a", ",", 
     RowBox[{"Int", "[", 
      RowBox[{"mul", "[", 
       RowBox[{
        RowBox[{"Int", "[", "f", "]"}], ",", "g"}], "]"}], "]"}], ",", "b"}], 
    "]"}], "+", 
   RowBox[{"mul", "[", 
    RowBox[{"a", ",", 
     RowBox[{"Int", "[", 
      RowBox[{"mul", "[", 
       RowBox[{"f", ",", 
        RowBox[{"Int", "[", "g", "]"}]}], "]"}], "]"}], ",", "b"}], 
    "]"}]}]}], "\n", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"Int", "[", "1", "]"}], ",", 
    RowBox[{"c_", "?", 
     SubscriptBox["MemberQ", "K"]}], ",", "b___"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", "c", ",", 
    RowBox[{"Int", "[", "1", "]"}], ",", "b"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"Int", "[", "f_Plus", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{"Int", ",", "f"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"c_", "?", "CoeffQ"}], ")"}], 
    RowBox[{"(", 
     RowBox[{"f_", "?", 
      SubscriptBox["MemberQ", "R"]}], ")"}]}], "]"}], ":=", 
  RowBox[{"c", " ", 
   RowBox[{"Int", "[", "f", "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.659162411432198*^9, 3.659162412408951*^9}, {
   3.659164197207127*^9, 3.659164197790752*^9}, {3.659171490362842*^9, 
   3.659171491487652*^9}, {3.6597013045303164`*^9, 3.6597013070497923`*^9}, {
   3.65970147718134*^9, 3.659701479851516*^9}, {3.670246390359516*^9, 
   3.670246410313141*^9}, {3.682835743292811*^9, 3.682835756499106*^9}, {
   3.682922363505677*^9, 3.6829223924145117`*^9}, {3.682926287313134*^9, 
   3.682926320109994*^9}, 3.6895924739343777`*^9, {3.723020749052878*^9, 
   3.723020756203888*^9}, {3.7397749543032312`*^9, 3.739774955211283*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Induced evaluation", "Subsubsection",
 CellChangeTimes->{{3.6591631661642323`*^9, 3.659163171220705*^9}, 
   3.659165594273448*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Eval", "[", 
   RowBox[{"f_", "?", 
    SubscriptBox["MemberQ", "K"]}], "]"}], ":=", "f"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Eval", "[", 
   RowBox[{"Int", "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  "0"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Eval", "[", "f_mul", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{"Eval", ",", "f"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Eval", "[", "f_Plus", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{"Eval", ",", "f"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"Eval", "[", 
     RowBox[{"f_", "?", 
      SubscriptBox["MemberQ", "R"]}], "]"}], ",", 
    RowBox[{"Eval", "[", 
     RowBox[{"inv", "[", 
      RowBox[{"f_", "?", 
       SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ",", "b___"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", "b"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.65916263319906*^9, 3.6591626335436068`*^9}, {
   3.670246424800674*^9, 3.670246429623632*^9}, {3.6828358313150043`*^9, 
   3.6828358410828857`*^9}, {3.6829210945837917`*^9, 3.682921099615996*^9}, {
   3.682922258911646*^9, 3.682922261329509*^9}, {3.6871018941824055`*^9, 
   3.687101922244011*^9}, 3.6871021395064373`*^9, 3.689592465414366*^9, {
   3.739774962286688*^9, 3.739774963063732*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Functionals", "Subsubsection",
 CellChangeTimes->{{3.6591641415283527`*^9, 3.6591641443831253`*^9}, 
   3.6591656005776367`*^9}],

Cell[BoxData[{
 RowBox[{"\[CapitalPhi]", "/:", 
  RowBox[{
   RowBox[{"\[CapitalPhi]", "[", "i_Integer", "]"}], "[", "1", "]"}], ":=", 
  "1"}], "\[IndentingNewLine]", 
 RowBox[{"\[CapitalPhi]", "/:", 
  RowBox[{
   RowBox[{"\[CapitalPhi]", "[", "i_Integer", "]"}], "[", "f_mul", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{"\[CapitalPhi]", "[", "i", "]"}], ",", "f"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"\[CapitalPhi]", "/:", 
  RowBox[{
   RowBox[{"\[CapitalPhi]", "[", "i_Integer", "]"}], "[", "f_Plus", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{"\[CapitalPhi]", "[", "i", "]"}], ",", "f"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.6871017707413454`*^9, 3.6871017750975943`*^9}, {
   3.6871018476607447`*^9, 3.687101848025766*^9}, 3.687102142485608*^9, {
   3.7397749684070377`*^9, 3.739774969333091*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Substitutions", "Subsubsection",
 CellChangeTimes->{{3.687153558950553*^9, 3.687153562351359*^9}}],

Cell[BoxData[{
 RowBox[{"S", "/:", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{"1", ",", "0"}], "]"}], "[", "f_", "]"}], ":=", 
  "f"}], "\[IndentingNewLine]", 
 RowBox[{"S", "/:", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"a_", "?", 
      SubscriptBox["MemberQ", "Z"]}], ",", 
     RowBox[{"b_", "?", 
      SubscriptBox["MemberQ", "Z"]}]}], "]"}], "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"t_", "?", 
      SubscriptBox["MemberQ", "G"]}], ")"}], "[", "f_", "]"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"comp", "[", 
    RowBox[{
     RowBox[{"S", "[", 
      RowBox[{"a", ",", "b"}], "]"}], ",", "t"}], "]"}], "[", "f", 
   "]"}]}], "\n", 
 RowBox[{"S", "/:", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"a_", "?", 
      SubscriptBox["MemberQ", "Z"]}], ",", 
     RowBox[{"b_", "?", 
      SubscriptBox["MemberQ", "Z"]}]}], "]"}], "[", 
   RowBox[{"c_", "?", 
    SubscriptBox["MemberQ", "K"]}], "]"}], ":=", "c"}], "\[IndentingNewLine]", 
 RowBox[{"S", "/:", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"a_", "?", 
      SubscriptBox["MemberQ", "Z"]}], ",", 
     RowBox[{"b_", "?", 
      SubscriptBox["MemberQ", "Z"]}]}], "]"}], "[", "f_mul", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{"S", "[", 
     RowBox[{"a", ",", "b"}], "]"}], ",", "f"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"S", "/:", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"a_", "?", 
      SubscriptBox["MemberQ", "Z"]}], ",", 
     RowBox[{"b_", "?", 
      SubscriptBox["MemberQ", "Z"]}]}], "]"}], "[", 
   RowBox[{"inv", "[", "f_", "]"}], "]"}], ":=", 
  RowBox[{"inv", "[", 
   RowBox[{
    RowBox[{"S", "[", 
     RowBox[{"a", ",", "b"}], "]"}], "[", "f", "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"S", "/:", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"a_", "?", 
      SubscriptBox["MemberQ", "Z"]}], ",", 
     RowBox[{"b_", "?", 
      SubscriptBox["MemberQ", "Z"]}]}], "]"}], "[", "f_Plus", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{"S", "[", 
     RowBox[{"a", ",", "b"}], "]"}], ",", "f"}], "]"}]}], "\n", 
 RowBox[{"S", "/:", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"a_", "?", 
      SubscriptBox["MemberQ", "Z"]}], ",", 
     RowBox[{"b_", "?", 
      SubscriptBox["MemberQ", "Z"]}]}], "]"}], "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"c_", "?", "CoeffQ"}], ")"}], 
    RowBox[{"(", 
     RowBox[{"f_", "?", 
      SubscriptBox["MemberQ", "R"]}], ")"}]}], "]"}], ":=", 
  RowBox[{"c", " ", 
   RowBox[{
    RowBox[{"S", "[", 
     RowBox[{"a", ",", "b"}], "]"}], "[", "f", 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"S", "/:", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"a_", "?", 
      SubscriptBox["MemberQ", "Z"]}], ",", 
     RowBox[{"b_", "?", 
      SubscriptBox["MemberQ", "Z"]}]}], "]"}], "[", 
   RowBox[{"Int", "[", "1", "]"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"mul", "[", 
    RowBox[{"a", ",", 
     RowBox[{"Int", "[", "1", "]"}]}], "]"}], "+", 
   RowBox[{"Eval", "[", 
    RowBox[{
     RowBox[{"S", "[", 
      RowBox[{"a", ",", "b"}], "]"}], "[", 
     RowBox[{"Hold", "[", 
      RowBox[{"Int", "[", "1", "]"}], "]"}], "]"}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"G", "[", "i_Integer", "]"}], ":=", 
  RowBox[{"S", "[", 
   RowBox[{
    RowBox[{"A", "[", "i", "]"}], ",", 
    RowBox[{"B", "[", "i", "]"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"jac", "[", 
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"a_", "?", 
      SubscriptBox["MemberQ", "Z"]}], ",", 
     RowBox[{"b_", "?", 
      SubscriptBox["MemberQ", "Z"]}]}], "]"}], "]"}], ":=", "a"}], "\n", 
 RowBox[{
  RowBox[{"comp", "[", 
   RowBox[{
    RowBox[{"S", "[", 
     RowBox[{
      RowBox[{"a_", "?", 
       SubscriptBox["MemberQ", "Z"]}], ",", 
      RowBox[{"b_", "?", 
       SubscriptBox["MemberQ", "Z"]}]}], "]"}], ",", 
    RowBox[{"S", "[", 
     RowBox[{
      RowBox[{"c_", "?", 
       SubscriptBox["MemberQ", "Z"]}], ",", 
      RowBox[{"d_", "?", 
       SubscriptBox["MemberQ", "Z"]}]}], "]"}]}], "]"}], ":=", 
  RowBox[{"S", "[", 
   RowBox[{
    RowBox[{"a", " ", "c"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"c", " ", "b"}], "+", "d"}], "//", "Expand"}], "//", 
     "Together"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"Diff", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"A", "|", "B"}], ")"}], "[", "_Integer", "]"}], "]"}], ":=", 
  "0"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Diff", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"s_", "?", 
      SubscriptBox["MemberQ", "G"]}], ")"}], "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{
    RowBox[{"jac", "[", "s", "]"}], ",", 
    RowBox[{"s", "[", 
     RowBox[{"Diff", "[", "f", "]"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{"S", "[", 
     RowBox[{
      RowBox[{"a_", "?", 
       SubscriptBox["MemberQ", "K"]}], ",", 
      RowBox[{"b_", "?", 
       SubscriptBox["MemberQ", "K"]}]}], "]"}], "[", "f_", "]"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{
    FractionBox["1", "a"], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"S", "[", 
       RowBox[{"a", ",", "b"}], "]"}], "[", 
      RowBox[{"Int", "[", "f", "]"}], "]"}], "-", 
     RowBox[{"Eval", "[", 
      RowBox[{
       RowBox[{"S", "[", 
        RowBox[{"a", ",", "b"}], "]"}], "[", 
       RowBox[{"Int", "[", "f", "]"}], "]"}], "]"}]}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"inv", "[", 
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"a_", "?", 
      SubscriptBox["MemberQ", "K"]}], ",", 
     RowBox[{"b_", "?", 
      SubscriptBox["MemberQ", "K"]}]}], "]"}], "]"}], ":=", 
  RowBox[{"S", "[", 
   RowBox[{
    RowBox[{"1", "/", "a"}], ",", 
    RowBox[{
     RowBox[{"-", "b"}], "/", "a"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Eval", "[", 
   RowBox[{
    RowBox[{"S", "[", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"A", "[", "1", "]"}]], ",", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"B", "[", "1", "]"}], 
        RowBox[{"A", "[", "1", "]"}]]}]}], "]"}], "[", 
    RowBox[{"Hold", "[", 
     RowBox[{"Int", "[", "1", "]"}], "]"}], "]"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{
    RowBox[{"-", 
     FractionBox["1", 
      RowBox[{"A", "[", "1", "]"}]]}], ",", 
    RowBox[{"Eval", "[", 
     RowBox[{
      RowBox[{"S", "[", 
       RowBox[{
        RowBox[{"A", "[", "1", "]"}], ",", 
        RowBox[{"B", "[", "1", "]"}]}], "]"}], "[", 
      RowBox[{"Hold", "[", 
       RowBox[{"Int", "[", "1", "]"}], "]"}], "]"}], "]"}]}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.6871536562323236`*^9, 3.6871536667623425`*^9}, {
   3.687153696854795*^9, 3.687153755760498*^9}, 3.6895924908244014`*^9, {
   3.739774981503787*^9, 3.739775066067624*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Matrix computations in the coefficient ring", "Subsection",
 CellChangeTimes->{{3.726207142324378*^9, 3.726207209466896*^9}, {
  3.726207556022505*^9, 3.726207559766511*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mul", "[", 
    RowBox[{"a___", ",", 
     RowBox[{"m1_", "?", "MatrixQ"}], ",", 
     RowBox[{"m2_", "?", "MatrixQ"}], ",", "b___"}], "]"}], "/;", 
   RowBox[{
    RowBox[{"Length", "[", 
     RowBox[{"m1", "[", 
      RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", 
    RowBox[{"Length", "[", "m2", "]"}]}]}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", 
    RowBox[{"Inner", "[", 
     RowBox[{"mul", ",", "m1", ",", "m2"}], "]"}], ",", "b"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.722595602026443*^9, 3.7225956326258907`*^9}, {
  3.7225956932327414`*^9, 3.722595723506545*^9}, {3.72259582464373*^9, 
  3.7225958350193644`*^9}, {3.722595879486856*^9, 3.722595910485755*^9}, {
  3.7225966032515306`*^9, 3.72259661861121*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Diff", "[", 
   RowBox[{"m_", "?", "MatrixQ"}], "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{"Diff", ",", "m", ",", 
    RowBox[{"{", "2", "}"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{"m_", "?", "MatrixQ"}], "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{"Int", ",", "m", ",", 
    RowBox[{"{", "2", "}"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"S", "/:", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"a_", "?", 
      SubscriptBox["MemberQ", "Z"]}], ",", 
     RowBox[{"b_", "?", 
      SubscriptBox["MemberQ", "Z"]}]}], "]"}], "[", 
   RowBox[{"m_", "?", "MatrixQ"}], "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{"S", "[", 
     RowBox[{"a", ",", "b"}], "]"}], ",", "m", ",", 
    RowBox[{"{", "2", "}"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Prod", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"c_", "?", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"MatrixQ", "[", "#", "]"}], "&&", 
        RowBox[{"MatchQ", "[", 
         RowBox[{
          RowBox[{"Flatten", "[", 
           RowBox[{"#", ",", "1"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"Repeated", "[", "0", "]"}], "}"}]}], "]"}]}], "&"}], 
      ")"}]}], ",", "b___"}], "]"}], ":=", 
  "0"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.7225959990524282`*^9, 3.722596034261569*^9}, {
   3.722596065881753*^9, 3.722596084166253*^9}, {3.7389094623721333`*^9, 
   3.7389094820052557`*^9}, {3.7389095213705077`*^9, 3.738909549436113*^9}, 
   3.738909764973441*^9, {3.7398521205392942`*^9, 3.739852121568353*^9}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Reduction system for IDOLS", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.682830373294333*^9, 3.682830377957657*^9}, {
  3.6895928521349087`*^9, 3.6895929344350233`*^9}, {3.6896046787532263`*^9, 
  3.689604682363433*^9}, {3.6941678932953777`*^9, 3.694167902694168*^9}, {
  3.7262066047006335`*^9, 3.726206607025038*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["h", "K"], "[", "k_", "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{"k", " ", 
    RowBox[{"Prod", "[", "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "RR"], "[", 
   RowBox[{
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], ",", 
    RowBox[{"g_", "?", 
     SubscriptBox["MemberQ", "R"]}]}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{"mul", "[", 
    RowBox[{"f", ",", "g"}], "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "\[CapitalPhi]R"], "[", 
   RowBox[{
    RowBox[{"\[CurlyPhi]_", "?", 
     SubscriptBox["MemberQ", "\[CapitalPhi]"]}], ",", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}]}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"\[CurlyPhi]", "[", "f", "]"}], 
     RowBox[{"Prod", "[", "]"}]}], ",", "\[CurlyPhi]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "\[CapitalPhi]\[CapitalPhi]"], "[", 
   RowBox[{
    RowBox[{"\[CurlyPhi]_", "?", 
     SubscriptBox["MemberQ", "\[CapitalPhi]"]}], ",", 
    RowBox[{"\[Psi]_", "?", 
     SubscriptBox["MemberQ", "\[CapitalPhi]"]}]}], "]"}], ":=", 
  RowBox[{"Prod", "[", "\[Psi]", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "EI"], "[", 
   RowBox[{"Eval", ",", "Int"}], "]"}], ":=", "0"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "DR"], "[", 
   RowBox[{"Diff", ",", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}]}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Prod", "[", 
    RowBox[{"Diff", "[", "f", "]"}], "]"}], "+", 
   RowBox[{"Prod", "[", 
    RowBox[{"f", ",", "Diff"}], "]"}]}]}], "\n", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "D\[CapitalPhi]"], "[", 
   RowBox[{"Diff", ",", 
    RowBox[{"\[CurlyPhi]_", "?", 
     SubscriptBox["MemberQ", "\[CapitalPhi]"]}]}], "]"}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "DI"], "[", 
   RowBox[{"Diff", ",", "Int"}], "]"}], ":=", 
  RowBox[{"Prod", "[", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "I\[CapitalPhi]"], "[", 
   RowBox[{"Int", ",", 
    RowBox[{"\[CurlyPhi]_", "?", 
     SubscriptBox["MemberQ", "\[CapitalPhi]"]}]}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{
    RowBox[{"Int", "[", "1", "]"}], ",", "\[CurlyPhi]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "ID"], "[", 
   RowBox[{"Int", ",", "Diff"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Prod", "[", "]"}], "-", 
   RowBox[{"Prod", "[", "Eval", "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "II"], "[", 
   RowBox[{"Int", ",", "Int"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Prod", "[", 
    RowBox[{
     RowBox[{"Int", "[", "1", "]"}], ",", "Int"}], "]"}], "-", 
   RowBox[{"Prod", "[", 
    RowBox[{"Int", ",", 
     RowBox[{"Int", "[", "1", "]"}]}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "IR\[CapitalPhi]"], "[", 
   RowBox[{"Int", ",", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], ",", 
    RowBox[{"\[CurlyPhi]_", "?", 
     SubscriptBox["MemberQ", "\[CapitalPhi]"]}]}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{
    RowBox[{"Int", "[", "f", "]"}], ",", "\[CurlyPhi]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "IRD"], "[", 
   RowBox[{"Int", ",", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], ",", "Diff"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Prod", "[", "f", "]"}], "-", 
   RowBox[{"Prod", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Eval", "[", "f", "]"}], " ", 
      RowBox[{"Prod", "[", "]"}]}], ",", "Eval"}], "]"}], "-", 
   RowBox[{"Prod", "[", 
    RowBox[{"Int", ",", 
     RowBox[{"Diff", "[", "f", "]"}]}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "IRI"], "[", 
   RowBox[{"Int", ",", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], ",", "Int"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Prod", "[", 
    RowBox[{
     RowBox[{"Int", "[", "f", "]"}], ",", "Int"}], "]"}], "-", 
   RowBox[{"Prod", "[", 
    RowBox[{"Int", ",", 
     RowBox[{"Int", "[", "f", "]"}]}], "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.682830444156025*^9, 3.682830470225523*^9}, {
   3.682834198147834*^9, 3.682834214536252*^9}, {3.682851644402529*^9, 
   3.682851645428053*^9}, {3.6871003756050105`*^9, 3.68710039816265*^9}, {
   3.687151940149107*^9, 3.687151949961524*^9}, 3.6871521643059006`*^9, {
   3.687152270432887*^9, 3.687152272648091*^9}, {3.689592507214424*^9, 
   3.6895925166644373`*^9}, {3.6895925538644896`*^9, 3.689592565024505*^9}, {
   3.689592655624632*^9, 3.689592667544649*^9}, {3.6895927037147007`*^9, 
   3.6895928463249*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    SubscriptBox["h", "N"], "[", 
    RowBox[{"S", "[", 
     RowBox[{"1", ",", "0"}], "]"}], "]"}], "=", 
   RowBox[{"Prod", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "GR"], "[", 
   RowBox[{
    RowBox[{"s_", "?", 
     SubscriptBox["MemberQ", "G"]}], ",", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}]}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{
    RowBox[{"s", "[", "f", "]"}], ",", "s"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "G\[CapitalPhi]"], "[", 
   RowBox[{
    RowBox[{"s_", "?", 
     SubscriptBox["MemberQ", "G"]}], ",", 
    RowBox[{"\[CurlyPhi]_", "?", 
     SubscriptBox["MemberQ", "\[CapitalPhi]"]}]}], "]"}], ":=", 
  RowBox[{"Prod", "[", "\[CurlyPhi]", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "GG"], "[", 
   RowBox[{
    RowBox[{"s_", "?", 
     SubscriptBox["MemberQ", "G"]}], ",", 
    RowBox[{"t_", "?", 
     SubscriptBox["MemberQ", "G"]}]}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{"comp", "[", 
    RowBox[{"s", ",", "t"}], "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "DG"], "[", 
   RowBox[{"Diff", ",", 
    RowBox[{"s_", "?", 
     SubscriptBox["MemberQ", "G"]}]}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"jac", "[", "s", "]"}], 
     RowBox[{"Prod", "[", "]"}]}], ",", "s", ",", "Diff"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "IG"], "[", 
   RowBox[{"Int", ",", 
    RowBox[{"s_", "?", 
     SubscriptBox["MemberQ", "G"]}]}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{
    RowBox[{
     FractionBox["1", 
      RowBox[{"jac", "[", "s", "]"}]], 
     RowBox[{"Prod", "[", "]"}]}], ",", 
    RowBox[{
     RowBox[{"Prod", "[", "]"}], "-", "Eval"}], ",", "s", ",", "Int"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "IRG"], "[", 
   RowBox[{"Int", ",", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], ",", 
    RowBox[{"s_", "?", 
     SubscriptBox["MemberQ", "G"]}]}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{
    RowBox[{
     FractionBox["1", 
      RowBox[{"jac", "[", "s", "]"}]], 
     RowBox[{"Prod", "[", "]"}]}], ",", 
    RowBox[{
     RowBox[{"Prod", "[", "]"}], "-", "Eval"}], ",", "s", ",", "Int", ",", 
    RowBox[{
     RowBox[{"inv", "[", "s", "]"}], "[", "f", "]"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.6871549385087757`*^9, 3.6871549814868517`*^9}, {
  3.6895925316744585`*^9, 3.689592537664467*^9}, {3.689592953985051*^9, 
  3.6895929845850935`*^9}, {3.689593053670707*^9, 3.6895930626162186`*^9}, {
  3.6895931005383177`*^9, 3.6895931219283476`*^9}, {3.689593334838646*^9, 
  3.6895933369086485`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"RedSys", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", "K", "}"}], ",", 
       SubscriptBox["h", "K"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"R", ",", "R"}], "}"}], ",", 
       SubscriptBox["h", "RR"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\[CapitalPhi]", ",", "R"}], "}"}], ",", 
       SubscriptBox["h", "\[CapitalPhi]R"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\[CapitalPhi]", ",", "\[CapitalPhi]"}], "}"}], ",", 
       SubscriptBox["h", "\[CapitalPhi]\[CapitalPhi]"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<E\>\"", ",", "\"\<I\>\""}], "}"}], ",", 
       SubscriptBox["h", "EI"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"D", ",", "R"}], "}"}], ",", 
       SubscriptBox["h", "DR"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"D", ",", "\[CapitalPhi]"}], "}"}], ",", 
       SubscriptBox["h", "D\[CapitalPhi]"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"D", ",", "\"\<I\>\""}], "}"}], ",", 
       SubscriptBox["h", "DI"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<I\>\"", ",", "\[CapitalPhi]"}], "}"}], ",", 
       SubscriptBox["h", "I\[CapitalPhi]"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<I\>\"", ",", "D"}], "}"}], ",", 
       SubscriptBox["h", "ID"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<I\>\"", ",", "\"\<I\>\""}], "}"}], ",", 
       SubscriptBox["h", "II"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<I\>\"", ",", "R", ",", "\[CapitalPhi]"}], "}"}], ",", 
       SubscriptBox["h", "IR\[CapitalPhi]"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<I\>\"", ",", "R", ",", "D"}], "}"}], ",", 
       SubscriptBox["h", "IRD"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<I\>\"", ",", "R", ",", "\"\<I\>\""}], "}"}], ",", 
       SubscriptBox["h", "IRI"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", "N", "}"}], ",", 
       SubscriptBox["h", "N"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"G", ",", "R"}], "}"}], ",", 
       SubscriptBox["h", "GR"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"G", ",", "\[CapitalPhi]"}], "}"}], ",", 
       SubscriptBox["h", "G\[CapitalPhi]"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"G", ",", "G"}], "}"}], ",", 
       SubscriptBox["h", "GG"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"D", ",", "G"}], "}"}], ",", 
       SubscriptBox["h", "DG"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<I\>\"", ",", "G"}], "}"}], ",", 
       SubscriptBox["h", "IG"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<I\>\"", ",", "R", ",", "G"}], "}"}], ",", 
       SubscriptBox["h", "IRG"]}], "}"}]}], "}"}]}], ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Auxiliary functions", "Section",
 InitializationCell->True,
 CellChangeTimes->{3.721113232148026*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["LeftCoeff", "R"], "[", 
   RowBox[{
    RowBox[{"Prod", "[", 
     RowBox[{
      RowBox[{"f__", "?", 
       SubscriptBox["MemberQ", "R"]}], ",", "m___"}], "]"}], ",", 
    RowBox[{"Prod", "[", "m___", "]"}]}], "]"}], ":=", 
  RowBox[{"mul", "[", "f", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["LeftCoeff", "R"], "[", 
   RowBox[{
    RowBox[{"Prod", "[", "m___", "]"}], ",", 
    RowBox[{"Prod", "[", "m___", "]"}]}], "]"}], ":=", 
  "1"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["LeftCoeff", "R"], "[", 
   RowBox[{
    RowBox[{"Prod", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"c_", "?", 
         SubscriptBox["MemberQ", "K"]}], ")"}], "*", 
       RowBox[{"Prod", "[", "]"}]}], ",", 
      RowBox[{"f___", "?", 
       SubscriptBox["MemberQ", "R"]}], ",", "m___"}], "]"}], ",", 
    RowBox[{"Prod", "[", "m___", "]"}]}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"c", ",", "f"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["LeftCoeff", "R"], "[", 
   RowBox[{"t_Prod", ",", 
    RowBox[{"Prod", "[", "m___", "]"}]}], "]"}], ":=", 
  "0"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["LeftCoeff", "R"], "[", 
   RowBox[{"a_Plus", ",", 
    RowBox[{"Prod", "[", "m___", "]"}]}], "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox["LeftCoeff", "R"], "[", 
      RowBox[{"#", ",", 
       RowBox[{"Prod", "[", "m", "]"}]}], "]"}], "&"}], ",", "a"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["LeftCoeff", "R"], "[", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"c_", "?", "CoeffQ"}], ")"}], "t_Prod"}], ",", 
    RowBox[{"Prod", "[", "m___", "]"}]}], "]"}], ":=", 
  RowBox[{"c", " ", 
   RowBox[{
    SubscriptBox["LeftCoeff", "R"], "[", 
    RowBox[{"t", ",", 
     RowBox[{"Prod", "[", "m", "]"}]}], "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.699351620935052*^9, 3.699351696511311*^9}, {
  3.699351908345364*^9, 3.699351927169579*^9}, {3.699352268410995*^9, 
  3.699352290178299*^9}, {3.699352447548417*^9, 3.6993524573555326`*^9}, {
  3.6993526692301083`*^9, 3.699352709251622*^9}, {3.699354814919639*^9, 
  3.699354865959058*^9}, {3.699354915253944*^9, 3.699354973183589*^9}, {
  3.699355521691896*^9, 3.699355530261294*^9}, {3.6993556750764303`*^9, 
  3.699355721031934*^9}, {3.714809595722381*^9, 3.714809629225843*^9}, {
  3.714811743154192*^9, 3.714811745482112*^9}, {3.720959585700904*^9, 
  3.720959599730564*^9}, {3.722669438862779*^9, 3.7226694443383884`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["Support", "R"], "[", 
   RowBox[{"Prod", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"c_", "?", 
        SubscriptBox["MemberQ", "K"]}], ")"}], "*", 
      RowBox[{"Prod", "[", "]"}]}], ",", "a___"}], "]"}], "]"}], ":=", 
  RowBox[{
   SubscriptBox["Support", "R"], "[", 
   RowBox[{"Prod", "[", "a", "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["Support", "R"], "[", 
   RowBox[{"Prod", "[", 
    RowBox[{
     RowBox[{"f__", "?", 
      SubscriptBox["MemberQ", "R"]}], ",", "a___"}], "]"}], "]"}], ":=", 
  RowBox[{
   SubscriptBox["Support", "R"], "[", 
   RowBox[{"Prod", "[", "a", "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["Support", "R"], "[", 
   RowBox[{"Prod", "[", "a___", "]"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{"Prod", "[", "a", "]"}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["Support", "R"], "[", "a_Plus", "]"}], ":=", 
  RowBox[{"Union", "@@", 
   RowBox[{"(", 
    RowBox[{
     SubscriptBox["Support", "R"], "/@", 
     RowBox[{"(", 
      RowBox[{"List", "@@", "a"}], ")"}]}], ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["Support", "R"], "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"c_", "?", "CoeffQ"}], ")"}], "t_Prod"}], "]"}], ":=", 
  RowBox[{
   SubscriptBox["Support", "R"], "[", "t", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["Support", "R"], "[", "0", "]"}], ":=", 
  RowBox[{"{", "}"}]}]}], "Input",
 CellChangeTimes->{{3.6993554712616453`*^9, 3.699355478105356*^9}, {
   3.6993560904101*^9, 3.699356094134852*^9}, {3.6993561385524406`*^9, 
   3.699356314720628*^9}, {3.699356348766143*^9, 3.699356403307789*^9}, {
   3.699356610362338*^9, 3.699356656845377*^9}, {3.7148096428305798`*^9, 
   3.7148096609734297`*^9}, {3.7148877588489027`*^9, 3.714887760693915*^9}, {
   3.714888758065007*^9, 3.714888762910594*^9}, {3.720959601482885*^9, 
   3.7209596329851303`*^9}, 3.722669432451168*^9, {3.7262105839831095`*^9, 
   3.726210594107527*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Coefficients", "[", "expr_", "]"}], ":=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"m", ",", 
      RowBox[{
       SubscriptBox["LeftCoeff", "R"], "[", 
       RowBox[{"expr", ",", "m"}], "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"m", ",", 
      RowBox[{
       SubscriptBox["Support", "R"], "[", "expr", "]"}]}], "}"}]}], 
   "]"}]}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["4) Recovering Artstein\[CloseCurlyQuote]s Transformation", "Section",
 CellChangeTimes->{{3.721113297475937*^9, 3.7211133060315228`*^9}, {
  3.726219325040496*^9, 3.7262193458041325`*^9}, {3.7375438646623755`*^9, 
  3.7375438663434715`*^9}}],

Cell[TextData[{
 "Consider the differential time-delay control system of the form\n\n         \
                                        ",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    RowBox[{
     RowBox[{
      OverscriptBox["x", "."], " ", 
      RowBox[{"(", "t", ")"}]}], " ", "=", "  ", 
     RowBox[{
      RowBox[{
       RowBox[{
        SubscriptBox["A", "0"], "(", "t", ")"}], " ", 
       RowBox[{"x", "(", "t", ")"}]}], " ", "+", " ", 
      RowBox[{
       RowBox[{
        SubscriptBox["B", "0"], "(", "t", ")"}], 
       RowBox[{"u", "(", "t", ")"}]}], " ", "+", 
      RowBox[{
       FormBox[
        RowBox[{" ", 
         SubscriptBox["B", "1"]}],
        TraditionalForm], 
       RowBox[{"(", "t", ")"}], 
       RowBox[{"u", "(", 
        RowBox[{"t", "-", "h"}], ")"}]}]}]}]}], TraditionalForm]]],
 "                               (1)\n            \nwhich can be written in \
terms of blocks as \n\n                                  ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{"(", GridBox[{
        {
         SubscriptBox["I", "n"], "0"}
       }], ")"}], 
     RowBox[{"(", GridBox[{
        {
         RowBox[{
          OverscriptBox["x", "."], 
          RowBox[{"(", "t", ")"}]}]},
        {
         RowBox[{
          OverscriptBox["u", "."], 
          RowBox[{"(", "t", ")"}]}]}
       }], ")"}]}], "=", 
    RowBox[{
     RowBox[{
      RowBox[{"(", GridBox[{
         {
          RowBox[{"A", 
           RowBox[{"(", "t", ")"}]}], 
          RowBox[{
           SubscriptBox["B", "0"], 
           RowBox[{"(", "t", ")"}]}]}
        }], ")"}], 
      RowBox[{"(", GridBox[{
         {
          RowBox[{"x", "(", "t", ")"}]},
         {
          RowBox[{"u", "(", "t", ")"}]}
        }], ")"}]}], "+", 
     RowBox[{
      RowBox[{"(", GridBox[{
         {"0", 
          RowBox[{
           SubscriptBox["B", "1"], 
           RowBox[{"(", "t", ")"}]}]}
        }], ")"}], 
      RowBox[{"(", GridBox[{
         {
          RowBox[{"x", "(", 
           RowBox[{"t", "-", "h"}], ")"}]},
         {
          RowBox[{"u", "(", 
           RowBox[{"t", "-", "h"}], ")"}]}
        }], ")"}]}]}]}], TraditionalForm]]],
 ".                      (2)\n       \nWe show how we can use our package to \
find by ansatz a transformation from the system above to the following \
differential system     \n        \n                                          \
                ",
 Cell[BoxData[
  FormBox[
   RowBox[{"  ", 
    RowBox[{
     RowBox[{
      OverscriptBox["z", "."], " ", 
      RowBox[{"(", "t", ")"}]}], " ", "=", "  ", 
     RowBox[{
      RowBox[{
       RowBox[{"E", "(", "t", ")"}], " ", 
       RowBox[{"z", "(", "t", ")"}]}], " ", "+", " ", 
      RowBox[{
       RowBox[{"F", "(", "t", ")"}], 
       RowBox[{"v", "(", "t", ")"}]}]}]}]}], TraditionalForm]]],
 ",                                                 (3)\n        \nwhich can \
be expressed in terms of blocks as \n      \n                                 \
                  ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{"(", GridBox[{
        {
         SubscriptBox["I", "n"], "0"}
       }], ")"}], " ", 
     FormBox[
      RowBox[{"(", GridBox[{
         {
          RowBox[{
           OverscriptBox["z", "."], "(", "t", ")"}]},
         {
          RowBox[{
           OverscriptBox["v", "."], "(", "t", ")"}]}
        }], ")"}],
      TraditionalForm]}], " ", "=", 
    RowBox[{
     FormBox[
      RowBox[{"(", GridBox[{
         {
          RowBox[{"E", "(", "t", ")"}], 
          RowBox[{"F", "(", "t", ")"}]}
        }], ")"}],
      TraditionalForm], "  ", 
     RowBox[{
      FormBox[
       RowBox[{"(", GridBox[{
          {
           RowBox[{"z", "(", "t", ")"}]},
          {
           RowBox[{"v", "(", "t", ")"}]}
         }], ")"}],
       TraditionalForm], " ", ".", "   "}]}]}], TraditionalForm]]],
 "                                         (4)\n        \nCorresponding to \
the systems (2) and (4) we consider the following operators\n\n               \
                                 ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{"R", "'"}], "=", 
     RowBox[{
      RowBox[{
       SubscriptBox[
        RowBox[{"R", "'"}], "0"], "\[CenterDot]", 
       RowBox[{"\[PartialD]", " ", 
        RowBox[{"+", " ", 
         SubscriptBox[
          RowBox[{"R", "'"}], "1"]}]}]}], "+", 
      RowBox[{
       SubscriptBox[
        RowBox[{"R", "'"}], "2"], "\[CenterDot]", "\[Delta]"}]}]}], ",", 
    "          ", 
    RowBox[{"R", "=", 
     RowBox[{
      SubscriptBox["R", "0"], "\[CenterDot]", 
      RowBox[{"\[PartialD]", " ", 
       RowBox[{"+", " ", 
        SubscriptBox["R", "1"]}]}]}]}], " ", ",", " "}], TraditionalForm]]],
 "                           (5), (6)\n                                       \
          \nwhere the coefficients have the block structures as  \n\n         \
                    ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox[
      RowBox[{"R", "'"}], "0"], "=", 
     RowBox[{"(", GridBox[{
        {
         SubscriptBox["I", "n"], "0"}
       }], ")"}]}], " ", ",", " ", 
    FormBox[
     RowBox[{
      RowBox[{
       SubscriptBox[
        RowBox[{"R", "'"}], "1"], "=", 
       RowBox[{"(", GridBox[{
          {
           RowBox[{"-", "A"}], 
           RowBox[{"-", 
            SubscriptBox["B", "0"]}]}
         }], ")"}]}], ",", " ", 
      RowBox[{
       SubscriptBox[
        RowBox[{"R", "'"}], "2"], "=", 
       RowBox[{"(", GridBox[{
          {"0", 
           RowBox[{"-", 
            SubscriptBox["B", "1"]}]}
         }], ")"}]}]}],
     TraditionalForm], ",", " ", 
    FormBox[
     RowBox[{
      SubscriptBox["R", "0"], "=", 
      RowBox[{"(", GridBox[{
         {
          SubscriptBox["I", "n"], "0"}
        }], ")"}]}],
     TraditionalForm], ",", " ", 
    RowBox[{
     SubscriptBox["R", "1"], "=", 
     RowBox[{"(", GridBox[{
        {
         RowBox[{"-", "E"}], 
         RowBox[{"-", "F"}]}
       }], ")"}]}]}], TraditionalForm]]],
 " .                \n                   \nOur goal is to find the operators ",
 Cell[BoxData[
  FormBox["P", TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox["Q", TraditionalForm]]],
 " such that \n\n                                                             \
               ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"R", "\[CenterDot]", " ", "P"}], " ", "=", " ", 
    RowBox[{"Q", "\[CenterDot]", " ", 
     RowBox[{"R", "'"}]}]}], TraditionalForm]]],
 ".                                                 (7)\n                     \
              \nFor the transformation we choose ",
 Cell[BoxData[
  FormBox[
   RowBox[{"Q", "=", 
    SubscriptBox["Q", "0"]}], TraditionalForm]]],
 " where ",
 Cell[BoxData[
  FormBox[Cell[TextData[Cell[BoxData[
    FormBox[
     SubscriptBox["Q", "0"], TraditionalForm]]]]], TraditionalForm]]],
 " is a multiplication operator and ",
 Cell[BoxData[
  FormBox["P", TraditionalForm]]],
 " as the simplified ansatz\n      \n                                         \
             ",
 Cell[BoxData[
  FormBox[
   RowBox[{"P", "=", 
    RowBox[{
     RowBox[{
      SubscriptBox["P", "0"], "\[CenterDot]", "\[Delta]", "\[CenterDot]", 
      RowBox[{"\[Integral]", 
       RowBox[{"\[CenterDot]", 
        SubscriptBox["P", "1"]}]}]}], "+", 
     RowBox[{
      SubscriptBox["P", "2"], "\[CenterDot]", 
      RowBox[{"\[Integral]", 
       RowBox[{"\[CenterDot]", 
        SubscriptBox["P", "3"]}]}]}], "+", " ", 
     RowBox[{
      SubscriptBox["P", "4"], "\[CenterDot]", "\[Delta]"}], "+", 
     SubscriptBox["P", "5"]}]}], TraditionalForm]]],
 ".                                 (8)\n\nMoreover, the operators ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["P", "0"], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["P", "1"], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["P", "2"], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["P", "3"], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["P", "4"], TraditionalForm]]],
 ", and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["P", "5"], TraditionalForm]]],
 " have undetermined blocks ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["P", "11"], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["P", "22"], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["a", "0"], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["a", "1"], TraditionalForm]]],
 ",",
 Cell[BoxData[
  FormBox[
   RowBox[{"  ", 
    SubscriptBox["a", "2"]}], TraditionalForm]]],
 Cell[BoxData[
  FormBox[
   RowBox[{",", 
    SubscriptBox["a", "3"]}], TraditionalForm]]],
 Cell[BoxData[
  FormBox[
   RowBox[{",", 
    SubscriptBox["a", "4"]}], TraditionalForm]]],
 ", and",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    SubscriptBox["a", "5"]}], TraditionalForm]]],
 " as follows\n\n                    ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox["P", "0"], "=", 
     RowBox[{"(", GridBox[{
        {
         SubscriptBox["a", "0"]},
        {"0"}
       }], ")"}]}], ",", "   ", 
    RowBox[{
     SubscriptBox["P", "1"], "=", 
     RowBox[{"(", GridBox[{
        {"0", 
         SubscriptBox["a", "1"]}
       }], ")"}]}], ",", "  ", 
    RowBox[{
     SubscriptBox["P", "2"], "=", 
     RowBox[{"(", GridBox[{
        {
         SubscriptBox["a", "2"]},
        {"0"}
       }], ")"}]}], ",", "  ", 
    RowBox[{
     SubscriptBox["P", "3"], "=", 
     RowBox[{"(", GridBox[{
        {"0", 
         SubscriptBox["a", "3"]}
       }], ")"}]}], ",", "  ", 
    RowBox[{
     SubscriptBox["P", "4"], "=", 
     RowBox[{"(", GridBox[{
        {"0", 
         SubscriptBox["a", "4"]},
        {"0", "0"}
       }], ")"}]}], ",", "   ", 
    RowBox[{
     SubscriptBox["P", "5"], "=", 
     RowBox[{"(", GridBox[{
        {
         SubscriptBox["P", "11"], 
         SubscriptBox["a", "5"]},
        {"0", 
         SubscriptBox["P", "22"]}
       }], ")"}]}]}], TraditionalForm]]],
 ".    \n                    \nFirst we need to introduce to our package the \
coefficients ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox[
     RowBox[{"R", "'"}], "0"], ",", " ", 
    SubscriptBox[
     RowBox[{"R", "'"}], "1"], ",", " ", 
    SubscriptBox[
     RowBox[{"R", "'"}], "2"], ",", " ", 
    SubscriptBox["P", "0"], ",", " ", 
    SubscriptBox["P", "1"], ",", " ", 
    SubscriptBox["P", "2"], ",", " ", 
    SubscriptBox["P", "3"], ",", " ", 
    SubscriptBox["P", "4"], ",", " ", 
    SubscriptBox["P", "5"], ",", " ", 
    SubscriptBox["Q", "0"], ","}], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[Cell["\[CapitalPhi]"], TraditionalForm]]],
 " which we use as elements of the coefficient ring ",
 Cell[BoxData[
  FormBox["R", TraditionalForm]]],
 ", the parameter ",
 Cell[BoxData[
  FormBox["h", TraditionalForm]]],
 " and the notation ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[Delta]", "=", 
    SubscriptBox["\[Sigma]", 
     RowBox[{"1", ",", "h"}]]}], TraditionalForm]]],
 ".          "
}], "Text",
 CellChangeTimes->CompressedData["
1:eJwdzF1MkmEABWDsgoZJM/sGK7StIk2j/ElxiDGYK2kYmWjh0tkoDAqhOUZM
20KazGprbhKzzcpaMSsjoyLdKlNuSOwPvQuXaesiFqMlSei093wXZ892dna2
akw12jUMBmM3CTSLnfl7/RHZ0MrjCjhYOVMJx3N2yeleTClhWVoXbUzBrIW6
Hdv0kF3VaYRKVoUXXqs744MWZvV3qIpn/YHUpf6UYqIwW8CEkg95Svi3p1sP
+R1vaPPH7f59+Hf9os0oWJyFtgHWNyhdmjohIWrvjZ2GAUb8PDSKb1lh9Un1
+1ri1XRWCBpyl6uS0xGZJvxZBfvcKXucYbLzPyiEVKK9HH5JTtA+sUaboKGt
QAN1t+0mmBhNbYesRc7wdWJ4LjoJqZ6zIVj0lFrnIj6fb1RAr6OzDqrNq//g
VMfCEszcNHKxl7j5Y6ENVtkVC9Bz5WUCpr+VKm4QD9z9ehjuD/YHoFE+OwFX
Qt76EWLqnOM4bObuFP4mau800orcmjI42H2f9iG/tJg9E5FNcnNKoGW01Qjz
4lkm+GMD2wynPwlomUGOFXaVrl6AnmcbHfBcNNMJDx4Z460nDnHqs+Ha4CEu
RdyivsmDbv7r7XCgTc6HDWkxIYz91Eug4NSrGtina1LBosvv1PDFsKABzi/7
mqFPl6uDjzwZBmgRuVro3sZpKSH2cnitUBoUHSsnBpJHaf8D4mJ79w==
  "]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", " ", 
   RowBox[{
    SubscriptBox["OR", "_Integer"], "|", 
    SubscriptBox["ORR", "_Integer"], "|", 
    SubscriptBox["P", "_Integer"], "|", 
    SubscriptBox["Q", "_Integer"], "|", "\[CapitalPhi]"}], "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "Z"], "[", "h", "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{"\[Delta]", ":=", 
  RowBox[{"S", "[", 
   RowBox[{"1", ",", "h"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.7208744586048193`*^9, 3.720874526951521*^9}, {
   3.726222269197059*^9, 3.7262222709442625`*^9}, {3.726222454322584*^9, 
   3.7262224617325974`*^9}, {3.726222517923896*^9, 3.726222523727106*^9}, {
   3.7262225612763724`*^9, 3.7262225688579855`*^9}, {3.7262226785261784`*^9, 
   3.7262226809441824`*^9}, {3.7262230952185097`*^9, 
   3.7262231165125475`*^9}, {3.7262236446454754`*^9, 
   3.7262236843475447`*^9}, {3.726223961035631*^9, 3.726223967759243*^9}, {
   3.7262263367151184`*^9, 3.726226338306321*^9}, {3.7262268282895823`*^9, 
   3.7262268315187883`*^9}, {3.7262310080696473`*^9, 3.726231018256465*^9}, {
   3.7262312393440537`*^9, 3.7262312446168633`*^9}, {3.726231438852804*^9, 
   3.726231467057654*^9}, {3.7262345017630033`*^9, 3.726234502394039*^9}, 
   3.726241330331843*^9, {3.7262413783799276`*^9, 3.726241404868774*^9}, 
   3.7262414351016273`*^9, {3.7262414910745254`*^9, 3.7262414920729275`*^9}, {
   3.7262418019018717`*^9, 3.726241802728673*^9}, {3.726241987885398*^9, 
   3.726242040878691*^9}, {3.726242337254817*^9, 3.7262423388460197`*^9}, {
   3.739774102968538*^9, 3.7397741038975906`*^9}}],

Cell[CellGroupData[{

Cell[TextData[{
 "1) Normal form computations for the lhs and the rhs of ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"R", "\[CenterDot]", "P"}], " ", "=", " ", 
    RowBox[{"Q", "\[CenterDot]", 
     RowBox[{"R", "'"}]}]}], TraditionalForm]]],
 "."
}], "Subsection",
 CellChangeTimes->{{3.737449039165777*^9, 3.7374491280888634`*^9}, {
   3.7374491628068495`*^9, 3.737449198066866*^9}, {3.737449627153408*^9, 
   3.7374496290875187`*^9}, {3.73744970288874*^9, 3.737449721263791*^9}, {
   3.7374554884725957`*^9, 3.73745553522927*^9}, 3.739774154895508*^9}],

Cell[BoxData[{
 RowBox[{"R1", ":=", 
  RowBox[{
   RowBox[{"Prod", "[", 
    RowBox[{
     SubscriptBox["OR", "0"], ",", "Diff"}], "]"}], "+", 
   RowBox[{"Prod", "[", 
    SubscriptBox["OR", "1"], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"P1", ":=", 
  RowBox[{
   RowBox[{"Prod", "[", 
    RowBox[{
     SubscriptBox["P", "0"], ",", "\[Delta]", ",", "Int", ",", 
     SubscriptBox["P", "1"]}], "]"}], "+", 
   RowBox[{"Prod", "[", 
    RowBox[{
     SubscriptBox["P", "2"], ",", "Int", ",", 
     SubscriptBox["P", "3"]}], "]"}], "+", 
   RowBox[{"Prod", "[", 
    RowBox[{
     SubscriptBox["P", "4"], ",", "\[Delta]"}], "]"}], "+", 
   RowBox[{"Prod", "[", 
    SubscriptBox["P", "5"], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"LHS", ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{"R1", ",", "P1"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.737448253120818*^9, 3.737448295901265*^9}, {
  3.7374483276160793`*^9, 3.7374483393687515`*^9}, {3.737448641224016*^9, 
  3.737448643664156*^9}, {3.7374487445449257`*^9, 3.7374487499922376`*^9}, {
  3.737448880624709*^9, 3.7374488816247663`*^9}, {3.737986699513678*^9, 
  3.737986701935817*^9}, {3.737990298457526*^9, 3.737990311322262*^9}, {
  3.7379903990512795`*^9, 3.7379904031055117`*^9}, {3.73987005015769*^9, 
  3.739870056591058*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"LeftSide", "=", 
     RowBox[{"ApplyRules", "[", 
      RowBox[{"LHS", ",", "RedSys"}], "]"}]}], ")"}], "//", "Coefficients"}], 
  "//", "TableForm"}]], "Input",
 CellChangeTimes->{{3.72087457753535*^9, 3.720874676207282*^9}, {
   3.722079977693082*^9, 3.722079989581319*^9}, {3.722080773411564*^9, 
   3.722080777024618*^9}, {3.7262222547046337`*^9, 3.726222293501902*^9}, {
   3.726224105429485*^9, 3.7262241235255165`*^9}, {3.7262263004118547`*^9, 
   3.7262263047018623`*^9}, {3.726230298478301*^9, 3.7262303096635203`*^9}, 
   3.7374482928690915`*^9, 3.737448324915924*^9, {3.7374483746957717`*^9, 
   3.7374483822802057`*^9}, {3.7379866214562135`*^9, 3.7379866357900333`*^9}, 
   3.7379866957104607`*^9, {3.7379869977067337`*^9, 3.7379870083193407`*^9}, {
   3.7379876893392925`*^9, 3.7379876919224405`*^9}, {3.73799031951373*^9, 
   3.7379903202937746`*^9}, {3.7395266715337133`*^9, 3.739526674557331*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{"Prod", "[", "]"}], 
     RowBox[{
      RowBox[{"mul", "[", 
       RowBox[{
        SubscriptBox["OR", "0"], ",", 
        RowBox[{"Diff", "[", 
         SubscriptBox["P", "5"], "]"}]}], "]"}], "+", 
      RowBox[{"mul", "[", 
       RowBox[{
        SubscriptBox["OR", "1"], ",", 
        SubscriptBox["P", "5"]}], "]"}], "+", 
      RowBox[{"mul", "[", 
       RowBox[{
        SubscriptBox["OR", "0"], ",", 
        SubscriptBox["P", "2"], ",", 
        SubscriptBox["P", "3"]}], "]"}]}]},
    {
     RowBox[{"Prod", "[", "Diff", "]"}], 
     RowBox[{"mul", "[", 
      RowBox[{
       SubscriptBox["OR", "0"], ",", 
       SubscriptBox["P", "5"]}], "]"}]},
    {
     RowBox[{"Prod", "[", 
      RowBox[{"S", "[", 
       RowBox[{"1", ",", "h"}], "]"}], "]"}], 
     RowBox[{
      RowBox[{"mul", "[", 
       RowBox[{
        SubscriptBox["OR", "0"], ",", 
        RowBox[{"Diff", "[", 
         SubscriptBox["P", "4"], "]"}]}], "]"}], "+", 
      RowBox[{"mul", "[", 
       RowBox[{
        SubscriptBox["OR", "1"], ",", 
        SubscriptBox["P", "4"]}], "]"}], "+", 
      RowBox[{"mul", "[", 
       RowBox[{
        SubscriptBox["OR", "0"], ",", 
        SubscriptBox["P", "0"], ",", 
        RowBox[{
         RowBox[{"S", "[", 
          RowBox[{"1", ",", "h"}], "]"}], "[", 
         SubscriptBox["P", "1"], "]"}]}], "]"}]}]},
    {
     RowBox[{"Prod", "[", 
      RowBox[{"Int", ",", 
       SubscriptBox["P", "3"]}], "]"}], 
     RowBox[{
      RowBox[{"mul", "[", 
       RowBox[{
        SubscriptBox["OR", "0"], ",", 
        RowBox[{"Diff", "[", 
         SubscriptBox["P", "2"], "]"}]}], "]"}], "+", 
      RowBox[{"mul", "[", 
       RowBox[{
        SubscriptBox["OR", "1"], ",", 
        SubscriptBox["P", "2"]}], "]"}]}]},
    {
     RowBox[{"Prod", "[", 
      RowBox[{
       RowBox[{"S", "[", 
        RowBox[{"1", ",", "h"}], "]"}], ",", "Diff"}], "]"}], 
     RowBox[{"mul", "[", 
      RowBox[{
       SubscriptBox["OR", "0"], ",", 
       SubscriptBox["P", "4"]}], "]"}]},
    {
     RowBox[{"Prod", "[", 
      RowBox[{
       RowBox[{"S", "[", 
        RowBox[{"1", ",", "h"}], "]"}], ",", "Int", ",", 
       SubscriptBox["P", "1"]}], "]"}], 
     RowBox[{
      RowBox[{"mul", "[", 
       RowBox[{
        SubscriptBox["OR", "0"], ",", 
        RowBox[{"Diff", "[", 
         SubscriptBox["P", "0"], "]"}]}], "]"}], "+", 
      RowBox[{"mul", "[", 
       RowBox[{
        SubscriptBox["OR", "1"], ",", 
        SubscriptBox["P", "0"]}], "]"}]}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.735540631160189*^9, 3.735540693248298*^9, 3.7374486150535192`*^9, 
   3.737448681751334*^9, 3.737448787694394*^9, 3.737448921425043*^9, 
   3.737693555983209*^9, 3.737693636091791*^9, 3.737693674589993*^9, 
   3.737693704816722*^9, 3.7376939009679413`*^9, 3.737694027722191*^9, 
   3.737694166311118*^9, 3.7376943052620654`*^9, 3.737697987421673*^9, 
   3.7376981914343414`*^9, 3.7376982431613007`*^9, 3.7376983005715837`*^9, 
   3.737698349540385*^9, 3.7376985218872423`*^9, 3.7376986395679736`*^9, 
   3.7376987175274324`*^9, 3.737698750660328*^9, 3.737698810285738*^9, 
   3.737698850161019*^9, 3.7376989815655346`*^9, 3.7376991195154247`*^9, 
   3.7376992238603935`*^9, 3.7376993452853384`*^9, 3.7376994635311017`*^9, 
   3.737699584386014*^9, 3.7377000564200125`*^9, 3.737700322403226*^9, 
   3.7377003835277224`*^9, 3.737700420582842*^9, 3.7377005317742014`*^9, 
   3.7377008013896227`*^9, 3.7377013408234763`*^9, 3.737701391992403*^9, 
   3.7377015292872562`*^9, 3.7377024956295276`*^9, 3.7377029441191797`*^9, 
   3.7377064860562677`*^9, 3.737706754159603*^9, 3.737706860465683*^9, 
   3.7377078932047524`*^9, {3.737708253872381*^9, 3.737708281308951*^9}, 
   3.737708428978397*^9, 3.737708500352479*^9, 3.73770881838867*^9, 
   3.7377095941800423`*^9, 3.737709681319027*^9, {3.7377099019936485`*^9, 
   3.7377099135803113`*^9}, 3.7377100824089675`*^9, 3.737710165820739*^9, {
   3.7377288471673746`*^9, 3.737728868618602*^9}, 3.737728920661578*^9, 
   3.7377290152119865`*^9, 3.7377296570316963`*^9, 3.737986743277181*^9, 
   3.7379868897475586`*^9, 3.737986930737903*^9, {3.737987002139987*^9, 
   3.7379870260043526`*^9}, 3.7379870592352533`*^9, 3.737987191112796*^9, 
   3.737987293437649*^9, 3.737987482439459*^9, {3.7379876930145035`*^9, 
   3.7379877162528324`*^9}, 3.7379880386082697`*^9, 3.7379881628673773`*^9, 
   3.737988213641281*^9, 3.7379903833023787`*^9, 3.737990422118599*^9, 
   3.7379906046750402`*^9, 3.737990651715731*^9, 3.738908882885988*^9, 
   3.7389090726888447`*^9, 3.7389091637710543`*^9, 3.7389093399641314`*^9, 
   3.7389095640979514`*^9, 3.73890968400581*^9, 3.738909802966614*^9, 
   3.7389098853923283`*^9, 3.7389101603170533`*^9, 3.7395311348853135`*^9, 
   3.739531199938034*^9, 3.7395323708080044`*^9, 3.7395362377152133`*^9, 
   3.739600248815195*^9, 3.7396003837149115`*^9, 3.7397163200051727`*^9, 
   3.7397163803736253`*^9, 3.7397165991321373`*^9, 3.739716653039221*^9, 
   3.739716684579025*^9, 3.7397168564958577`*^9, 3.7397169999380627`*^9, 
   3.739717139830064*^9, 3.7397171827505183`*^9, 3.739722744726277*^9, 
   3.7397229165301037`*^9, 3.739723119641721*^9, 3.739723187660611*^9, 
   3.7397236744274526`*^9, 3.7397237696598997`*^9, 3.739723799684617*^9, 
   3.73972383820482*^9, 3.7397238683335433`*^9, {3.7397239051386485`*^9, 
   3.7397239347623425`*^9}, {3.7397239885524197`*^9, 3.739724016672028*^9}, {
   3.7397240533811274`*^9, 3.739724079206605*^9}, 3.739724157662092*^9, 
   3.7397241902669573`*^9, 3.739724280592123*^9, 3.7397632428489375`*^9, 
   3.7397633601706476`*^9, 3.7397635475053625`*^9, 3.7397637635377192`*^9, 
   3.7397638098853703`*^9, 3.739768672658742*^9, 3.739768999552439*^9, 
   3.7397697203146644`*^9, 3.7397697791490297`*^9, 3.739770094328057*^9, 
   3.7397701700093856`*^9, 3.7397705935836124`*^9, 3.7397735731372333`*^9, 
   3.739774866391203*^9, 3.739774911546786*^9, 3.7397751793921056`*^9, 
   3.7397838455378456`*^9, 3.739783900806007*^9, 3.7397876087590895`*^9, 
   3.7397999767208858`*^9, 3.73980040636546*^9, 3.73980087841346*^9, 
   3.7398518344359303`*^9, 3.739852202423978*^9, 3.739870101394621*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{"Q1", "  ", ":=", 
  RowBox[{"Prod", "[", 
   SubscriptBox["Q", "0"], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"RR1", ":=", 
  RowBox[{
   RowBox[{"Prod", "[", 
    RowBox[{
     SubscriptBox["ORR", "0"], ",", "Diff"}], "]"}], "+", 
   RowBox[{"Prod", "[", 
    SubscriptBox["ORR", "1"], "]"}], "+", 
   RowBox[{"Prod", "[", 
    RowBox[{
     SubscriptBox["ORR", "2"], ",", "\[Delta]"}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"RHS", ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{"Q1", ",", "RR1"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.737448412324924*^9, 3.73744844267266*^9}, {
  3.7374486535367203`*^9, 3.7374486594160566`*^9}, {3.737448764641075*^9, 
  3.7374487661521616`*^9}, {3.7374488472488003`*^9, 3.737448871776203*^9}, {
  3.737986706131057*^9, 3.737986713999507*^9}, {3.737990326964156*^9, 
  3.7379903599400425`*^9}, {3.7392094067435417`*^9, 3.739209412117359*^9}, {
  3.7397875947882905`*^9, 3.7397875952283154`*^9}, {3.7398700659735947`*^9, 
  3.7398700706388617`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"RightSide", "=", 
     RowBox[{"ApplyRules", "[", 
      RowBox[{"RHS", ",", "RedSys"}], "]"}]}], ")"}], "//", "Coefficients"}], 
  "//", "TableForm"}]], "Input",
 CellChangeTimes->{{3.722080002246379*^9, 3.7220800046741457`*^9}, {
  3.722590363304584*^9, 3.722590363553258*^9}, {3.726222482418234*^9, 
  3.7262225108102837`*^9}, {3.726222579013603*^9, 3.7262226220852795`*^9}, {
  3.726222658043342*^9, 3.726222674922572*^9}, {3.7262261990106764`*^9, 
  3.72622620696669*^9}, {3.7262303495059905`*^9, 3.726230349708791*^9}, {
  3.7374484404325314`*^9, 3.737448475920562*^9}, {3.7379866576632843`*^9, 
  3.737986687064966*^9}, {3.7379869853240256`*^9, 3.737986987343141*^9}, {
  3.737987698363809*^9, 3.737987700781947*^9}, {3.737990364848323*^9, 
  3.7379903675824795`*^9}, {3.739526655174061*^9, 3.7395266565811577`*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{"Prod", "[", "]"}], 
     RowBox[{"mul", "[", 
      RowBox[{
       SubscriptBox["Q", "0"], ",", 
       SubscriptBox["ORR", "1"]}], "]"}]},
    {
     RowBox[{"Prod", "[", "Diff", "]"}], 
     RowBox[{"mul", "[", 
      RowBox[{
       SubscriptBox["Q", "0"], ",", 
       SubscriptBox["ORR", "0"]}], "]"}]},
    {
     RowBox[{"Prod", "[", 
      RowBox[{"S", "[", 
       RowBox[{"1", ",", "h"}], "]"}], "]"}], 
     RowBox[{"mul", "[", 
      RowBox[{
       SubscriptBox["Q", "0"], ",", 
       SubscriptBox["ORR", "2"]}], "]"}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.735540631175789*^9, 3.735540693248298*^9, 3.737448615337536*^9, 
   3.7374486817993374`*^9, 3.7374487878474026`*^9, 3.737448921456045*^9, 
   3.7376935560072107`*^9, 3.7376936361147923`*^9, 3.737693674631995*^9, 
   3.7376937048417234`*^9, 3.7376939009919424`*^9, 3.7376940277701936`*^9, 
   3.7376941663351192`*^9, 3.7376943052850666`*^9, 3.737697987457675*^9, 
   3.737698191547348*^9, 3.7376982432533054`*^9, 3.7376983006855907`*^9, 
   3.73769834963239*^9, 3.7376985219752474`*^9, 3.7376986396019754`*^9, 
   3.7376987175604343`*^9, 3.7376987507513328`*^9, 3.737698810401745*^9, 
   3.7376988502510242`*^9, 3.73769898165954*^9, 3.737699119549427*^9, 
   3.7376992239533987`*^9, 3.7376993454073453`*^9, 3.737699463566104*^9, 
   3.737699584422016*^9, 3.7377000564550147`*^9, 3.737700322439228*^9, 
   3.737700383562724*^9, 3.737700420615844*^9, 3.737700531873207*^9, 
   3.737700801425625*^9, 3.737701340857478*^9, 3.737701392085408*^9, 
   3.737701529322258*^9, 3.73770249566753*^9, 3.737702944155182*^9, 
   3.7377064860832696`*^9, 3.737706754185604*^9, 3.7377068604906845`*^9, 
   3.7377078932327538`*^9, {3.737708253895383*^9, 3.737708281331952*^9}, 
   3.7377084290023985`*^9, 3.7377085003764806`*^9, 3.7377088184536734`*^9, 
   3.737709594253047*^9, 3.7377099136193137`*^9, 3.7377100824429693`*^9, 
   3.7377101658557405`*^9, {3.7377288472263784`*^9, 3.737728868664604*^9}, 
   3.7377289206865797`*^9, 3.7377290152329874`*^9, 3.7377296570536976`*^9, 
   3.7379867433221836`*^9, 3.737986889781561*^9, 3.737986930771905*^9, 
   3.737986988363199*^9, 3.737987026053355*^9, 3.7379870592732553`*^9, 
   3.737987191153798*^9, 3.73798729345665*^9, 3.737987482477461*^9, {
   3.737987701676998*^9, 3.7379877162918344`*^9}, 3.7379880386492724`*^9, 
   3.73798816291838*^9, 3.7379882136962843`*^9, 3.73799038332738*^9, 
   3.7379904221416*^9, 3.7379906046960416`*^9, 3.7379906517367325`*^9, 
   3.7389088829059896`*^9, 3.7389090727068453`*^9, 3.7389091637900553`*^9, 
   3.738909339983133*^9, 3.7389095641179523`*^9, 3.738909684023811*^9, 
   3.738909802985615*^9, 3.7389098854113293`*^9, 3.7389101603360543`*^9, 
   3.739531134937317*^9, 3.739531199964036*^9, 3.7395323708320055`*^9, 
   3.739536237751216*^9, 3.7396002489022007`*^9, 3.7396003837339125`*^9, 
   3.739716320035174*^9, 3.739716380402627*^9, 3.7397165991681395`*^9, 
   3.739716653076223*^9, 3.739716684617027*^9, 3.7397168565318604`*^9, 
   3.7397169999750643`*^9, 3.7397171398670654`*^9, 3.739717182787521*^9, 
   3.7397227447592783`*^9, 3.7397229165611053`*^9, 3.739723119677723*^9, 
   3.7397231876976132`*^9, 3.7397236744614544`*^9, 3.7397237696929016`*^9, 
   3.7397237997166185`*^9, 3.739723838255823*^9, 3.7397238683685455`*^9, {
   3.73972390516965*^9, 3.739723934795345*^9}, {3.7397239885864215`*^9, 
   3.7397240167070303`*^9}, {3.7397240534151297`*^9, 3.739724079239607*^9}, 
   3.739724157697094*^9, 3.739724190298959*^9, 3.739724280628125*^9, 
   3.739763242875939*^9, 3.73976336020565*^9, 3.739763547542365*^9, 
   3.739763763622724*^9, 3.7397638099123716`*^9, 3.739768672689744*^9, 
   3.739768999582441*^9, 3.7397697203446665`*^9, 3.739769779185032*^9, 
   3.739770094365059*^9, 3.7397701700463877`*^9, 3.7397705936196146`*^9, 
   3.7397735731652346`*^9, 3.739774866442206*^9, 3.739774911571787*^9, 
   3.7397751794191074`*^9, 3.739783845560847*^9, 3.739783900830008*^9, 
   3.739787608799092*^9, 3.7397999768518934`*^9, 3.739800406419463*^9, 
   3.7398008784614625`*^9, 3.739851834496934*^9, 3.739852202581987*^9, 
   3.7398701014216223`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["2) Extracting conditions by coefficient comparison.", \
"Subsection"]], "Subsection",
 CellChangeTimes->{{3.7262426694598007`*^9, 3.7262427264935007`*^9}, {
   3.7262885758614016`*^9, 3.7262886080754585`*^9}, 3.7374556774654055`*^9}],

Cell[BoxData[
 RowBox[{"BlockStructure", ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     SubscriptBox["OR", "0"], "\[Rule]", 
     RowBox[{"(", "\[NoBreak]", GridBox[{
        {"1", "0"}
       }], "\[NoBreak]", ")"}]}], ",", 
    RowBox[{
     SubscriptBox["OR", "1"], "\[Rule]", 
     RowBox[{"(", "\[NoBreak]", GridBox[{
        {
         RowBox[{"-", "EE"}], 
         RowBox[{"-", "FF"}]}
       }], "\[NoBreak]", ")"}]}], ",", 
    RowBox[{
     SubscriptBox["ORR", "0"], "\[Rule]", " ", 
     RowBox[{"(", "\[NoBreak]", GridBox[{
        {"1", "0"}
       }], "\[NoBreak]", ")"}]}], ",", 
    RowBox[{
     SubscriptBox["ORR", "1"], "\[Rule]", " ", 
     RowBox[{"(", "\[NoBreak]", GridBox[{
        {
         RowBox[{"-", "A"}], 
         RowBox[{"-", 
          SubscriptBox["B", "0"]}]}
       }], "\[NoBreak]", ")"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{
     SubscriptBox["ORR", "2"], "\[Rule]", " ", 
     RowBox[{"(", "\[NoBreak]", GridBox[{
        {"0", 
         RowBox[{"-", 
          SubscriptBox["B", "1"]}]}
       }], "\[NoBreak]", ")"}]}], ",", 
    RowBox[{
     SubscriptBox["P", "0"], "\[Rule]", " ", 
     RowBox[{"(", "\[NoBreak]", GridBox[{
        {
         SubscriptBox["a", "0"]},
        {"0"}
       }], "\[NoBreak]", ")"}]}], ",", 
    RowBox[{
     SubscriptBox["P", "1"], "\[Rule]", " ", 
     RowBox[{"(", "\[NoBreak]", GridBox[{
        {"0", 
         SubscriptBox["a", "1"]}
       }], "\[NoBreak]", ")"}]}], ",", 
    RowBox[{
     SubscriptBox["P", "2"], "\[Rule]", 
     RowBox[{"(", "\[NoBreak]", GridBox[{
        {
         SubscriptBox["a", "2"]},
        {"0"}
       }], "\[NoBreak]", ")"}]}], ",", 
    RowBox[{
     SubscriptBox["P", "3"], "\[Rule]", " ", 
     RowBox[{"(", GridBox[{
        {"0", 
         SubscriptBox["a", "3"]}
       }], ")"}]}], ",", 
    RowBox[{
     SubscriptBox["P", "4"], "\[Rule]", " ", 
     RowBox[{"(", "\[NoBreak]", GridBox[{
        {"0", 
         SubscriptBox["a", "4"]},
        {"0", "0"}
       }], "\[NoBreak]", ")"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{
     SubscriptBox["P", "5"], "\[Rule]", 
     RowBox[{"(", "\[NoBreak]", GridBox[{
        {
         SubscriptBox["P", "11"], 
         SubscriptBox["a", "5"]},
        {"0", 
         SubscriptBox["P", "22"]}
       }], "\[NoBreak]", ")"}]}], ",", 
    RowBox[{
     SubscriptBox["Q", "0"], "\[Rule]", " ", 
     RowBox[{"{", 
      RowBox[{"{", 
       SubscriptBox["Q", "0"], "}"}], "}"}]}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.726222721629054*^9, 3.7262227219566545`*^9}, 
   3.7262228176472225`*^9, 3.7262229055065765`*^9, {3.726222936176231*^9, 
   3.7262229462070484`*^9}, {3.7262229793103065`*^9, 
   3.7262230780896797`*^9}, {3.7262231284465685`*^9, 3.726223173811448*^9}, {
   3.726223312552092*^9, 3.726223318651703*^9}, {3.726224519282612*^9, 
   3.7262245253666224`*^9}, {3.7262252208002443`*^9, 3.726225228257057*^9}, {
   3.726232377407713*^9, 3.726232475875086*^9}, {3.7262325059519386`*^9, 
   3.726232561628436*^9}, {3.726239892888918*^9, 3.7262399927602935`*^9}, 
   3.726289226663345*^9, {3.7262893291711245`*^9, 3.726289332790331*^9}, {
   3.7353661904738417`*^9, 3.7353662053094673`*^9}, {3.7353663059728446`*^9, 
   3.7353663134452577`*^9}, {3.7353966402542534`*^9, 3.735396650394272*^9}, {
   3.7377302542918577`*^9, 3.7377302565039845`*^9}, {3.739527078851583*^9, 
   3.739527082305708*^9}, {3.7395332766358495`*^9, 3.739533330728943*^9}, {
   3.7395333719302998`*^9, 3.7395333754054985`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Coefficients", "[", 
      RowBox[{"LeftSide", "-", "RightSide"}], "]"}], "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "2"}], "]"}], "]"}], "/.", "BlockStructure"}], " ", 
   "//", "TableForm"}]}]], "Input",
 CellChangeTimes->{{3.7395324407660055`*^9, 3.7395324810223083`*^9}, {
  3.7395331308225093`*^9, 3.739533237116589*^9}}],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {GridBox[{
       {
        RowBox[{
         RowBox[{"Diff", "[", 
          SubscriptBox["P", "11"], "]"}], "-", 
         RowBox[{"mul", "[", 
          RowBox[{"EE", ",", 
           SubscriptBox["P", "11"]}], "]"}], "+", 
         RowBox[{"mul", "[", 
          RowBox[{
           SubscriptBox["Q", "0"], ",", "A"}], "]"}]}]},
       {
        RowBox[{
         RowBox[{"Diff", "[", 
          SubscriptBox["a", "5"], "]"}], "-", 
         RowBox[{"mul", "[", 
          RowBox[{"EE", ",", 
           SubscriptBox["a", "5"]}], "]"}], "-", 
         RowBox[{"mul", "[", 
          RowBox[{"FF", ",", 
           SubscriptBox["P", "22"]}], "]"}], "+", 
         RowBox[{"mul", "[", 
          RowBox[{
           SubscriptBox["a", "2"], ",", 
           SubscriptBox["a", "3"]}], "]"}], "+", 
         RowBox[{"mul", "[", 
          RowBox[{
           SubscriptBox["Q", "0"], ",", 
           SubscriptBox["B", "0"]}], "]"}]}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {GridBox[{
       {
        RowBox[{
         SubscriptBox["P", "11"], "-", 
         SubscriptBox["Q", "0"]}]},
       {
        SubscriptBox["a", "5"]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {GridBox[{
       {"0"},
       {
        RowBox[{
         RowBox[{"Diff", "[", 
          SubscriptBox["a", "4"], "]"}], "-", 
         RowBox[{"mul", "[", 
          RowBox[{"EE", ",", 
           SubscriptBox["a", "4"]}], "]"}], "+", 
         RowBox[{"mul", "[", 
          RowBox[{
           SubscriptBox["a", "0"], ",", 
           RowBox[{
            RowBox[{"S", "[", 
             RowBox[{"1", ",", "h"}], "]"}], "[", 
            SubscriptBox["a", "1"], "]"}]}], "]"}], "+", 
         RowBox[{"mul", "[", 
          RowBox[{
           SubscriptBox["Q", "0"], ",", 
           SubscriptBox["B", "1"]}], "]"}]}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"Diff", "[", 
          SubscriptBox["a", "2"], "]"}], "-", 
         RowBox[{"mul", "[", 
          RowBox[{"EE", ",", 
           SubscriptBox["a", "2"]}], "]"}]}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {GridBox[{
       {"0"},
       {
        SubscriptBox["a", "4"]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"Diff", "[", 
          SubscriptBox["a", "0"], "]"}], "-", 
         RowBox[{"mul", "[", 
          RowBox[{"EE", ",", 
           SubscriptBox["a", "0"]}], "]"}]}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  TableForm[{{{$CellContext`Diff[
        Subscript[$CellContext`P, 11]] - $CellContext`mul[$CellContext`EE, 
       Subscript[$CellContext`P, 11]] + $CellContext`mul[
        Subscript[$CellContext`Q, 0], $CellContext`A], $CellContext`Diff[
        Subscript[$CellContext`a, 5]] - $CellContext`mul[$CellContext`EE, 
       Subscript[$CellContext`a, 5]] - $CellContext`mul[$CellContext`FF, 
       Subscript[$CellContext`P, 22]] + $CellContext`mul[
        Subscript[$CellContext`a, 2], 
        Subscript[$CellContext`a, 3]] + $CellContext`mul[
        Subscript[$CellContext`Q, 0], 
        Subscript[$CellContext`B, 0]]}}, {{
     Subscript[$CellContext`P, 11] - Subscript[$CellContext`Q, 0], 
      Subscript[$CellContext`a, 5]}}, {{0, $CellContext`Diff[
        Subscript[$CellContext`a, 4]] - $CellContext`mul[$CellContext`EE, 
       Subscript[$CellContext`a, 4]] + $CellContext`mul[
        Subscript[$CellContext`a, 0], 
        $CellContext`S[1, $CellContext`h][
         Subscript[$CellContext`a, 1]]] + $CellContext`mul[
        Subscript[$CellContext`Q, 0], 
        Subscript[$CellContext`B, 1]]}}, {{$CellContext`Diff[
        Subscript[$CellContext`a, 2]] - $CellContext`mul[$CellContext`EE, 
       Subscript[$CellContext`a, 2]]}}, {{0, 
      Subscript[$CellContext`a, 4]}}, {{$CellContext`Diff[
        Subscript[$CellContext`a, 0]] - $CellContext`mul[$CellContext`EE, 
       Subscript[$CellContext`a, 0]]}}}]]], "Output",
 CellChangeTimes->{
  3.739533242047871*^9, 3.7395336280019464`*^9, 3.7395362378252196`*^9, 
   3.739600248968204*^9, 3.7396003837819147`*^9, 3.739716320104178*^9, 
   3.739716380471631*^9, 3.739716599243144*^9, 3.739716653151227*^9, 
   3.739716684692031*^9, 3.739716856604864*^9, 3.7397170000570693`*^9, 
   3.73971713994307*^9, 3.739717182867525*^9, 3.7397227448422832`*^9, 
   3.7397229166361094`*^9, 3.7397231197617273`*^9, 3.7397231877726173`*^9, 
   3.739723674540459*^9, 3.739723769764906*^9, 3.7397237997906227`*^9, 
   3.739723838343828*^9, 3.7397238684395494`*^9, {3.7397239052436543`*^9, 
   3.7397239348763494`*^9}, {3.7397239886594257`*^9, 3.739724016789035*^9}, {
   3.7397240534911337`*^9, 3.7397240793146105`*^9}, 3.739724157771098*^9, 
   3.7397241903749633`*^9, 3.73972428070813*^9, 3.739763242964944*^9, 
   3.7397633602816544`*^9, 3.7397635476193695`*^9, 3.739763763693728*^9, 
   3.7397638100663805`*^9, 3.739768672764748*^9, 3.739768999655445*^9, 
   3.739769720447672*^9, 3.739769779261036*^9, 3.739770094451064*^9, 
   3.739770170123392*^9, 3.739770593696619*^9, 3.73977357325524*^9, 
   3.739774866530211*^9, 3.739774911675793*^9, 3.739775179516113*^9, 
   3.73978384561085*^9, 3.7397839009030123`*^9, 3.7397876088620954`*^9, 
   3.7397999769548993`*^9, 3.7398004065254693`*^9, 3.7398008785524673`*^9, 
   3.7398518345999393`*^9, 3.7398522026789923`*^9, 3.73987010156063*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"equations", "=", 
  RowBox[{"DeleteCases", "[", 
   RowBox[{
    RowBox[{"Flatten", "[", "%", "]"}], ",", "0"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.739526848053853*^9, 3.739526866971662*^9}, {
  3.7395338723769236`*^9, 3.739533882482502*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"Diff", "[", 
     SubscriptBox["P", "11"], "]"}], "-", 
    RowBox[{"mul", "[", 
     RowBox[{"EE", ",", 
      SubscriptBox["P", "11"]}], "]"}], "+", 
    RowBox[{"mul", "[", 
     RowBox[{
      SubscriptBox["Q", "0"], ",", "A"}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"Diff", "[", 
     SubscriptBox["a", "5"], "]"}], "-", 
    RowBox[{"mul", "[", 
     RowBox[{"EE", ",", 
      SubscriptBox["a", "5"]}], "]"}], "-", 
    RowBox[{"mul", "[", 
     RowBox[{"FF", ",", 
      SubscriptBox["P", "22"]}], "]"}], "+", 
    RowBox[{"mul", "[", 
     RowBox[{
      SubscriptBox["a", "2"], ",", 
      SubscriptBox["a", "3"]}], "]"}], "+", 
    RowBox[{"mul", "[", 
     RowBox[{
      SubscriptBox["Q", "0"], ",", 
      SubscriptBox["B", "0"]}], "]"}]}], ",", 
   RowBox[{
    SubscriptBox["P", "11"], "-", 
    SubscriptBox["Q", "0"]}], ",", 
   SubscriptBox["a", "5"], ",", 
   RowBox[{
    RowBox[{"Diff", "[", 
     SubscriptBox["a", "4"], "]"}], "-", 
    RowBox[{"mul", "[", 
     RowBox[{"EE", ",", 
      SubscriptBox["a", "4"]}], "]"}], "+", 
    RowBox[{"mul", "[", 
     RowBox[{
      SubscriptBox["a", "0"], ",", 
      RowBox[{
       RowBox[{"S", "[", 
        RowBox[{"1", ",", "h"}], "]"}], "[", 
       SubscriptBox["a", "1"], "]"}]}], "]"}], "+", 
    RowBox[{"mul", "[", 
     RowBox[{
      SubscriptBox["Q", "0"], ",", 
      SubscriptBox["B", "1"]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"Diff", "[", 
     SubscriptBox["a", "2"], "]"}], "-", 
    RowBox[{"mul", "[", 
     RowBox[{"EE", ",", 
      SubscriptBox["a", "2"]}], "]"}]}], ",", 
   SubscriptBox["a", "4"], ",", 
   RowBox[{
    RowBox[{"Diff", "[", 
     SubscriptBox["a", "0"], "]"}], "-", 
    RowBox[{"mul", "[", 
     RowBox[{"EE", ",", 
      SubscriptBox["a", "0"]}], "]"}]}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.739526870631562*^9, 3.739531135790365*^9, 3.739531200494066*^9, 
   3.7395323715800486`*^9, 3.7395338480635333`*^9, 3.7395338834025545`*^9, 
   3.739536237850221*^9, 3.7396002489842052`*^9, 3.7396003837959156`*^9, 
   3.739716320126179*^9, 3.739716380491632*^9, 3.7397165992701454`*^9, 
   3.739716653178229*^9, 3.7397166847170324`*^9, 3.7397168566298656`*^9, 
   3.7397170000820704`*^9, 3.7397171399690714`*^9, 3.739717182893527*^9, 
   3.739722744866285*^9, 3.739722916656111*^9, 3.739723119786729*^9, 
   3.739723187800619*^9, 3.73972367456546*^9, 3.739723769788907*^9, 
   3.739723799812624*^9, 3.73972383838383*^9, 3.739723868462551*^9, {
   3.7397239052676563`*^9, 3.739723934901351*^9}, {3.7397239886844273`*^9, 
   3.739724016812036*^9}, {3.7397240535151353`*^9, 3.7397240793396125`*^9}, 
   3.7397241577960997`*^9, 3.7397241903989644`*^9, 3.7397242807351313`*^9, 
   3.7397632429849453`*^9, 3.739763360306656*^9, 3.739763547644371*^9, 
   3.739763763711729*^9, 3.739763810084381*^9, 3.7397686727877493`*^9, 
   3.7397689996784463`*^9, 3.739769720468673*^9, 3.7397697792860374`*^9, 
   3.739770094477065*^9, 3.7397701701483936`*^9, 3.73977059372062*^9, 
   3.739773573275241*^9, 3.739774866550212*^9, 3.7397749116947947`*^9, 
   3.7397751795361137`*^9, 3.7397838456278505`*^9, 3.7397839009220133`*^9, 
   3.7397876088750963`*^9, 3.7397999769749002`*^9, 3.7398004065464706`*^9, 
   3.739800878570469*^9, 3.7398518346189404`*^9, 3.7398522026979933`*^9, 
   3.7398701015786314`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "3) Solving obtained system and finding ",
 Cell[BoxData[
  FormBox["P", TraditionalForm]],
  FormatType->"TraditionalForm"],
 "."
}], "Subsection",
 CellChangeTimes->{{3.7374497641282425`*^9, 3.737449809503838*^9}, 
   3.7374499450885935`*^9, 3.739774146489027*^9}],

Cell[TextData[{
 "For solving the obtained equations, we set ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["a", "4"], "=", 
    RowBox[{
     SubscriptBox["a", "5"], "=", "0"}]}], TraditionalForm]]],
 " and let ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["P", "11"], TraditionalForm]]],
 " be such that the following equation holds:\n  \n                           \
                               ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{"\[PartialD]", 
      SubscriptBox["P", "11"]}], "-", 
     RowBox[{"E", " ", 
      SubscriptBox["P", "11"]}]}], "=", 
    RowBox[{
     RowBox[{"-", 
      SubscriptBox["Q", "0"]}], "  ", 
     RowBox[{"A", "."}]}]}], TraditionalForm]]],
 " \n                                                          \nWe also set ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["Q", "0"], "=", 
    SubscriptBox["P", "11"]}], TraditionalForm]]],
 " and  let \[CapitalPhi] invertible such that\n                              \
                                    \n                                        \
                           ",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    RowBox[{
     RowBox[{"\[PartialD]", " ", "\[CapitalPhi]"}], " ", "=", " ", 
     RowBox[{"E", " ", 
      RowBox[{"\[CapitalPhi]", "."}]}]}]}], TraditionalForm]]],
 "\n                                                                   \nThen \
for arbitrary constants ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["c", "0"], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["c", "2"], TraditionalForm]]],
 " we assume that\n\n                                                      ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["a", "0"], "=", 
    RowBox[{"\[CapitalPhi]", " ", 
     SubscriptBox["c", "0"], " "}]}], TraditionalForm]]],
 "  and   ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["a", "2"], "=", 
    RowBox[{"\[CapitalPhi]", " ", 
     RowBox[{
      SubscriptBox["c", "2"], " ", "."}]}]}], TraditionalForm]]]
}], "Text",
 CellChangeTimes->{
  3.7262331694561048`*^9, {3.726235213705038*^9, 3.7262352648679647`*^9}, {
   3.7262392347685623`*^9, 3.7262392706798253`*^9}, {3.7262427795491943`*^9, 
   3.7262427795491943`*^9}, {3.7262435319229155`*^9, 
   3.7262435489581456`*^9}, {3.7262886514279346`*^9, 
   3.7262886571843443`*^9}, {3.726296227735664*^9, 3.726296234744504*^9}, {
   3.735540446455865*^9, 3.735540449856671*^9}, {3.735540658475837*^9, 
   3.735540659443039*^9}, 3.739525763454833*^9, {3.739528060276456*^9, 
   3.7395284838366823`*^9}, 3.739529408637578*^9, {3.7395340045474834`*^9, 
   3.739534138168126*^9}, {3.7395352301175823`*^9, 3.739535234539835*^9}, 
   3.7395360421080256`*^9, {3.7395360733898144`*^9, 3.7395361448229003`*^9}, {
   3.739536284118868*^9, 3.7395363735649834`*^9}, {3.7397736621213226`*^9, 
   3.7397736716598682`*^9}, {3.739773777326912*^9, 3.7397738017423086`*^9}, {
   3.739774237968259*^9, 3.7397742899352317`*^9}, {3.7397881888772707`*^9, 
   3.739788189580311*^9}, {3.7397882421193156`*^9, 3.7397882489517064`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Diff", "[", 
   RowBox[{
    SubscriptBox["c", "0"], "|", 
    SubscriptBox["c", "2"]}], "]"}], ":=", "0"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Diff", "[", "\[CapitalPhi]", "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"EE", ",", "\[CapitalPhi]"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.726233675014716*^9, 3.726233743697644*^9}, {
   3.726233808026324*^9, 3.726233985282462*^9}, {3.7262340434987917`*^9, 
   3.7262340648660145`*^9}, {3.7262341130257688`*^9, 
   3.7262341523380175`*^9}, {3.726234194181411*^9, 3.726234205554061*^9}, {
   3.726234236588836*^9, 3.726234274506005*^9}, 3.7262344500270443`*^9, 
   3.7262344888022623`*^9, {3.7262346596440334`*^9, 3.726234694180009*^9}, 
   3.726234811706731*^9, {3.7262348423144817`*^9, 3.7262348684349756`*^9}, {
   3.7262349071781917`*^9, 3.726234919297885*^9}, {3.726234954026871*^9, 
   3.726234995859264*^9}, {3.7262351074049587`*^9, 3.7262351463071833`*^9}, {
   3.726235823162897*^9, 3.72623582635408*^9}, {3.7262375436963916`*^9, 
   3.7262376222521296`*^9}, {3.7262376814230337`*^9, 3.726237738846734*^9}, {
   3.726238788389378*^9, 3.72623878932538*^9}, {3.726239296747471*^9, 
   3.7262393281347265`*^9}, {3.726240180413023*^9, 3.726240233999117*^9}, {
   3.726240312701256*^9, 3.7262403336832924`*^9}, {3.726240456829909*^9, 
   3.726240503801591*^9}, {3.7355404564554825`*^9, 3.735540464208696*^9}, {
   3.735540496703553*^9, 3.7355404990903573`*^9}, {3.73554054053963*^9, 
   3.7355405447828374`*^9}, 3.739600235747448*^9, {3.7397161617931232`*^9, 
   3.7397161793161254`*^9}, {3.7397162206164875`*^9, 
   3.7397162381684914`*^9}, {3.7397165236698213`*^9, 3.7397165389526954`*^9}, 
   3.739716576878865*^9, {3.739716635119196*^9, 3.739716665001905*^9}, {
   3.739716699224862*^9, 3.739716712170603*^9}, {3.7397167541760054`*^9, 
   3.739716759867331*^9}, {3.739716825466083*^9, 3.739716839011858*^9}, {
   3.739763178119235*^9, 3.7397631805583744`*^9}, 3.739763509847209*^9, {
   3.7397736409831133`*^9, 3.7397736418711643`*^9}}],

Cell["This solves six of the above equations.", "Text",
 CellChangeTimes->{{3.739774317393802*^9, 3.7397744179265523`*^9}, {
  3.7397744743627806`*^9, 3.7397745026063957`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Solution1", ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     SubscriptBox["a", "4"], "\[Rule]", " ", "0"}], ",", 
    RowBox[{
     SubscriptBox["a", "5"], "\[Rule]", "  ", "0"}], ",", 
    RowBox[{
     SubscriptBox["Q", "0"], "\[Rule]", " ", 
     SubscriptBox["P", "11"]}], ",", 
    RowBox[{
     RowBox[{"Diff", "[", 
      SubscriptBox["P", "11"], "]"}], "\[Rule]", " ", 
     RowBox[{
      RowBox[{"mul", "[", 
       RowBox[{"EE", ",", 
        SubscriptBox["P", "11"]}], "]"}], "-", 
      RowBox[{"mul", "[", 
       RowBox[{
        SubscriptBox["P", "11"], ",", "A"}], "]"}]}]}], ",", 
    RowBox[{
     SubscriptBox["a", "0"], "\[Rule]", " ", 
     RowBox[{"mul", "[", 
      RowBox[{"\[CapitalPhi]", ",", 
       SubscriptBox["c", "0"]}], "]"}]}], ",", 
    RowBox[{
     SubscriptBox["a", "2"], "\[Rule]", " ", 
     RowBox[{"mul", "[", 
      RowBox[{"\[CapitalPhi]", ",", 
       SubscriptBox["c", "2"]}], "]"}]}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{"RemainingEquations", "=", 
  RowBox[{"DeleteCases", "[", 
   RowBox[{
    RowBox[{"equations", "/.", "Solution1"}], ",", "0"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.7397686018076897`*^9, 3.7397686059359255`*^9}, 
   3.739768683383355*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     RowBox[{"mul", "[", 
      RowBox[{"FF", ",", 
       SubscriptBox["P", "22"]}], "]"}]}], "+", 
    RowBox[{"mul", "[", 
     RowBox[{
      SubscriptBox["P", "11"], ",", 
      SubscriptBox["B", "0"]}], "]"}], "+", 
    RowBox[{"mul", "[", 
     RowBox[{"\[CapitalPhi]", ",", 
      SubscriptBox["c", "2"], ",", 
      SubscriptBox["a", "3"]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"mul", "[", 
     RowBox[{
      SubscriptBox["P", "11"], ",", 
      SubscriptBox["B", "1"]}], "]"}], "+", 
    RowBox[{"mul", "[", 
     RowBox[{"\[CapitalPhi]", ",", 
      SubscriptBox["c", "0"], ",", 
      RowBox[{
       RowBox[{"S", "[", 
        RowBox[{"1", ",", "h"}], "]"}], "[", 
       SubscriptBox["a", "1"], "]"}]}], "]"}]}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.739763547682373*^9, 3.7397637637387304`*^9, 3.739763810111383*^9, {
   3.739768672888755*^9, 3.739768684701431*^9}, 3.7397687219315605`*^9, 
   3.73976899974045*^9, 3.739769720500675*^9, 3.7397697793240395`*^9, 
   3.7397700945160675`*^9, 3.739770170189396*^9, 3.7397705937576227`*^9, 
   3.739773573327244*^9, 3.739774866596215*^9, 3.7397749117507973`*^9, 
   3.739775179594117*^9, 3.739783845649852*^9, 3.7397839009750166`*^9, 
   3.7397876088970976`*^9, 3.739799977030904*^9, 3.7398004066004734`*^9, 
   3.7398008786214714`*^9, 3.739851834679944*^9, 3.739852202754997*^9, 
   3.7398701016076326`*^9}]
}, Open  ]],

Cell[TextData[{
 "The remaining equations \n\n                        ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox["a", "0"], "\[Delta]", " ", 
      SubscriptBox["a", "1"]}], "+", 
     RowBox[{"\[PartialD]", 
      SubscriptBox["a", "4"]}], "-", 
     RowBox[{"E", " ", 
      SubscriptBox["a", "4"]}]}], "=", 
    RowBox[{
     RowBox[{"-", 
      SubscriptBox["Q", "0"]}], 
     SubscriptBox["B", "1"], " "}]}], TraditionalForm]]],
 "   and    ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{"\[PartialD]", 
      SubscriptBox["a", "5"]}], "+", 
     RowBox[{
      SubscriptBox["a", "2"], 
      SubscriptBox["a", "3"]}], "-", 
     RowBox[{"E", " ", 
      SubscriptBox["a", "5"]}], "-", 
     RowBox[{"F", " ", 
      SubscriptBox["P", "22"]}]}], "=", 
    RowBox[{
     RowBox[{"-", 
      SubscriptBox["Q", "0"]}], 
     SubscriptBox["B", "0"], " "}]}], TraditionalForm]]],
 "\n\ncan be written respectively as\n\n                                   ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox["c", 
      RowBox[{"0", " "}]], 
     SubscriptBox["a", "1"]}], "=", 
    RowBox[{
     RowBox[{"-", " ", 
      SuperscriptBox["\[Delta]", 
       RowBox[{"-", "1"}]]}], "\[CapitalPhi]", " ", 
     SubscriptBox["P", "11"], 
     SubscriptBox["B", "1"], "  "}]}], TraditionalForm]]],
 "  and   ",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    RowBox[{
     RowBox[{
      SubscriptBox["c", 
       RowBox[{"2", " "}]], 
      SubscriptBox["a", "3"]}], "=", 
     RowBox[{
      RowBox[{"-", 
       SuperscriptBox["\[CapitalPhi]", 
        RowBox[{"-", "1"}]]}], " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"F", " ", 
          SubscriptBox["P", "22"]}], "-", 
         RowBox[{
          SubscriptBox["P", "11"], 
          SubscriptBox["B", "0"]}]}], ")"}], "."}]}]}]}], TraditionalForm]]],
 "\n             \nWe assume that ",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    RowBox[{
     SubscriptBox["c", "0"], ",", " ", 
     SubscriptBox["c", "2"], ",", " ", 
     SubscriptBox["a", "1"], ",", " ", 
     SubscriptBox["a", "3"], "  "}]}], TraditionalForm]]],
 "are such that they satisfy the above equations."
}], "Text",
 CellChangeTimes->{{3.7262315499883995`*^9, 3.7262315804240527`*^9}, {
   3.7262396894801607`*^9, 3.7262396894801607`*^9}, {3.7262405272952323`*^9, 
   3.7262405712717094`*^9}, {3.7262428032456355`*^9, 3.726242899248204*^9}, {
   3.726243507134472*^9, 3.726243522094898*^9}, {3.735369301458605*^9, 
   3.7353693067636137`*^9}, {3.73554055184965*^9, 3.735540567699278*^9}, 
   3.739525772583323*^9, {3.739528477347311*^9, 3.739528478827396*^9}, {
   3.739529442514516*^9, 3.7395295502836795`*^9}, {3.739535330765339*^9, 
   3.7395353377167363`*^9}, {3.7395357436939573`*^9, 3.739535930787658*^9}, {
   3.739536011805292*^9, 3.73953603048536*^9}, {3.739536454763628*^9, 
   3.7395367315904617`*^9}, {3.739600328201736*^9, 3.7396003394743805`*^9}, {
   3.7397233654517803`*^9, 3.739723387736055*^9}, 3.7397636163663015`*^9, {
   3.739763670237383*^9, 3.739763671685466*^9}, {3.739773421522561*^9, 
   3.7397734809149585`*^9}, {3.7397736858786817`*^9, 3.739773711214131*^9}, {
   3.7397745372383766`*^9, 3.739774570103256*^9}, {3.7397998820084686`*^9, 
   3.7397998840675864`*^9}, 3.739851111747595*^9, 3.7398511455995307`*^9}],

Cell[BoxData[
 RowBox[{"Solution2", ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"mul", "[", 
      RowBox[{"\[CapitalPhi]", ",", 
       SubscriptBox["c", "0"], ",", 
       RowBox[{
        RowBox[{"S", "[", 
         RowBox[{"1", ",", "h"}], "]"}], "[", 
        SubscriptBox["a", "1"], "]"}]}], "]"}], "\[Rule]", " ", 
     RowBox[{"-", 
      RowBox[{"mul", "[", 
       RowBox[{
        SubscriptBox["P", "11"], ",", 
        SubscriptBox["B", "1"]}], "]"}]}]}], ",", 
    RowBox[{
     RowBox[{"mul", "[", 
      RowBox[{"\[CapitalPhi]", ",", 
       SubscriptBox["c", "2"], ",", 
       SubscriptBox["a", "3"]}], "]"}], "\[Rule]", " ", 
     RowBox[{
      RowBox[{"mul", "[", 
       RowBox[{"FF", ",", 
        SubscriptBox["P", "22"]}], "]"}], "-", 
      RowBox[{"mul", "[", 
       RowBox[{
        SubscriptBox["P", "11"], ",", 
        SubscriptBox["B", "0"]}], "]"}]}]}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.739763189903909*^9, 3.739763210246073*^9}, {
  3.7397686124803*^9, 3.7397686153924665`*^9}, {3.7397737531035266`*^9, 
  3.739773754126585*^9}}],

Cell["\<\
After entering these assumptions, our package verifies the remaining \
equations are solved.\
\>", "Text",
 CellChangeTimes->{{3.739774719424797*^9, 3.7397747521826706`*^9}, {
  3.739774807990863*^9, 3.739774814534237*^9}, {3.7397876761569443`*^9, 
  3.7397876786200852`*^9}, {3.739869797214223*^9, 3.7398697978772607`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RemainingEquations", "/.", "Solution2"}]], "Input",
 CellChangeTimes->{{3.726235338150156*^9, 3.7262355144812417`*^9}, {
   3.726235556914669*^9, 3.7262356658819017`*^9}, {3.726235702627003*^9, 
   3.7262357033700457`*^9}, {3.726235769517829*^9, 3.726235771433939*^9}, {
   3.726237796164235*^9, 3.726237877955179*^9}, {3.726237913882042*^9, 
   3.7262379927401805`*^9}, {3.726238065826309*^9, 3.7262381970537395`*^9}, {
   3.726238300388321*^9, 3.726238418262128*^9}, {3.72623882362984*^9, 
   3.726238824347441*^9}, {3.726238854970295*^9, 3.726238890179557*^9}, {
   3.7262389865877266`*^9, 3.726239100233926*^9}, {3.726239161588834*^9, 
   3.726239175457258*^9}, {3.7262393682579966`*^9, 3.726239369802399*^9}, {
   3.72624027537039*^9, 3.726240276087991*^9}, {3.726240680690302*^9, 
   3.726240737193601*^9}, {3.7262408139301357`*^9, 3.72624081628574*^9}, {
   3.726240856705411*^9, 3.7262408927882743`*^9}, {3.7262409344091473`*^9, 
   3.7262410165900917`*^9}, {3.7262410510817523`*^9, 
   3.7262411147766647`*^9}, {3.7262411474119215`*^9, 
   3.7262412611613216`*^9}, {3.735540587963713*^9, 3.735540590038517*^9}, {
   3.739600361265627*^9, 3.7396003689690676`*^9}, 3.7397163584403706`*^9, 
   3.739763185917681*^9, 3.739763216806448*^9, 3.7397686305843353`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{
  3.7262355186404796`*^9, {3.726235620132285*^9, 3.7262356308658986`*^9}, 
   3.726235668401046*^9, 3.726235731001626*^9, 3.7262357727690153`*^9, 
   3.726235843572065*^9, 3.726237520623951*^9, 3.7262376507221794`*^9, 
   3.726237797568238*^9, 3.7262378793123817`*^9, {3.726237926471264*^9, 
   3.726237962195327*^9}, 3.7262379954077854`*^9, {3.726238090037552*^9, 
   3.72623812329681*^9}, {3.726238179893709*^9, 3.726238193855734*^9}, 
   3.7262384229109364`*^9, 3.726238825330243*^9, 3.7262388914587593`*^9, 
   3.7262389934673386`*^9, {3.7262390629342604`*^9, 3.7262390853358994`*^9}, 
   3.7262391779064627`*^9, 3.726239371736803*^9, 3.726239846042036*^9, {
   3.726240277335994*^9, 3.726240299332032*^9}, 3.726240391528194*^9, 
   3.726240481852353*^9, 3.7262407030139413`*^9, 3.726240738316803*^9, 
   3.7262408171281414`*^9, {3.726240876626646*^9, 3.726240894145477*^9}, 
   3.726240936717952*^9, {3.7262409939700522`*^9, 3.7262410532657566`*^9}, {
   3.7262410893486195`*^9, 3.7262410945590286`*^9}, 3.7262411694703608`*^9, {
   3.7262412018208175`*^9, 3.7262412625965242`*^9}, 3.726241342874265*^9, 
   3.726241418300398*^9, 3.726241448689251*^9, 3.726241506159752*^9, 
   3.7262418171742983`*^9, 3.726242353884446*^9, 3.7262438753483195`*^9, 
   3.726289058089449*^9, 3.72628911577835*^9, 3.7262893756748066`*^9, 
   3.726295613719821*^9, 3.7353630376598005`*^9, 3.735363130495264*^9, 
   3.7353650648030634`*^9, 3.7353652687460217`*^9, 3.7353654399421225`*^9, 
   3.7353656547514005`*^9, 3.7353657165169086`*^9, 3.7353658564460545`*^9, 
   3.7353663684372544`*^9, {3.735366487660164*^9, 3.7353665146482115`*^9}, 
   3.7353665909373455`*^9, 3.735366679521801*^9, 3.7353670746028957`*^9, 
   3.7353671372370057`*^9, 3.7353673863276434`*^9, 3.7353971360231247`*^9, 
   3.735496017789524*^9, 3.735540631253789*^9, 3.7355406933730984`*^9, 
   3.7374486160155745`*^9, 3.737448681936345*^9, 3.7374487879924107`*^9, 
   3.737448921589052*^9, 3.737693556190221*^9, 3.737693636386808*^9, 
   3.7376936748800097`*^9, 3.7376937050017323`*^9, 3.7376939012239556`*^9, 
   3.7376940280082073`*^9, 3.7376941665851336`*^9, 3.7376943054180746`*^9, 
   3.737697987599683*^9, 3.737698191699357*^9, 3.7376982433793125`*^9, 
   3.7376983008375993`*^9, 3.7376983497633977`*^9, 3.737698522100255*^9, 
   3.737698639800987*^9, 3.737698717724444*^9, 3.7376987508973413`*^9, 
   3.7376988105737543`*^9, 3.7376988503850317`*^9, 3.73769898183255*^9, 
   3.7376991197524385`*^9, 3.737699224115408*^9, 3.7376993455703545`*^9, 
   3.7376994637611146`*^9, 3.7376995846050262`*^9, 3.737700056615024*^9, 
   3.7377003226002374`*^9, 3.737700383695732*^9, 3.7377004207578516`*^9, 
   3.7377005320042143`*^9, 3.737700801639637*^9, 3.7377013410144873`*^9, 
   3.7377013922314167`*^9, 3.737701529460266*^9, 3.7377029444131966`*^9, 
   3.737706486297282*^9, 3.737706754429618*^9, 3.737706860710697*^9, 
   3.7377078934837685`*^9, {3.737708254045391*^9, 3.7377082814759603`*^9}, 
   3.7377084291614075`*^9, 3.7377085006244946`*^9, 3.737708818658685*^9, 
   3.737709594474059*^9, 3.7377099138303256`*^9, 3.737710082708985*^9, 
   3.737710166067753*^9, {3.7377288473813868`*^9, 3.7377288688856173`*^9}, 
   3.7377289209145927`*^9, 3.737729015451*^9, 3.73772965726071*^9, 
   3.737986743518195*^9, 3.737986889926569*^9, 3.737986931046921*^9, 
   3.7379870262813683`*^9, 3.737987059569272*^9, 3.737987191460816*^9, 
   3.737987293741666*^9, 3.737987482770478*^9, 3.737987716534848*^9, 
   3.737988038835283*^9, 3.737988163142393*^9, 3.737988213919297*^9, 
   3.7379903834723883`*^9, 3.7379904223406115`*^9, 3.7379906049200544`*^9, 
   3.7379906519577446`*^9, 3.738908883092*^9, 3.738909072836853*^9, 
   3.7389091639070616`*^9, 3.7389093401111403`*^9, 3.738909564319964*^9, 
   3.738909684152818*^9, 3.7389098031176224`*^9, 3.738909885542337*^9, 
   3.738910160474062*^9, 3.739531135924373*^9, 3.7395312005830717`*^9, 
   3.739532371723057*^9, 3.7395362379182253`*^9, 3.7396002490412083`*^9, 
   3.739600383851919*^9, 3.739716320215184*^9, 3.739716380544635*^9, 
   3.739716599497158*^9, 3.739716653392241*^9, 3.7397166847800364`*^9, 
   3.7397168567008696`*^9, 3.7397170001300735`*^9, 3.7397171400410757`*^9, 
   3.739717182971531*^9, 3.7397227449332886`*^9, 3.7397229167191143`*^9, 
   3.7397231198347316`*^9, 3.7397231878466215`*^9, 3.739723674624464*^9, 
   3.7397237698349094`*^9, 3.7397237998526263`*^9, 3.739723838456835*^9, 
   3.739723868502553*^9, {3.739723905307658*^9, 3.7397239349453535`*^9}, {
   3.7397239887274294`*^9, 3.73972401688304*^9}, {3.7397240535901394`*^9, 
   3.739724079382615*^9}, 3.7397241578431025`*^9, 3.739724190474969*^9, 
   3.7397242807831345`*^9, 3.7397632430449486`*^9, 3.7397633603606586`*^9, 
   3.739763547715375*^9, 3.739763763763732*^9, 3.7397638101353846`*^9, 
   3.7397686729217567`*^9, {3.7397687059046435`*^9, 3.739768721958562*^9}, 
   3.7397689997704515`*^9, 3.739769720529677*^9, 3.739769779358042*^9, 
   3.7397700945510693`*^9, 3.739770170225398*^9, 3.739770593793625*^9, 
   3.739773573375247*^9, 3.739774866618216*^9, 3.739774911774799*^9, 
   3.7397751796181183`*^9, 3.7397838456688533`*^9, 3.739783901001018*^9, 
   3.739787608993103*^9, 3.7397999770559053`*^9, 3.7398004066244745`*^9, 
   3.739800878645473*^9, 3.7398518347049456`*^9, 3.739852202778998*^9, 
   3.7398701016336346`*^9}]
}, Open  ]],

Cell[TextData[{
 "Considering these assumptions, the operator ",
 Cell[BoxData[
  FormBox["P", TraditionalForm]]],
 " can be written as \n\n          ",
 Cell[BoxData[
  FormBox[
   RowBox[{"P", " ", "=", " ", 
    RowBox[{
     RowBox[{
      RowBox[{"-", " ", 
       RowBox[{"(", GridBox[{
          {"\[CapitalPhi]"},
          {"0"}
         }], ")"}]}], " ", "\[CenterDot]", " ", "\[Delta]", " ", 
      "\[CenterDot]", " ", 
      RowBox[{"\[Integral]", 
       RowBox[{"\[CenterDot]", 
        RowBox[{"(", 
         RowBox[{GridBox[{
            {"0", 
             SuperscriptBox["\[Delta]", 
              RowBox[{"-", "1"}]]}
           }], "\[CapitalPhi]", " ", 
          SubscriptBox["P", "11"], 
          SubscriptBox["B", "1"]}], ")"}]}]}]}], "+", 
     RowBox[{
      RowBox[{"(", GridBox[{
         {"\[CapitalPhi]"},
         {"0"}
        }], ")"}], "\[CenterDot]", 
      RowBox[{"\[Integral]", 
       RowBox[{"\[CenterDot]", 
        RowBox[{"(", 
         RowBox[{GridBox[{
            {"0", 
             SuperscriptBox["\[CapitalPhi]", 
              RowBox[{"-", "1"}]]}
           }], 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"F", " ", 
             SubscriptBox["P", "22"]}], "-", 
            RowBox[{
             SubscriptBox["P", "11"], 
             SubscriptBox["B", "0"]}]}], ")"}]}], ")"}]}]}]}], "+", 
     RowBox[{"(", GridBox[{
        {
         SubscriptBox["P", "11"], "0"},
        {"0", 
         SubscriptBox["P", "22"]}
       }], ")"}]}]}], TraditionalForm]]],
 "."
}], "Text",
 CellChangeTimes->{{3.7262429494802923`*^9, 3.7262429831451516`*^9}, {
   3.7262434939056487`*^9, 3.726243497119254*^9}, {3.7262435577097607`*^9, 
   3.726243558255762*^9}, {3.739529573764023*^9, 3.7395296986401653`*^9}, {
   3.7395353439730945`*^9, 3.7395355927293224`*^9}, {3.7395356529417667`*^9, 
   3.7395357251478963`*^9}, {3.739536566069994*^9, 3.739536566069994*^9}, 
   3.7397638146006393`*^9, {3.73978831126027*^9, 3.739788313980426*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Solution", ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      SubscriptBox["P", "0"], "\[Rule]", 
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"\[CapitalPhi]"},
         {"0"}
        }], "\[NoBreak]", ")"}]}], ",", 
     RowBox[{
      SubscriptBox["P", "1"], "\[Rule]", " ", 
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", 
          RowBox[{"-", 
           RowBox[{"mul", "[", 
            RowBox[{
             RowBox[{"inv", "[", "\[Delta]", "]"}], "[", 
             RowBox[{"mul", "[", 
              RowBox[{
               RowBox[{"inv", "[", "\[CapitalPhi]", "]"}], ",", 
               SubscriptBox["P", "11"], ",", 
               SubscriptBox["B", "1"]}], "]"}], "]"}], "]"}]}]}
        }], "\[NoBreak]", ")"}]}], ",", 
     RowBox[{
      SubscriptBox["P", "2"], "\[Rule]", 
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"\[CapitalPhi]"},
         {"0"}
        }], "\[NoBreak]", ")"}]}], ",", 
     RowBox[{
      SubscriptBox["P", "3"], "\[Rule]", " ", 
      RowBox[{"(", GridBox[{
         {"0", 
          RowBox[{" ", 
           RowBox[{"mul", "[", 
            RowBox[{
             RowBox[{"inv", "[", "\[CapitalPhi]", "]"}], ",", 
             RowBox[{
              RowBox[{"mul", "[", 
               RowBox[{"FF", ",", 
                SubscriptBox["P", "22"]}], "]"}], "-", 
              RowBox[{"mul", "[", 
               RowBox[{
                SubscriptBox["P", "11"], ",", 
                SubscriptBox["B", "0"]}], "]"}]}]}], "]"}]}]}
        }], ")"}]}], ",", 
     RowBox[{
      SubscriptBox["P", "4"], "\[Rule]", " ", 
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", "0"},
         {"0", "0"}
        }], "\[NoBreak]", ")"}]}], ",", 
     RowBox[{
      SubscriptBox["P", "5"], "\[Rule]", 
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {
          SubscriptBox["P", "11"], "0"},
         {"0", 
          SubscriptBox["P", "22"]}
        }], "\[NoBreak]", ")"}]}], ",", 
     RowBox[{
      SubscriptBox["Q", "0"], "\[Rule]", " ", 
      RowBox[{"{", 
       RowBox[{"{", 
        SubscriptBox["P", "11"], "}"}], "}"}]}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"OP", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"Prod", "[", 
     RowBox[{
      SubscriptBox["P", "0"], ",", "\[Delta]", ",", "Int", ",", 
      SubscriptBox["P", "1"]}], "]"}], "+", 
    RowBox[{"Prod", "[", 
     RowBox[{
      SubscriptBox["P", "2"], ",", "Int", ",", 
      SubscriptBox["P", "3"]}], "]"}], "+", 
    RowBox[{"Prod", "[", 
     RowBox[{
      SubscriptBox["P", "4"], ",", "\[Delta]"}], "]"}], "+", 
    RowBox[{"Prod", "[", 
     SubscriptBox["P", "5"], "]"}]}], "/.", "Solution"}]}]}], "Input",
 CellChangeTimes->{
  3.73972364867898*^9, 3.7397633428096547`*^9, {3.739763787719102*^9, 
   3.7397637920393496`*^9}, {3.739773547327757*^9, 3.739773547694778*^9}, {
   3.73977483538443*^9, 3.73977484291186*^9}, {3.739783825949725*^9, 
   3.739783828973898*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Prod", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       SubscriptBox["P", "11"], ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       SubscriptBox["P", "22"]}], "}"}]}], "}"}], "]"}], "+", 
  RowBox[{"Prod", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", "\[CapitalPhi]", "}"}], ",", 
      RowBox[{"{", "0", "}"}]}], "}"}], ",", "Int", ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{
        RowBox[{"mul", "[", 
         RowBox[{
          RowBox[{"inv", "[", "\[CapitalPhi]", "]"}], ",", "FF", ",", 
          SubscriptBox["P", "22"]}], "]"}], "-", 
        RowBox[{"mul", "[", 
         RowBox[{
          RowBox[{"inv", "[", "\[CapitalPhi]", "]"}], ",", 
          SubscriptBox["P", "11"], ",", 
          SubscriptBox["B", "0"]}], "]"}]}]}], "}"}], "}"}]}], "]"}], "+", 
  RowBox[{"Prod", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", "\[CapitalPhi]", "}"}], ",", 
      RowBox[{"{", "0", "}"}]}], "}"}], ",", 
    RowBox[{"S", "[", 
     RowBox[{"1", ",", "h"}], "]"}], ",", "Int", ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"-", 
        RowBox[{"mul", "[", 
         RowBox[{
          RowBox[{"inv", "[", 
           RowBox[{
            RowBox[{"S", "[", 
             RowBox[{"1", ",", 
              RowBox[{"-", "h"}]}], "]"}], "[", "\[CapitalPhi]", "]"}], "]"}],
           ",", 
          RowBox[{
           RowBox[{"S", "[", 
            RowBox[{"1", ",", 
             RowBox[{"-", "h"}]}], "]"}], "[", 
           SubscriptBox["P", "11"], "]"}], ",", 
          RowBox[{
           RowBox[{"S", "[", 
            RowBox[{"1", ",", 
             RowBox[{"-", "h"}]}], "]"}], "[", 
           SubscriptBox["B", "1"], "]"}]}], "]"}]}]}], "}"}], "}"}]}], 
   "]"}]}]], "Output",
 CellChangeTimes->{3.7397748666572185`*^9, 3.739774911825802*^9, 
  3.7397751796731215`*^9, 3.7397838457068553`*^9, 3.7397839010430202`*^9, 
  3.739787609033105*^9, 3.7397999771079082`*^9, 3.7398004066694775`*^9, 
  3.7398008786904755`*^9, 3.739851834753948*^9, 3.739852202833001*^9, 
  3.7398701016766367`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["4) Verifying correctness of the solution.", "Subsection",
 CellChangeTimes->{{3.7353671841306877`*^9, 3.7353673466623735`*^9}, 
   3.735540610100152*^9, {3.7374489595522237`*^9, 3.7374489610883117`*^9}, {
   3.7374498531763363`*^9, 3.7374499356330523`*^9}}],

Cell[TextData[{
 "In the following we prove that for the obtained operators ",
 Cell[BoxData[
  FormBox["P", TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox["Q", TraditionalForm]]],
 "  the identity ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"R", "\[CenterDot]", " ", "P"}], " ", "=", " ", 
    RowBox[{"Q", "\[CenterDot]", " ", 
     RowBox[{"R", "'"}]}]}], TraditionalForm]]],
 "  holds."
}], "Text",
 CellChangeTimes->{{3.739536800931428*^9, 3.739536887724392*^9}, {
   3.7395369369562073`*^9, 3.7395369472037935`*^9}, {3.7397170311498475`*^9, 
   3.7397170341740203`*^9}, {3.739763866625615*^9, 3.73976386915776*^9}, {
   3.7397735976956377`*^9, 3.739773604263014*^9}, {3.739787860250474*^9, 
   3.7397878783885117`*^9}, 3.739855639765582*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", " ", 
   RowBox[{"A", "|", 
    SubscriptBox["B", "_Integer"], "|", "EE", "|", "FF"}], "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", 
   SubscriptBox["P", "11"], "]"}], ":=", "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Diff", "[", 
   SubscriptBox["P", "11"], "]"}], ":=", " ", 
  RowBox[{
   RowBox[{"mul", "[", 
    RowBox[{"EE", ",", 
     SubscriptBox["P", "11"]}], "]"}], "-", 
   RowBox[{"mul", "[", 
    RowBox[{
     SubscriptBox["P", "11"], ",", "A"}], "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.7397700662784524`*^9, 3.7397700672175064`*^9}, 
   3.7397701309461513`*^9, {3.739770540763592*^9, 3.7397705648539696`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ApplyRules", "[", 
      RowBox[{
       RowBox[{"LHS", "-", "RHS"}], ",", "RedSys"}], "]"}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        SubscriptBox["OR", "0"], "\[Rule]", 
        RowBox[{"(", "\[NoBreak]", GridBox[{
           {"1", "0"}
          }], "\[NoBreak]", ")"}]}], ",", 
       RowBox[{
        SubscriptBox["OR", "1"], "\[Rule]", 
        RowBox[{"(", "\[NoBreak]", GridBox[{
           {
            RowBox[{"-", "EE"}], 
            RowBox[{"-", "FF"}]}
          }], "\[NoBreak]", ")"}]}], ",", 
       RowBox[{
        SubscriptBox["ORR", "0"], "\[Rule]", " ", 
        RowBox[{"(", "\[NoBreak]", GridBox[{
           {"1", "0"}
          }], "\[NoBreak]", ")"}]}], ",", 
       RowBox[{
        SubscriptBox["ORR", "1"], "\[Rule]", " ", 
        RowBox[{"(", "\[NoBreak]", GridBox[{
           {
            RowBox[{"-", "A"}], 
            RowBox[{"-", 
             SubscriptBox["B", "0"]}]}
          }], "\[NoBreak]", ")"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{
        SubscriptBox["ORR", "2"], "\[Rule]", " ", 
        RowBox[{"(", "\[NoBreak]", GridBox[{
           {"0", 
            RowBox[{"-", 
             SubscriptBox["B", "1"]}]}
          }], "\[NoBreak]", ")"}]}]}], "}"}]}], "/.", "Solution"}], "//", 
   "Coefficients"}], "//", "TableForm"}]], "Input",
 CellChangeTimes->{{3.739706851494701*^9, 3.739706867743924*^9}, {
   3.7397085758809*^9, 3.7397085898444567`*^9}, 3.7397230972714415`*^9, {
   3.739723165625351*^9, 3.739723172548747*^9}, {3.7397232276478987`*^9, 
   3.739723233069208*^9}, {3.739723753731989*^9, 3.739723781809594*^9}, {
   3.739723819168731*^9, 3.7397238505545263`*^9}, {3.7397238883886905`*^9, 
   3.739723916479297*^9}, {3.739723964620051*^9, 3.739723997783948*^9}, {
   3.7397240310398493`*^9, 3.739724062008621*^9}, {3.73972411216949*^9, 
   3.739724137239924*^9}, {3.7397241704148216`*^9, 3.7397241732489834`*^9}, {
   3.7397242045967765`*^9, 3.7397242089980288`*^9}, 3.7397242518324785`*^9, {
   3.73976875706657*^9, 3.7397687839701085`*^9}, {3.7397689131344967`*^9, 
   3.7397689318765683`*^9}, {3.739768972900915*^9, 3.7397689766481295`*^9}, {
   3.739769656456012*^9, 3.739769696683313*^9}, {3.7397697325333633`*^9, 
   3.7397697558576975`*^9}, {3.739769970510975*^9, 3.7397699771173525`*^9}, {
   3.739774881512068*^9, 3.7397748823421154`*^9}, 3.7397838325881047`*^9}],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{"Prod", "[", "]"}], GridBox[{
       {"0", "0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {
     RowBox[{"Prod", "[", 
      RowBox[{"Int", ",", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          RowBox[{
           RowBox[{"mul", "[", 
            RowBox[{
             RowBox[{"inv", "[", "\[CapitalPhi]", "]"}], ",", "FF", ",", 
             SubscriptBox["P", "22"]}], "]"}], "-", 
           RowBox[{"mul", "[", 
            RowBox[{
             RowBox[{"inv", "[", "\[CapitalPhi]", "]"}], ",", 
             SubscriptBox["P", "11"], ",", 
             SubscriptBox["B", "0"]}], "]"}]}]}], "}"}], "}"}]}], "]"}], 
     GridBox[{
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {
     RowBox[{"Prod", "[", 
      RowBox[{
       RowBox[{"S", "[", 
        RowBox[{"1", ",", "h"}], "]"}], ",", "Int", ",", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          RowBox[{"-", 
           RowBox[{"mul", "[", 
            RowBox[{
             RowBox[{"inv", "[", 
              RowBox[{
               RowBox[{"S", "[", 
                RowBox[{"1", ",", 
                 RowBox[{"-", "h"}]}], "]"}], "[", "\[CapitalPhi]", "]"}], 
              "]"}], ",", 
             RowBox[{
              RowBox[{"S", "[", 
               RowBox[{"1", ",", 
                RowBox[{"-", "h"}]}], "]"}], "[", 
              SubscriptBox["P", "11"], "]"}], ",", 
             RowBox[{
              RowBox[{"S", "[", 
               RowBox[{"1", ",", 
                RowBox[{"-", "h"}]}], "]"}], "[", 
              SubscriptBox["B", "1"], "]"}]}], "]"}]}]}], "}"}], "}"}]}], 
      "]"}], GridBox[{
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  TableForm[{{
     TenReS`Prod[], {{0, 0}}}, {
     TenReS`Prod[$CellContext`Int, {{0, $CellContext`mul[
          $CellContext`inv[$CellContext`\[CapitalPhi]], $CellContext`FF, 
          Subscript[$CellContext`P, 22]] - $CellContext`mul[
         $CellContext`inv[$CellContext`\[CapitalPhi]], 
         Subscript[$CellContext`P, 11], 
         Subscript[$CellContext`B, 0]]}}], {{0}}}, {
     TenReS`Prod[
      $CellContext`S[
      1, $CellContext`h], $CellContext`Int, {{0, -$CellContext`mul[
          $CellContext`inv[
           $CellContext`S[1, -$CellContext`h][$CellContext`\[CapitalPhi]]], 
          $CellContext`S[1, -$CellContext`h][
           Subscript[$CellContext`P, 11]], 
          $CellContext`S[1, -$CellContext`h][
           Subscript[$CellContext`B, 1]]]}}], {{0}}}}]]], "Output",
 CellChangeTimes->{3.7397700948740883`*^9, 3.739770170989442*^9, 
  3.739770594123644*^9, 3.739773573679264*^9, 3.7397748669262333`*^9, 
  3.739774912089817*^9, 3.739775179945137*^9, 3.7397838458858657`*^9, 
  3.7397839013070354`*^9, 3.7397876092151155`*^9, 3.739799977346922*^9, 
  3.73980040688649*^9, 3.7398008789274893`*^9, 3.739851835027964*^9, 
  3.739852203051014*^9, 3.739870101836646*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1904, 982},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
Magnification:>2. Inherited,
FrontEndVersion->"10.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (December 4, \
2014)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Info-974383ca-908d-4292-9fc1-adc8bd2d33b1"->{
  Cell[2105, 54, 290, 5, 82, "Print",
   CellTags->"Info-974383ca-908d-4292-9fc1-adc8bd2d33b1"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Info-974383ca-908d-4292-9fc1-adc8bd2d33b1", 139663, 3843}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 505, 9, 56, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1110, 35, 992, 17, 102, "Print"],
Cell[2105, 54, 290, 5, 82, "Print",
 CellTags->"Info-974383ca-908d-4292-9fc1-adc8bd2d33b1"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[2444, 65, 231, 4, 127, "Section",
 InitializationCell->True],
Cell[2678, 71, 763, 22, 101, "Text"],
Cell[3444, 95, 1009, 23, 68, "Input"],
Cell[4456, 120, 798, 20, 56, "Input"],
Cell[CellGroupData[{
Cell[5279, 144, 105, 1, 87, "Subsection"],
Cell[5387, 147, 3351, 92, 257, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8775, 244, 160, 2, 87, "Subsection"],
Cell[8938, 248, 102, 1, 60, "Text"],
Cell[9043, 251, 436, 10, 170, "Input"],
Cell[9482, 263, 1098, 29, 122, "Text"],
Cell[10583, 294, 1915, 49, 552, "Input"],
Cell[12501, 345, 205, 2, 120, "Text"],
Cell[12709, 349, 3163, 92, 932, "Input"],
Cell[15875, 443, 157, 2, 120, "Text"],
Cell[16035, 447, 570, 13, 248, "Input"],
Cell[16608, 462, 110, 1, 120, "Text"],
Cell[16721, 465, 545, 16, 248, "Input"],
Cell[17269, 483, 182, 2, 120, "Text"],
Cell[17454, 487, 543, 17, 400, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[18034, 509, 155, 2, 170, "Subsection"],
Cell[CellGroupData[{
Cell[18214, 515, 105, 1, 134, "Subsubsection"],
Cell[18322, 518, 3297, 90, 932, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[21656, 613, 134, 2, 134, "Subsubsection"],
Cell[21793, 617, 3177, 75, 704, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25007, 697, 134, 2, 134, "Subsubsection"],
Cell[25144, 701, 2878, 82, 628, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[28059, 788, 137, 2, 134, "Subsubsection"],
Cell[28199, 792, 1402, 36, 476, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[29638, 833, 134, 2, 134, "Subsubsection"],
Cell[29775, 837, 858, 20, 324, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[30670, 862, 104, 1, 134, "Subsubsection"],
Cell[30777, 865, 6933, 232, 1444, "Input"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[37759, 1103, 180, 2, 170, "Subsection"],
Cell[37942, 1107, 792, 20, 170, "Input"],
Cell[38737, 1129, 1657, 46, 476, "Input"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[40443, 1181, 341, 5, 95, "Section",
 InitializationCell->True],
Cell[40787, 1188, 4818, 143, 1136640, "Input"],
Cell[45608, 1333, 2840, 88, 741376, "Input"],
Cell[48451, 1423, 3465, 107, 819200, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[51953, 1535, 107, 2, 95, "Section",
 InitializationCell->True],
Cell[52063, 1539, 2650, 74, 514048, "Input"],
Cell[54716, 1615, 2112, 58, 514048, "Input"],
Cell[56831, 1675, 421, 14, 122880, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[57289, 1694, 247, 3, 95, "Section"],
Cell[57539, 1699, 11890, 407, 1618, "Text"],
Cell[69432, 2108, 1677, 32, 133, "Input"],
Cell[CellGroupData[{
Cell[71134, 2144, 565, 13, 87, "Subsection"],
Cell[71702, 2159, 1289, 32, 123, "Input"],
Cell[CellGroupData[{
Cell[73016, 2195, 978, 17, 56, "Input"],
Cell[73997, 2214, 6629, 148, 226, "Output"]
}, Open  ]],
Cell[80641, 2365, 1022, 24, 123, "Input"],
Cell[CellGroupData[{
Cell[81688, 2393, 888, 16, 56, "Input"],
Cell[82579, 2411, 4607, 84, 122, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[87235, 2501, 257, 3, 87, "Subsection"],
Cell[87495, 2506, 3498, 96, 216, "Input"],
Cell[CellGroupData[{
Cell[91018, 2606, 431, 11, 90, "Input"],
Cell[91452, 2619, 8102, 199, 334, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[99591, 2823, 272, 6, 56, "Input"],
Cell[99866, 2831, 3366, 84, 90, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[103281, 2921, 283, 8, 88, "Subsection"],
Cell[103567, 2931, 3078, 81, 456, "Text"],
Cell[106648, 3014, 2043, 33, 92, "Input"],
Cell[108694, 3049, 176, 2, 60, "Text"],
Cell[CellGroupData[{
Cell[108895, 3055, 1250, 36, 90, "Input"],
Cell[110148, 3093, 1449, 37, 56, "Output"]
}, Open  ]],
Cell[111612, 3133, 3376, 95, 374, "Text"],
Cell[114991, 3230, 1090, 32, 56, "Input"],
Cell[116084, 3264, 334, 6, 60, "Text"],
Cell[CellGroupData[{
Cell[116443, 3274, 1292, 18, 56, "Input"],
Cell[117738, 3294, 5401, 76, 56, "Output"]
}, Open  ]],
Cell[123154, 3373, 2000, 59, 172, "Text"],
Cell[CellGroupData[{
Cell[125179, 3436, 2981, 88, 196, "Input"],
Cell[128163, 3526, 2213, 65, 90, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[130425, 3597, 263, 3, 87, "Subsection"],
Cell[130691, 3602, 764, 20, 61, "Text"],
Cell[131458, 3624, 777, 22, 133, "Input"],
Cell[CellGroupData[{
Cell[132260, 3650, 2444, 56, 90, "Input"],
Cell[134707, 3708, 4548, 118, 124, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
