(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    128018,       3403]
NotebookOptionsPosition[    122275,       3221]
NotebookOutlinePosition[    122912,       3245]
CellTagsIndexPosition[    122806,       3240]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"<<", 
  "\"\<C:\\\\Users\\\\Jamal\\\\Desktop\\\\main\\\\Research\\\\Codes\\\\IDOs\\\
\\ArtesteinsReduction\\\\TenReS.m\>\""}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694167372350441*^9, 3.694167385792696*^9}, {
   3.6993427658432713`*^9, 3.6993428272217827`*^9}, {3.7262326477393084`*^9, 
   3.726232661647654*^9}, 3.7397839142277746`*^9}],

Cell[CellGroupData[{

Cell[BoxData["\<\"Package TenReS version 0.2.4\\nwritten by Clemens G. \
Raab\\nCopyright 2016, RICAM, Austrian Academy of Sciences\"\>"], "Print",
 CellChangeTimes->CompressedData["
1:eJwd0FtIk3EcxvGlQbOCmq81OzAyiswdUjFpsTxkZw/rsIulpW1NyoKCJS/r
KitxympYF29GNHAYmmw4UZeCFU3QWqysdIpUbCYkbAWDpDmj+j+/i4fPxXP3
zTBePVmbJBKJlGzwSs+JZ4qRSHGrS08Kfvl5JTN6OJdUqgx2eFx+kdTWzLVB
85kIOS5+3qliZjaNkGOKmmEo664lK5Oto9DTcJeULXXPQt7SS9Z/iH3cxXxb
ESc12rMzsFVnIm+1J0JwRrYsDPfaxH/gffEa8m+gSpLN1JUaSWeWezNMdPaR
88HKrbBIZyBDXdGKPcxzHb/Jsu05NjVzuE5NDhaubtEzrQJHav+5q1O/RIqb
X4RJ0baHXmhIC5D28Ws+jqlyuEj9RFUM+h/bST5nqH8jc3lJygBsc479gqYH
kgUYdb5ehJOx1AS8VN+TtIkZnFoi82QTK6F0XcYquHbx9E7Y2NJBevkN2TDx
yUTGf/g19Dek74Mu85GDu5llGis5GFeWQ8uWC+Spxlw99Dy6TLo/C13wXeF7
8qjd+BL+zBPIG0LBJPQpzOS3ovSv8FidOwQPcJIY5J8cItX5N1fkM5ssA2RY
+soAp1PumeAbrv02lMqD5A6uxAN9szw5F1g/D9NspaTD1T+qYVYnfyfvePc7
CtD36XXyP3toe2w=
  "]],

Cell[BoxData[
 StyleBox["\<\"A few definitions need to be made by the user. Type ?CoeffQ, \
?Specialization, and ?CyclicModules for more information.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.7398745478648853`*^9},
 CellTags->"Info-6570581b-3d56-4a7f-b205-59545445794e"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Basic definitions", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.6400787807134733`*^9, 3.640078788888632*^9}, {
  3.659170131248847*^9, 3.659170137303594*^9}, {3.682830115630125*^9, 
  3.6828301266446743`*^9}}],

Cell[TextData[{
 "We want to compute in the tensor ring over ",
 Cell[BoxData[
  FormBox[Cell[TextData[Cell[BoxData[
    FormBox["K", TraditionalForm]]]]], TraditionalForm]]],
 "-bimodules. However, bimodules are not implemented, so the implementation \
uses the tensor algebra product over ",
 Cell[BoxData[
  FormBox["\[DoubleStruckCapitalZ]", TraditionalForm]]],
 "-modules. Consequently, the cyclic ",
 Cell[BoxData[
  FormBox["K", TraditionalForm]]],
 "-bimodule ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["M", "K"], TraditionalForm]]],
 " is not a cyclic ",
 Cell[BoxData[
  FormBox["\[DoubleStruckCapitalZ]", TraditionalForm]]],
 "-module."
}], "Text",
 CellChangeTimes->{{3.674799362782167*^9, 3.674799486021337*^9}, {
  3.674799838708332*^9, 3.674799892900877*^9}, {3.687079520040925*^9, 
  3.687079543347366*^9}, {3.7397839327768354`*^9, 3.7397839339729037`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Specialization", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"R", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"K", ",", 
        OverscriptBox["R", "~"]}], "}"}]}], ",", 
     RowBox[{"\[CapitalPhi]", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<E\>\"", ",", 
        OverscriptBox["\[CapitalPhi]", "~"]}], "}"}]}], ",", 
     RowBox[{"G", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"N", ",", 
        OverscriptBox["G", "~"]}], "}"}]}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6398890163113747`*^9, 3.639889054043709*^9}, {
   3.639889737312602*^9, 3.639889744112504*^9}, {3.6398940881500607`*^9, 
   3.639894098174966*^9}, {3.659086827358851*^9, 3.659086831494749*^9}, {
   3.659088973275432*^9, 3.659088977842003*^9}, {3.6590976281633368`*^9, 
   3.659097642819615*^9}, {3.670244973878394*^9, 3.670245032387117*^9}, {
   3.670247219591683*^9, 3.670247222415421*^9}, 3.6871531306206007`*^9, {
   3.689592234536019*^9, 3.6895922372660227`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"CyclicModules", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"K", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<E\>\"", ",", "Eval"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"D", ",", "Diff"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<I\>\"", ",", "Int"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"N", ",", 
       RowBox[{"S", "[", 
        RowBox[{"1", ",", "0"}], "]"}]}], "}"}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.659096534797022*^9, 3.6590965352753773`*^9}, {
   3.659096673633688*^9, 3.659096675368188*^9}, {3.670245062107257*^9, 
   3.6702451117240057`*^9}, {3.670245295686005*^9, 3.67024532450555*^9}, {
   3.670247225231395*^9, 3.6702472253272943`*^9}, 3.687153154519842*^9}],

Cell[CellGroupData[{

Cell["Bimodule structure", "Subsection",
 CellChangeTimes->{{3.683001088920826*^9, 3.68300109299426*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Prod", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"b", ":", 
     RowBox[{"Diff", "|", "Int", "|", "Eval", "|", 
      RowBox[{"\[CapitalPhi]", "[", "_Integer", "]"}], "|", 
      RowBox[{"S", "[", 
       RowBox[{
        RowBox[{"_", "?", 
         SubscriptBox["MemberQ", "Z"]}], ",", 
        RowBox[{"_", "?", 
         SubscriptBox["MemberQ", "Z"]}]}], "]"}]}]}], ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"c_", "?", 
       SubscriptBox["MemberQ", "K"]}], ")"}], 
     RowBox[{"Prod", "[", "]"}]}], ",", "d___"}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{"a", ",", 
    RowBox[{"c", " ", 
     RowBox[{"Prod", "[", "]"}]}], ",", "b", ",", "d"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Prod", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"b_", "?", 
     SubscriptBox["MemberQ", "R"]}], ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"c_", "?", 
       SubscriptBox["MemberQ", "K"]}], ")"}], 
     RowBox[{"Prod", "[", "]"}]}], ",", "d___"}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{"a", ",", 
    RowBox[{"mul", "[", 
     RowBox[{"b", ",", "c"}], "]"}], ",", "d"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Prod", "[", 
   RowBox[{"a___", ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"b_", "?", 
       SubscriptBox["MemberQ", "K"]}], ")"}], 
     RowBox[{"Prod", "[", "]"}]}], ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"c_", "?", 
       SubscriptBox["MemberQ", "K"]}], ")"}], 
     RowBox[{"Prod", "[", "]"}]}], ",", "d___"}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{"a", ",", 
    RowBox[{
     RowBox[{"mul", "[", 
      RowBox[{"b", ",", "c"}], "]"}], 
     RowBox[{"Prod", "[", "]"}]}], ",", "d"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Prod", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"mul", "[", 
     RowBox[{
      RowBox[{"c_", "?", 
       SubscriptBox["MemberQ", "K"]}], ",", "f__"}], "]"}], ",", "b___"}], 
   "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{"a", ",", 
    RowBox[{"c", " ", 
     RowBox[{"Prod", "[", "]"}]}], ",", 
    RowBox[{"mul", "[", "f", "]"}], ",", "b"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"Prod", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"b_", "*", "c_Plus"}], ",", "d___"}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{"a", ",", 
    RowBox[{"Map", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"b", "*", "#"}], "&"}], ",", "c"}], "]"}], ",", "d"}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.682838778862541*^9, 3.682838843044186*^9}, 
   3.68283887404455*^9, {3.682838905347752*^9, 3.682838945747851*^9}, {
   3.6828389863455553`*^9, 3.682839001603705*^9}, {3.682839064639946*^9, 
   3.682839067127886*^9}, {3.6829202148020077`*^9, 3.682920246908084*^9}, {
   3.6829202861393833`*^9, 3.682920383404994*^9}, {3.6829204540780697`*^9, 
   3.6829204543463497`*^9}, {3.682920550373654*^9, 3.682920568978134*^9}, {
   3.687153170837471*^9, 3.6871531990579205`*^9}, 3.6871532388223906`*^9, {
   3.6871532710520473`*^9, 3.687153299007296*^9}, {3.6871537992221746`*^9, 
   3.6871538033249817`*^9}, 3.6895922436960316`*^9, {3.7397751466232314`*^9, 
   3.739775147407276*^9}, {3.7398509946808987`*^9, 3.7398509955479484`*^9}, {
   3.7398554416772523`*^9, 3.739855444397408*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Membership checks", "Subsection",
 CellChangeTimes->{{3.6591723429752007`*^9, 3.6591723786702147`*^9}, {
  3.670250652868689*^9, 3.6702506619234743`*^9}}],

Cell["Check for constants:", "Text",
 CellChangeTimes->{{3.659163098154707*^9, 3.659163115075246*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "K"], "[", "f_", "]"}], ":=", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"Diff", "[", "f", "]"}], "===", "0"}], ")"}]}]], "Input",
 CellChangeTimes->{{3.638682699993037*^9, 3.638682727301762*^9}, 
   3.67024541657796*^9, {3.68715821445373*^9, 3.6871582755278373`*^9}, {
   3.6871584196564903`*^9, 3.6871584226048956`*^9}, {3.6895922571560507`*^9, 
   3.6895922587360525`*^9}}],

Cell[TextData[{
 "We denote  ",
 Cell[BoxData[
  FormBox[
   RowBox[{"K", "\[Intersection]", 
    RowBox[{"Z", 
     RowBox[{"(", "R", ")"}]}]}], TraditionalForm]]],
 " ( intersection of constants ",
 Cell[BoxData[
  FormBox["K", TraditionalForm]]],
 " with the center of ring ",
 Cell[BoxData[
  FormBox["R", TraditionalForm]]],
 ") by ",
 Cell[BoxData[
  FormBox["Z", TraditionalForm]]],
 " ."
}], "Text",
 CellChangeTimes->{{3.674799362782167*^9, 3.674799486021337*^9}, {
  3.674799838708332*^9, 3.674799892900877*^9}, {3.687079520040925*^9, 
  3.687079543347366*^9}, {3.689593404990744*^9, 3.689593572110978*^9}, {
  3.689593694373726*^9, 3.689593705262348*^9}, {3.689593735991106*^9, 
  3.689593739998335*^9}, {3.6895939396953936`*^9, 3.6895939510054097`*^9}, {
  3.6895939847354565`*^9, 3.6895940841055956`*^9}, {3.6896046549968677`*^9, 
  3.6896046575160117`*^9}, {3.690104488854461*^9, 3.690104489477497*^9}, {
  3.739773295370346*^9, 3.739773320288771*^9}, {3.7397839409793043`*^9, 
  3.7397839453665557`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "Z"], "[", "_Integer", "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "Z"], "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"A", "|", "B"}], ")"}], "[", "_Integer", "]"}], "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "Z"], "[", "f_Plus", "]"}], ":=", 
  RowBox[{"(", 
   RowBox[{"And", "@@", 
    RowBox[{"Map", "[", 
     RowBox[{
      SubscriptBox["MemberQ", "Z"], ",", 
      RowBox[{"List", "@@", "f"}]}], "]"}]}], ")"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "Z"], "[", "f_Times", "]"}], ":=", 
  RowBox[{"(", 
   RowBox[{"And", "@@", 
    RowBox[{"Map", "[", 
     RowBox[{
      SubscriptBox["MemberQ", "Z"], ",", 
      RowBox[{"List", "@@", "f"}]}], "]"}]}], ")"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "Z"], "[", 
   RowBox[{"Power", "[", 
    RowBox[{
     RowBox[{"f_", "?", 
      SubscriptBox["MemberQ", "Z"]}], ",", "_Integer"}], "]"}], "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "Z"], "[", "_", "]"}], ":=", "False"}]}], "Input",
 CellChangeTimes->{{3.6871538216862144`*^9, 3.6871538556786737`*^9}, {
  3.6871539025411563`*^9, 3.6871539328676095`*^9}, {3.68715458797616*^9, 
  3.687154597492177*^9}, {3.6871546640262938`*^9, 3.6871547075035706`*^9}, {
  3.687154777220093*^9, 3.6871547861433086`*^9}, {3.6871555406854334`*^9, 
  3.6871555997939377`*^9}, {3.6871563694686894`*^9, 3.687156379515107*^9}, {
  3.687156456938043*^9, 3.687156473084071*^9}, {3.6871577340186863`*^9, 
  3.6871577500867147`*^9}, {3.687157862094911*^9, 3.687157864388115*^9}, {
  3.6871579003773785`*^9, 3.6871579124049997`*^9}, {3.687157944572256*^9, 
  3.6871579629802885`*^9}, {3.6895922636660595`*^9, 3.689592264856061*^9}}],

Cell["Check for membership in the function algebra:", "Text",
 CellChangeTimes->{{3.6591631194512157`*^9, 3.6591631291876383`*^9}, 
   3.659163217493614*^9, {3.6591724206231956`*^9, 3.659172422789729*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", 
   RowBox[{"F", "[", "_Integer", "]"}], "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", 
   RowBox[{"Diff", "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", 
   RowBox[{"Int", "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", "f_mul", "]"}], ":=", 
  RowBox[{"And", "@@", 
   RowBox[{"(", 
    RowBox[{
     SubscriptBox["MemberQ", "R"], "/@", 
     RowBox[{"(", 
      RowBox[{"List", "@@", "f"}], ")"}]}], ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"s_", "?", 
      SubscriptBox["MemberQ", "G"]}], ")"}], "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", 
   RowBox[{"inv", "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"R", "[", "k_Integer", "]"}], ":=", 
  RowBox[{"F", "[", "k", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", 
   RowBox[{"f_", "?", 
    SubscriptBox["MemberQ", "K"]}], "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"c_", "?", "CoeffQ"}], ")"}], "f_"}], "]"}], ":=", 
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", "f", "]"}]}], "\n", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", "f__Plus", "]"}], ":=", 
  RowBox[{"And", "@@", 
   RowBox[{"(", 
    RowBox[{
     SubscriptBox["MemberQ", "R"], "/@", 
     RowBox[{"(", 
      RowBox[{"List", "@@", "f"}], ")"}]}], ")"}]}]}], "\n", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", 
   RowBox[{"f_", "?", "MatrixQ"}], "]"}], ":=", 
  RowBox[{"And", "@@", 
   RowBox[{"(", 
    RowBox[{
     SubscriptBox["MemberQ", "R"], "/@", 
     RowBox[{"Flatten", "[", 
      RowBox[{"f", ",", "1"}], "]"}]}], ")"}]}]}]}], "Input",
 CellChangeTimes->{{3.669455790328519*^9, 3.6694557970644712`*^9}, {
   3.669543619267727*^9, 3.669543632574329*^9}, {3.670245501045932*^9, 
   3.670245606567086*^9}, 3.670246245762525*^9, 3.682830172179517*^9, {
   3.6828355629428263`*^9, 3.682835600736021*^9}, {3.6871533509085875`*^9, 
   3.687153351704189*^9}, {3.689592274976075*^9, 3.689592324676145*^9}, {
   3.6895923885585527`*^9, 3.689592428534314*^9}, {3.698728886447846*^9, 
   3.698728918015327*^9}, {3.698730164873973*^9, 3.698730171312064*^9}, {
   3.698730495221025*^9, 3.6987304978995113`*^9}, {3.69873057212881*^9, 
   3.698730576040122*^9}, {3.739715930342885*^9, 3.7397159317089634`*^9}, {
   3.7397691038264036`*^9, 3.7397691041814237`*^9}, {3.7397751276401453`*^9, 
   3.739775128208178*^9}}],

Cell["Check for functionals:", "Text",
 CellChangeTimes->{{3.670245973081357*^9, 3.670245977713456*^9}, {
  3.7397751207367506`*^9, 3.7397751211667757`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "\[CapitalPhi]"], "[", "Eval", "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "\[CapitalPhi]"], "[", 
   RowBox[{"\[CapitalPhi]", "[", "_Integer", "]"}], "]"}], ":=", 
  "True"}]}], "Input",
 CellChangeTimes->{{3.669455877198039*^9, 3.669455894498609*^9}, 
   3.669543189868985*^9, {3.6702459832458897`*^9, 3.670246019832996*^9}, {
   3.687103716685647*^9, 3.687103749558527*^9}, {3.6871039884201894`*^9, 
   3.6871039890202236`*^9}, 3.687153387038251*^9}],

Cell["Check for substitutions:", "Text",
 CellChangeTimes->{{3.6871534023886776`*^9, 3.6871534127626963`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "G"], "[", 
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"a_", "?", 
      SubscriptBox["MemberQ", "Z"]}], ",", 
     RowBox[{"b_", "?", 
      SubscriptBox["MemberQ", "Z"]}]}], "]"}], "]"}], ":=", 
  RowBox[{"(", 
   RowBox[{"a", "=!=", "0"}], ")"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "G"], "[", 
   RowBox[{"G", "[", "_Integer", "]"}], "]"}], ":=", "True"}]}], "Input",
 CellChangeTimes->{3.6871533833098445`*^9, 3.6871537713293257`*^9}],

Cell["Check for membership in the other cyclic modules:", "Text",
 CellChangeTimes->{{3.6702458564563427`*^9, 3.670245866975058*^9}, {
  3.670245946760453*^9, 3.670245947584765*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "D"], "[", "Diff", "]"}], ":=", "True"}], "\n", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "\"\<I\>\""], "[", "Int", "]"}], ":=", 
  "True"}], "\n", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "\"\<E\>\""], "[", "Eval", "]"}], ":=", 
  "True"}], "\n", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "N"], "[", 
   RowBox[{"S", "[", 
    RowBox[{"1", ",", "0"}], "]"}], "]"}], ":=", "True"}]}], "Input",
 CellChangeTimes->{{3.739775108515052*^9, 3.73977511407837*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Function algebra", "Subsection",
 CellChangeTimes->{{3.638691610025188*^9, 3.638691614921186*^9}, {
  3.659165795915909*^9, 3.6591657979705772`*^9}}],

Cell[CellGroupData[{

Cell["Multiplication", "Subsubsection",
 CellChangeTimes->{{3.659165569776952*^9, 3.659165577588789*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", "b_Plus", ",", "c___"}], "]"}], ":=", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"mul", "[", 
      RowBox[{"a", ",", "#", ",", "c"}], "]"}], "&"}], "/@", "b"}], 
   ")"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", "b_Integer", ",", "c__"}], "]"}], ":=", 
  RowBox[{"b", " ", 
   RowBox[{"mul", "[", 
    RowBox[{"a", ",", "c"}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a__", ",", "b_Integer", ",", "c___"}], "]"}], ":=", 
  RowBox[{"b", " ", 
   RowBox[{"mul", "[", 
    RowBox[{"a", ",", "c"}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"d_Integer", "*", "b_"}], ",", "c___"}], "]"}], ":=", 
  RowBox[{"d", " ", 
   RowBox[{"mul", "[", 
    RowBox[{"a", ",", "b", ",", "c"}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"mul", "[", "b__", "]"}], ",", "c___"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", "b", ",", "c"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mul", "[", "a_", "]"}], ":=", "a"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"b_", "?", 
     SubscriptBox["MemberQ", "Z"]}], ",", 
    RowBox[{"c_", "?", 
     SubscriptBox["MemberQ", "Z"]}], ",", "d___"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", 
    RowBox[{"b", "*", "c"}], ",", "d"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"b_", "?", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{
         SubscriptBox["MemberQ", "R"], "[", "#", "]"}], "&&", 
        RowBox[{"!", 
         RowBox[{
          SubscriptBox["MemberQ", "Z"], "[", "#", "]"}]}]}], "&"}], ")"}]}], 
    ",", 
    RowBox[{"c_", "?", 
     SubscriptBox["MemberQ", "Z"]}], ",", "d___"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", "c", ",", "b", ",", "d"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], ",", 
    RowBox[{"inv", "[", "f_", "]"}], ",", "b___"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", "b"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"inv", "[", "f_", "]"}], ",", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], ",", "b___"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", "b"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"mul", "[", "]"}], ":=", "1"}]}], "Input",
 CellChangeTimes->{{3.638684986800296*^9, 3.638685023740603*^9}, {
   3.638685085399458*^9, 3.6386851016267347`*^9}, {3.6386852559617443`*^9, 
   3.638685292086501*^9}, {3.638685328564872*^9, 3.63868533076567*^9}, {
   3.638685453632114*^9, 3.638685456591627*^9}, {3.638685773732319*^9, 
   3.63868577618708*^9}, 3.6386858741418343`*^9, {3.63869290635741*^9, 
   3.6386929232045727`*^9}, {3.6387824422362843`*^9, 3.638782493065415*^9}, {
   3.6388722777325487`*^9, 3.6388722903501*^9}, {3.639212523253624*^9, 
   3.639212586876335*^9}, 3.639980360207717*^9, {3.739775082471562*^9, 
   3.739775083382614*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Differentiation", "Subsubsection",
 CellChangeTimes->{{3.659163141267557*^9, 3.6591631488521423`*^9}, 
   3.659165586346394*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Diff", "[", 
   RowBox[{"f_", "?", "NumericQ"}], "]"}], ":=", "0"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Diff", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"\[CurlyPhi]_", "?", 
      SubscriptBox["MemberQ", "\[CapitalPhi]"]}], ")"}], "[", "f_", "]"}], 
   "]"}], ":=", "0"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Diff", "[", 
   RowBox[{"f_", "?", 
    SubscriptBox["MemberQ", "Z"]}], "]"}], ":=", "0"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Diff", "[", 
   RowBox[{"Int", "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  "f"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Diff", "[", "a_mul", "]"}], ":=", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{"MapAt", "[", 
     RowBox[{"Diff", ",", "a", ",", "i"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", 
      RowBox[{"Length", "[", "a", "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Diff", "[", "f_Plus", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{"Diff", ",", "f"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"Diff", "[", 
   RowBox[{"inv", "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  RowBox[{"-", 
   RowBox[{"mul", "[", 
    RowBox[{
     RowBox[{"inv", "[", "f", "]"}], ",", 
     RowBox[{"Diff", "[", "f", "]"}], ",", 
     RowBox[{"inv", "[", "f", "]"}]}], "]"}]}]}], "\n", 
 RowBox[{
  RowBox[{"Diff", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"c_", "?", "CoeffQ"}], ")"}], 
    RowBox[{"(", 
     RowBox[{"f_", "?", 
      SubscriptBox["MemberQ", "R"]}], ")"}]}], "]"}], ":=", 
  RowBox[{"c", " ", 
   RowBox[{"Diff", "[", "f", "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.638682746051725*^9, 3.638682788960909*^9}, {
   3.638682825870358*^9, 3.638682962118843*^9}, {3.6386831317951612`*^9, 
   3.638683190849043*^9}, {3.638683239496002*^9, 3.638683300736999*^9}, {
   3.638683391426631*^9, 3.6386834461159897`*^9}, {3.638782252717188*^9, 
   3.638782253282292*^9}, {3.638782504556032*^9, 3.6387825049058027`*^9}, {
   3.639212762878365*^9, 3.639212788512412*^9}, {3.640058908518703*^9, 
   3.640058989848414*^9}, {3.6400590763931026`*^9, 3.640059144710424*^9}, {
   3.659159838349127*^9, 3.659159839787879*^9}, {3.659701295933262*^9, 
   3.6597012991698523`*^9}, {3.659701749337516*^9, 3.6597017541360083`*^9}, {
   3.659701785652364*^9, 3.6597017880263767`*^9}, {3.659701846596245*^9, 
   3.6597018492038803`*^9}, {3.670246185189465*^9, 3.670246215676208*^9}, {
   3.670246254518935*^9, 3.670246256356043*^9}, {3.670246334717093*^9, 
   3.670246369529475*^9}, 3.670246738163018*^9, {3.670249771073493*^9, 
   3.6702497719200172`*^9}, {3.68283571585677*^9, 3.682835730684732*^9}, {
   3.6829379750055523`*^9, 3.682937975485763*^9}, {3.6829429368147717`*^9, 
   3.68294293771128*^9}, {3.6871559666597815`*^9, 3.687155983913412*^9}, {
   3.6871561575257173`*^9, 3.6871561891167727`*^9}, {3.6871583790964193`*^9, 
   3.687158413042079*^9}, 3.6895924605543594`*^9, {3.7262066801423664`*^9, 
   3.726206691530386*^9}, {3.7262067287676516`*^9, 3.726206739937271*^9}, {
   3.739774940767457*^9, 3.7397749417545137`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Integration", "Subsubsection",
 CellChangeTimes->{{3.6591631541798153`*^9, 3.6591631569643307`*^9}, 
   3.6591655902493143`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{"f_", "?", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{
        SubscriptBox["MemberQ", "K"], "[", "#", "]"}], "&&", 
       RowBox[{"(", 
        RowBox[{"#", "=!=", "1"}], ")"}]}], "&"}], ")"}]}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"f", ",", " ", 
    RowBox[{"Int", "[", "1", "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{"mul", "[", 
    RowBox[{"f__", ",", 
     RowBox[{"c_", "?", 
      SubscriptBox["MemberQ", "K"]}]}], "]"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{
    RowBox[{"Int", "[", 
     RowBox[{"mul", "[", "f", "]"}], "]"}], ",", "c"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{"Diff", "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  RowBox[{"f", "-", 
   RowBox[{"Eval", "[", "f", "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"Int", "/:", 
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"Int", "[", "f_", "]"}], ",", 
    RowBox[{"Int", "[", "g_", "]"}], ",", "b___"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"mul", "[", 
    RowBox[{"a", ",", 
     RowBox[{"Int", "[", 
      RowBox[{"mul", "[", 
       RowBox[{
        RowBox[{"Int", "[", "f", "]"}], ",", "g"}], "]"}], "]"}], ",", "b"}], 
    "]"}], "+", 
   RowBox[{"mul", "[", 
    RowBox[{"a", ",", 
     RowBox[{"Int", "[", 
      RowBox[{"mul", "[", 
       RowBox[{"f", ",", 
        RowBox[{"Int", "[", "g", "]"}]}], "]"}], "]"}], ",", "b"}], 
    "]"}]}]}], "\n", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"Int", "[", "1", "]"}], ",", 
    RowBox[{"c_", "?", 
     SubscriptBox["MemberQ", "K"]}], ",", "b___"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", "c", ",", 
    RowBox[{"Int", "[", "1", "]"}], ",", "b"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"Int", "[", "f_Plus", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{"Int", ",", "f"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"c_", "?", "CoeffQ"}], ")"}], 
    RowBox[{"(", 
     RowBox[{"f_", "?", 
      SubscriptBox["MemberQ", "R"]}], ")"}]}], "]"}], ":=", 
  RowBox[{"c", " ", 
   RowBox[{"Int", "[", "f", "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.659162411432198*^9, 3.659162412408951*^9}, {
   3.659164197207127*^9, 3.659164197790752*^9}, {3.659171490362842*^9, 
   3.659171491487652*^9}, {3.6597013045303164`*^9, 3.6597013070497923`*^9}, {
   3.65970147718134*^9, 3.659701479851516*^9}, {3.670246390359516*^9, 
   3.670246410313141*^9}, {3.682835743292811*^9, 3.682835756499106*^9}, {
   3.682922363505677*^9, 3.6829223924145117`*^9}, {3.682926287313134*^9, 
   3.682926320109994*^9}, 3.6895924739343777`*^9, {3.723020749052878*^9, 
   3.723020756203888*^9}, {3.7397749543032312`*^9, 3.739774955211283*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Induced evaluation", "Subsubsection",
 CellChangeTimes->{{3.6591631661642323`*^9, 3.659163171220705*^9}, 
   3.659165594273448*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Eval", "[", 
   RowBox[{"f_", "?", 
    SubscriptBox["MemberQ", "K"]}], "]"}], ":=", "f"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Eval", "[", 
   RowBox[{"Int", "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  "0"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Eval", "[", "f_mul", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{"Eval", ",", "f"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Eval", "[", "f_Plus", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{"Eval", ",", "f"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"Eval", "[", 
     RowBox[{"f_", "?", 
      SubscriptBox["MemberQ", "R"]}], "]"}], ",", 
    RowBox[{"Eval", "[", 
     RowBox[{"inv", "[", 
      RowBox[{"f_", "?", 
       SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ",", "b___"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", "b"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.65916263319906*^9, 3.6591626335436068`*^9}, {
   3.670246424800674*^9, 3.670246429623632*^9}, {3.6828358313150043`*^9, 
   3.6828358410828857`*^9}, {3.6829210945837917`*^9, 3.682921099615996*^9}, {
   3.682922258911646*^9, 3.682922261329509*^9}, {3.6871018941824055`*^9, 
   3.687101922244011*^9}, 3.6871021395064373`*^9, 3.689592465414366*^9, {
   3.739774962286688*^9, 3.739774963063732*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Functionals", "Subsubsection",
 CellChangeTimes->{{3.6591641415283527`*^9, 3.6591641443831253`*^9}, 
   3.6591656005776367`*^9}],

Cell[BoxData[{
 RowBox[{"\[CapitalPhi]", "/:", 
  RowBox[{
   RowBox[{"\[CapitalPhi]", "[", "i_Integer", "]"}], "[", "1", "]"}], ":=", 
  "1"}], "\[IndentingNewLine]", 
 RowBox[{"\[CapitalPhi]", "/:", 
  RowBox[{
   RowBox[{"\[CapitalPhi]", "[", "i_Integer", "]"}], "[", "f_mul", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{"\[CapitalPhi]", "[", "i", "]"}], ",", "f"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"\[CapitalPhi]", "/:", 
  RowBox[{
   RowBox[{"\[CapitalPhi]", "[", "i_Integer", "]"}], "[", "f_Plus", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{"\[CapitalPhi]", "[", "i", "]"}], ",", "f"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.6871017707413454`*^9, 3.6871017750975943`*^9}, {
   3.6871018476607447`*^9, 3.687101848025766*^9}, 3.687102142485608*^9, {
   3.7397749684070377`*^9, 3.739774969333091*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Substitutions", "Subsubsection",
 CellChangeTimes->{{3.687153558950553*^9, 3.687153562351359*^9}}],

Cell[BoxData[{
 RowBox[{"S", "/:", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{"1", ",", "0"}], "]"}], "[", "f_", "]"}], ":=", 
  "f"}], "\[IndentingNewLine]", 
 RowBox[{"S", "/:", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"a_", "?", 
      SubscriptBox["MemberQ", "Z"]}], ",", 
     RowBox[{"b_", "?", 
      SubscriptBox["MemberQ", "Z"]}]}], "]"}], "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"t_", "?", 
      SubscriptBox["MemberQ", "G"]}], ")"}], "[", "f_", "]"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"comp", "[", 
    RowBox[{
     RowBox[{"S", "[", 
      RowBox[{"a", ",", "b"}], "]"}], ",", "t"}], "]"}], "[", "f", 
   "]"}]}], "\n", 
 RowBox[{"S", "/:", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"a_", "?", 
      SubscriptBox["MemberQ", "Z"]}], ",", 
     RowBox[{"b_", "?", 
      SubscriptBox["MemberQ", "Z"]}]}], "]"}], "[", 
   RowBox[{"c_", "?", 
    SubscriptBox["MemberQ", "K"]}], "]"}], ":=", "c"}], "\[IndentingNewLine]", 
 RowBox[{"S", "/:", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"a_", "?", 
      SubscriptBox["MemberQ", "Z"]}], ",", 
     RowBox[{"b_", "?", 
      SubscriptBox["MemberQ", "Z"]}]}], "]"}], "[", "f_mul", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{"S", "[", 
     RowBox[{"a", ",", "b"}], "]"}], ",", "f"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"S", "/:", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"a_", "?", 
      SubscriptBox["MemberQ", "Z"]}], ",", 
     RowBox[{"b_", "?", 
      SubscriptBox["MemberQ", "Z"]}]}], "]"}], "[", 
   RowBox[{"inv", "[", "f_", "]"}], "]"}], ":=", 
  RowBox[{"inv", "[", 
   RowBox[{
    RowBox[{"S", "[", 
     RowBox[{"a", ",", "b"}], "]"}], "[", "f", "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"S", "/:", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"a_", "?", 
      SubscriptBox["MemberQ", "Z"]}], ",", 
     RowBox[{"b_", "?", 
      SubscriptBox["MemberQ", "Z"]}]}], "]"}], "[", "f_Plus", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{"S", "[", 
     RowBox[{"a", ",", "b"}], "]"}], ",", "f"}], "]"}]}], "\n", 
 RowBox[{"S", "/:", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"a_", "?", 
      SubscriptBox["MemberQ", "Z"]}], ",", 
     RowBox[{"b_", "?", 
      SubscriptBox["MemberQ", "Z"]}]}], "]"}], "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"c_", "?", "CoeffQ"}], ")"}], 
    RowBox[{"(", 
     RowBox[{"f_", "?", 
      SubscriptBox["MemberQ", "R"]}], ")"}]}], "]"}], ":=", 
  RowBox[{"c", " ", 
   RowBox[{
    RowBox[{"S", "[", 
     RowBox[{"a", ",", "b"}], "]"}], "[", "f", 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"S", "/:", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"a_", "?", 
      SubscriptBox["MemberQ", "Z"]}], ",", 
     RowBox[{"b_", "?", 
      SubscriptBox["MemberQ", "Z"]}]}], "]"}], "[", 
   RowBox[{"Int", "[", "1", "]"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"mul", "[", 
    RowBox[{"a", ",", 
     RowBox[{"Int", "[", "1", "]"}]}], "]"}], "+", 
   RowBox[{"Eval", "[", 
    RowBox[{
     RowBox[{"S", "[", 
      RowBox[{"a", ",", "b"}], "]"}], "[", 
     RowBox[{"Hold", "[", 
      RowBox[{"Int", "[", "1", "]"}], "]"}], "]"}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"G", "[", "i_Integer", "]"}], ":=", 
  RowBox[{"S", "[", 
   RowBox[{
    RowBox[{"A", "[", "i", "]"}], ",", 
    RowBox[{"B", "[", "i", "]"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"jac", "[", 
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"a_", "?", 
      SubscriptBox["MemberQ", "Z"]}], ",", 
     RowBox[{"b_", "?", 
      SubscriptBox["MemberQ", "Z"]}]}], "]"}], "]"}], ":=", "a"}], "\n", 
 RowBox[{
  RowBox[{"comp", "[", 
   RowBox[{
    RowBox[{"S", "[", 
     RowBox[{
      RowBox[{"a_", "?", 
       SubscriptBox["MemberQ", "Z"]}], ",", 
      RowBox[{"b_", "?", 
       SubscriptBox["MemberQ", "Z"]}]}], "]"}], ",", 
    RowBox[{"S", "[", 
     RowBox[{
      RowBox[{"c_", "?", 
       SubscriptBox["MemberQ", "Z"]}], ",", 
      RowBox[{"d_", "?", 
       SubscriptBox["MemberQ", "Z"]}]}], "]"}]}], "]"}], ":=", 
  RowBox[{"S", "[", 
   RowBox[{
    RowBox[{"a", " ", "c"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"c", " ", "b"}], "+", "d"}], "//", "Expand"}], "//", 
     "Together"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"Diff", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"A", "|", "B"}], ")"}], "[", "_Integer", "]"}], "]"}], ":=", 
  "0"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Diff", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"s_", "?", 
      SubscriptBox["MemberQ", "G"]}], ")"}], "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{
    RowBox[{"jac", "[", "s", "]"}], ",", 
    RowBox[{"s", "[", 
     RowBox[{"Diff", "[", "f", "]"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{"S", "[", 
     RowBox[{
      RowBox[{"a_", "?", 
       SubscriptBox["MemberQ", "K"]}], ",", 
      RowBox[{"b_", "?", 
       SubscriptBox["MemberQ", "K"]}]}], "]"}], "[", "f_", "]"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{
    FractionBox["1", "a"], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"S", "[", 
       RowBox[{"a", ",", "b"}], "]"}], "[", 
      RowBox[{"Int", "[", "f", "]"}], "]"}], "-", 
     RowBox[{"Eval", "[", 
      RowBox[{
       RowBox[{"S", "[", 
        RowBox[{"a", ",", "b"}], "]"}], "[", 
       RowBox[{"Int", "[", "f", "]"}], "]"}], "]"}]}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"inv", "[", 
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"a_", "?", 
      SubscriptBox["MemberQ", "K"]}], ",", 
     RowBox[{"b_", "?", 
      SubscriptBox["MemberQ", "K"]}]}], "]"}], "]"}], ":=", 
  RowBox[{"S", "[", 
   RowBox[{
    RowBox[{"1", "/", "a"}], ",", 
    RowBox[{
     RowBox[{"-", "b"}], "/", "a"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Eval", "[", 
   RowBox[{
    RowBox[{"S", "[", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"A", "[", "1", "]"}]], ",", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"B", "[", "1", "]"}], 
        RowBox[{"A", "[", "1", "]"}]]}]}], "]"}], "[", 
    RowBox[{"Hold", "[", 
     RowBox[{"Int", "[", "1", "]"}], "]"}], "]"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{
    RowBox[{"-", 
     FractionBox["1", 
      RowBox[{"A", "[", "1", "]"}]]}], ",", 
    RowBox[{"Eval", "[", 
     RowBox[{
      RowBox[{"S", "[", 
       RowBox[{
        RowBox[{"A", "[", "1", "]"}], ",", 
        RowBox[{"B", "[", "1", "]"}]}], "]"}], "[", 
      RowBox[{"Hold", "[", 
       RowBox[{"Int", "[", "1", "]"}], "]"}], "]"}], "]"}]}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.6871536562323236`*^9, 3.6871536667623425`*^9}, {
   3.687153696854795*^9, 3.687153755760498*^9}, 3.6895924908244014`*^9, {
   3.739774981503787*^9, 3.739775066067624*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Matrix computations in the coefficient ring", "Subsection",
 CellChangeTimes->{{3.726207142324378*^9, 3.726207209466896*^9}, {
  3.726207556022505*^9, 3.726207559766511*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mul", "[", 
    RowBox[{"a___", ",", 
     RowBox[{"m1_", "?", "MatrixQ"}], ",", 
     RowBox[{"m2_", "?", "MatrixQ"}], ",", "b___"}], "]"}], "/;", 
   RowBox[{
    RowBox[{"Length", "[", 
     RowBox[{"m1", "[", 
      RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", 
    RowBox[{"Length", "[", "m2", "]"}]}]}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", 
    RowBox[{"Inner", "[", 
     RowBox[{"mul", ",", "m1", ",", "m2"}], "]"}], ",", "b"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.722595602026443*^9, 3.7225956326258907`*^9}, {
  3.7225956932327414`*^9, 3.722595723506545*^9}, {3.72259582464373*^9, 
  3.7225958350193644`*^9}, {3.722595879486856*^9, 3.722595910485755*^9}, {
  3.7225966032515306`*^9, 3.72259661861121*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Diff", "[", 
   RowBox[{"m_", "?", "MatrixQ"}], "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{"Diff", ",", "m", ",", 
    RowBox[{"{", "2", "}"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{"m_", "?", "MatrixQ"}], "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{"Int", ",", "m", ",", 
    RowBox[{"{", "2", "}"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"S", "/:", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"a_", "?", 
      SubscriptBox["MemberQ", "Z"]}], ",", 
     RowBox[{"b_", "?", 
      SubscriptBox["MemberQ", "Z"]}]}], "]"}], "[", 
   RowBox[{"m_", "?", "MatrixQ"}], "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{"S", "[", 
     RowBox[{"a", ",", "b"}], "]"}], ",", "m", ",", 
    RowBox[{"{", "2", "}"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Prod", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"c_", "?", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"MatrixQ", "[", "#", "]"}], "&&", 
        RowBox[{"MatchQ", "[", 
         RowBox[{
          RowBox[{"Flatten", "[", 
           RowBox[{"#", ",", "1"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"Repeated", "[", "0", "]"}], "}"}]}], "]"}]}], "&"}], 
      ")"}]}], ",", "b___"}], "]"}], ":=", 
  "0"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.7225959990524282`*^9, 3.722596034261569*^9}, {
   3.722596065881753*^9, 3.722596084166253*^9}, {3.7389094623721333`*^9, 
   3.7389094820052557`*^9}, {3.7389095213705077`*^9, 3.738909549436113*^9}, 
   3.738909764973441*^9, {3.7398554526928825`*^9, 3.7398554535329304`*^9}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Reduction system for IDOLS", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.682830373294333*^9, 3.682830377957657*^9}, {
  3.6895928521349087`*^9, 3.6895929344350233`*^9}, {3.6896046787532263`*^9, 
  3.689604682363433*^9}, {3.6941678932953777`*^9, 3.694167902694168*^9}, {
  3.7262066047006335`*^9, 3.726206607025038*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["h", "K"], "[", "k_", "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{"k", " ", 
    RowBox[{"Prod", "[", "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "RR"], "[", 
   RowBox[{
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], ",", 
    RowBox[{"g_", "?", 
     SubscriptBox["MemberQ", "R"]}]}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{"mul", "[", 
    RowBox[{"f", ",", "g"}], "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "\[CapitalPhi]R"], "[", 
   RowBox[{
    RowBox[{"\[CurlyPhi]_", "?", 
     SubscriptBox["MemberQ", "\[CapitalPhi]"]}], ",", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}]}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"\[CurlyPhi]", "[", "f", "]"}], 
     RowBox[{"Prod", "[", "]"}]}], ",", "\[CurlyPhi]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "\[CapitalPhi]\[CapitalPhi]"], "[", 
   RowBox[{
    RowBox[{"\[CurlyPhi]_", "?", 
     SubscriptBox["MemberQ", "\[CapitalPhi]"]}], ",", 
    RowBox[{"\[Psi]_", "?", 
     SubscriptBox["MemberQ", "\[CapitalPhi]"]}]}], "]"}], ":=", 
  RowBox[{"Prod", "[", "\[Psi]", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "EI"], "[", 
   RowBox[{"Eval", ",", "Int"}], "]"}], ":=", "0"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "DR"], "[", 
   RowBox[{"Diff", ",", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}]}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Prod", "[", 
    RowBox[{"Diff", "[", "f", "]"}], "]"}], "+", 
   RowBox[{"Prod", "[", 
    RowBox[{"f", ",", "Diff"}], "]"}]}]}], "\n", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "D\[CapitalPhi]"], "[", 
   RowBox[{"Diff", ",", 
    RowBox[{"\[CurlyPhi]_", "?", 
     SubscriptBox["MemberQ", "\[CapitalPhi]"]}]}], "]"}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "DI"], "[", 
   RowBox[{"Diff", ",", "Int"}], "]"}], ":=", 
  RowBox[{"Prod", "[", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "I\[CapitalPhi]"], "[", 
   RowBox[{"Int", ",", 
    RowBox[{"\[CurlyPhi]_", "?", 
     SubscriptBox["MemberQ", "\[CapitalPhi]"]}]}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{
    RowBox[{"Int", "[", "1", "]"}], ",", "\[CurlyPhi]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "ID"], "[", 
   RowBox[{"Int", ",", "Diff"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Prod", "[", "]"}], "-", 
   RowBox[{"Prod", "[", "Eval", "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "II"], "[", 
   RowBox[{"Int", ",", "Int"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Prod", "[", 
    RowBox[{
     RowBox[{"Int", "[", "1", "]"}], ",", "Int"}], "]"}], "-", 
   RowBox[{"Prod", "[", 
    RowBox[{"Int", ",", 
     RowBox[{"Int", "[", "1", "]"}]}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "IR\[CapitalPhi]"], "[", 
   RowBox[{"Int", ",", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], ",", 
    RowBox[{"\[CurlyPhi]_", "?", 
     SubscriptBox["MemberQ", "\[CapitalPhi]"]}]}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{
    RowBox[{"Int", "[", "f", "]"}], ",", "\[CurlyPhi]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "IRD"], "[", 
   RowBox[{"Int", ",", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], ",", "Diff"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Prod", "[", "f", "]"}], "-", 
   RowBox[{"Prod", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Eval", "[", "f", "]"}], " ", 
      RowBox[{"Prod", "[", "]"}]}], ",", "Eval"}], "]"}], "-", 
   RowBox[{"Prod", "[", 
    RowBox[{"Int", ",", 
     RowBox[{"Diff", "[", "f", "]"}]}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "IRI"], "[", 
   RowBox[{"Int", ",", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], ",", "Int"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Prod", "[", 
    RowBox[{
     RowBox[{"Int", "[", "f", "]"}], ",", "Int"}], "]"}], "-", 
   RowBox[{"Prod", "[", 
    RowBox[{"Int", ",", 
     RowBox[{"Int", "[", "f", "]"}]}], "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.682830444156025*^9, 3.682830470225523*^9}, {
   3.682834198147834*^9, 3.682834214536252*^9}, {3.682851644402529*^9, 
   3.682851645428053*^9}, {3.6871003756050105`*^9, 3.68710039816265*^9}, {
   3.687151940149107*^9, 3.687151949961524*^9}, 3.6871521643059006`*^9, {
   3.687152270432887*^9, 3.687152272648091*^9}, {3.689592507214424*^9, 
   3.6895925166644373`*^9}, {3.6895925538644896`*^9, 3.689592565024505*^9}, {
   3.689592655624632*^9, 3.689592667544649*^9}, {3.6895927037147007`*^9, 
   3.6895928463249*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    SubscriptBox["h", "N"], "[", 
    RowBox[{"S", "[", 
     RowBox[{"1", ",", "0"}], "]"}], "]"}], "=", 
   RowBox[{"Prod", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "GR"], "[", 
   RowBox[{
    RowBox[{"s_", "?", 
     SubscriptBox["MemberQ", "G"]}], ",", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}]}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{
    RowBox[{"s", "[", "f", "]"}], ",", "s"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "G\[CapitalPhi]"], "[", 
   RowBox[{
    RowBox[{"s_", "?", 
     SubscriptBox["MemberQ", "G"]}], ",", 
    RowBox[{"\[CurlyPhi]_", "?", 
     SubscriptBox["MemberQ", "\[CapitalPhi]"]}]}], "]"}], ":=", 
  RowBox[{"Prod", "[", "\[CurlyPhi]", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "GG"], "[", 
   RowBox[{
    RowBox[{"s_", "?", 
     SubscriptBox["MemberQ", "G"]}], ",", 
    RowBox[{"t_", "?", 
     SubscriptBox["MemberQ", "G"]}]}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{"comp", "[", 
    RowBox[{"s", ",", "t"}], "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "DG"], "[", 
   RowBox[{"Diff", ",", 
    RowBox[{"s_", "?", 
     SubscriptBox["MemberQ", "G"]}]}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"jac", "[", "s", "]"}], 
     RowBox[{"Prod", "[", "]"}]}], ",", "s", ",", "Diff"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "IG"], "[", 
   RowBox[{"Int", ",", 
    RowBox[{"s_", "?", 
     SubscriptBox["MemberQ", "G"]}]}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{
    RowBox[{
     FractionBox["1", 
      RowBox[{"jac", "[", "s", "]"}]], 
     RowBox[{"Prod", "[", "]"}]}], ",", 
    RowBox[{
     RowBox[{"Prod", "[", "]"}], "-", "Eval"}], ",", "s", ",", "Int"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "IRG"], "[", 
   RowBox[{"Int", ",", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], ",", 
    RowBox[{"s_", "?", 
     SubscriptBox["MemberQ", "G"]}]}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{
    RowBox[{
     FractionBox["1", 
      RowBox[{"jac", "[", "s", "]"}]], 
     RowBox[{"Prod", "[", "]"}]}], ",", 
    RowBox[{
     RowBox[{"Prod", "[", "]"}], "-", "Eval"}], ",", "s", ",", "Int", ",", 
    RowBox[{
     RowBox[{"inv", "[", "s", "]"}], "[", "f", "]"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.6871549385087757`*^9, 3.6871549814868517`*^9}, {
  3.6895925316744585`*^9, 3.689592537664467*^9}, {3.689592953985051*^9, 
  3.6895929845850935`*^9}, {3.689593053670707*^9, 3.6895930626162186`*^9}, {
  3.6895931005383177`*^9, 3.6895931219283476`*^9}, {3.689593334838646*^9, 
  3.6895933369086485`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"RedSys", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", "K", "}"}], ",", 
       SubscriptBox["h", "K"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"R", ",", "R"}], "}"}], ",", 
       SubscriptBox["h", "RR"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\[CapitalPhi]", ",", "R"}], "}"}], ",", 
       SubscriptBox["h", "\[CapitalPhi]R"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\[CapitalPhi]", ",", "\[CapitalPhi]"}], "}"}], ",", 
       SubscriptBox["h", "\[CapitalPhi]\[CapitalPhi]"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<E\>\"", ",", "\"\<I\>\""}], "}"}], ",", 
       SubscriptBox["h", "EI"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"D", ",", "R"}], "}"}], ",", 
       SubscriptBox["h", "DR"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"D", ",", "\[CapitalPhi]"}], "}"}], ",", 
       SubscriptBox["h", "D\[CapitalPhi]"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"D", ",", "\"\<I\>\""}], "}"}], ",", 
       SubscriptBox["h", "DI"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<I\>\"", ",", "\[CapitalPhi]"}], "}"}], ",", 
       SubscriptBox["h", "I\[CapitalPhi]"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<I\>\"", ",", "D"}], "}"}], ",", 
       SubscriptBox["h", "ID"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<I\>\"", ",", "\"\<I\>\""}], "}"}], ",", 
       SubscriptBox["h", "II"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<I\>\"", ",", "R", ",", "\[CapitalPhi]"}], "}"}], ",", 
       SubscriptBox["h", "IR\[CapitalPhi]"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<I\>\"", ",", "R", ",", "D"}], "}"}], ",", 
       SubscriptBox["h", "IRD"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<I\>\"", ",", "R", ",", "\"\<I\>\""}], "}"}], ",", 
       SubscriptBox["h", "IRI"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", "N", "}"}], ",", 
       SubscriptBox["h", "N"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"G", ",", "R"}], "}"}], ",", 
       SubscriptBox["h", "GR"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"G", ",", "\[CapitalPhi]"}], "}"}], ",", 
       SubscriptBox["h", "G\[CapitalPhi]"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"G", ",", "G"}], "}"}], ",", 
       SubscriptBox["h", "GG"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"D", ",", "G"}], "}"}], ",", 
       SubscriptBox["h", "DG"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<I\>\"", ",", "G"}], "}"}], ",", 
       SubscriptBox["h", "IG"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<I\>\"", ",", "R", ",", "G"}], "}"}], ",", 
       SubscriptBox["h", "IRG"]}], "}"}]}], "}"}]}], ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Auxiliary functions", "Section",
 InitializationCell->True,
 CellChangeTimes->{3.721113232148026*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["LeftCoeff", "R"], "[", 
   RowBox[{
    RowBox[{"Prod", "[", 
     RowBox[{
      RowBox[{"f__", "?", 
       SubscriptBox["MemberQ", "R"]}], ",", "m___"}], "]"}], ",", 
    RowBox[{"Prod", "[", "m___", "]"}]}], "]"}], ":=", 
  RowBox[{"mul", "[", "f", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["LeftCoeff", "R"], "[", 
   RowBox[{
    RowBox[{"Prod", "[", "m___", "]"}], ",", 
    RowBox[{"Prod", "[", "m___", "]"}]}], "]"}], ":=", 
  "1"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["LeftCoeff", "R"], "[", 
   RowBox[{
    RowBox[{"Prod", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"c_", "?", 
         SubscriptBox["MemberQ", "K"]}], ")"}], "*", 
       RowBox[{"Prod", "[", "]"}]}], ",", 
      RowBox[{"f___", "?", 
       SubscriptBox["MemberQ", "R"]}], ",", "m___"}], "]"}], ",", 
    RowBox[{"Prod", "[", "m___", "]"}]}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"c", ",", "f"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["LeftCoeff", "R"], "[", 
   RowBox[{"t_Prod", ",", 
    RowBox[{"Prod", "[", "m___", "]"}]}], "]"}], ":=", 
  "0"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["LeftCoeff", "R"], "[", 
   RowBox[{"a_Plus", ",", 
    RowBox[{"Prod", "[", "m___", "]"}]}], "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox["LeftCoeff", "R"], "[", 
      RowBox[{"#", ",", 
       RowBox[{"Prod", "[", "m", "]"}]}], "]"}], "&"}], ",", "a"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["LeftCoeff", "R"], "[", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"c_", "?", "CoeffQ"}], ")"}], "t_Prod"}], ",", 
    RowBox[{"Prod", "[", "m___", "]"}]}], "]"}], ":=", 
  RowBox[{"c", " ", 
   RowBox[{
    SubscriptBox["LeftCoeff", "R"], "[", 
    RowBox[{"t", ",", 
     RowBox[{"Prod", "[", "m", "]"}]}], "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.699351620935052*^9, 3.699351696511311*^9}, {
  3.699351908345364*^9, 3.699351927169579*^9}, {3.699352268410995*^9, 
  3.699352290178299*^9}, {3.699352447548417*^9, 3.6993524573555326`*^9}, {
  3.6993526692301083`*^9, 3.699352709251622*^9}, {3.699354814919639*^9, 
  3.699354865959058*^9}, {3.699354915253944*^9, 3.699354973183589*^9}, {
  3.699355521691896*^9, 3.699355530261294*^9}, {3.6993556750764303`*^9, 
  3.699355721031934*^9}, {3.714809595722381*^9, 3.714809629225843*^9}, {
  3.714811743154192*^9, 3.714811745482112*^9}, {3.720959585700904*^9, 
  3.720959599730564*^9}, {3.722669438862779*^9, 3.7226694443383884`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["Support", "R"], "[", 
   RowBox[{"Prod", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"c_", "?", 
        SubscriptBox["MemberQ", "K"]}], ")"}], "*", 
      RowBox[{"Prod", "[", "]"}]}], ",", "a___"}], "]"}], "]"}], ":=", 
  RowBox[{
   SubscriptBox["Support", "R"], "[", 
   RowBox[{"Prod", "[", "a", "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["Support", "R"], "[", 
   RowBox[{"Prod", "[", 
    RowBox[{
     RowBox[{"f__", "?", 
      SubscriptBox["MemberQ", "R"]}], ",", "a___"}], "]"}], "]"}], ":=", 
  RowBox[{
   SubscriptBox["Support", "R"], "[", 
   RowBox[{"Prod", "[", "a", "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["Support", "R"], "[", 
   RowBox[{"Prod", "[", "a___", "]"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{"Prod", "[", "a", "]"}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["Support", "R"], "[", "a_Plus", "]"}], ":=", 
  RowBox[{"Union", "@@", 
   RowBox[{"(", 
    RowBox[{
     SubscriptBox["Support", "R"], "/@", 
     RowBox[{"(", 
      RowBox[{"List", "@@", "a"}], ")"}]}], ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["Support", "R"], "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"c_", "?", "CoeffQ"}], ")"}], "t_Prod"}], "]"}], ":=", 
  RowBox[{
   SubscriptBox["Support", "R"], "[", "t", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["Support", "R"], "[", "0", "]"}], ":=", 
  RowBox[{"{", "}"}]}]}], "Input",
 CellChangeTimes->{{3.6993554712616453`*^9, 3.699355478105356*^9}, {
   3.6993560904101*^9, 3.699356094134852*^9}, {3.6993561385524406`*^9, 
   3.699356314720628*^9}, {3.699356348766143*^9, 3.699356403307789*^9}, {
   3.699356610362338*^9, 3.699356656845377*^9}, {3.7148096428305798`*^9, 
   3.7148096609734297`*^9}, {3.7148877588489027`*^9, 3.714887760693915*^9}, {
   3.714888758065007*^9, 3.714888762910594*^9}, {3.720959601482885*^9, 
   3.7209596329851303`*^9}, 3.722669432451168*^9, {3.7262105839831095`*^9, 
   3.726210594107527*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Coefficients", "[", "expr_", "]"}], ":=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"m", ",", 
      RowBox[{
       SubscriptBox["LeftCoeff", "R"], "[", 
       RowBox[{"expr", ",", "m"}], "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"m", ",", 
      RowBox[{
       SubscriptBox["Support", "R"], "[", "expr", "]"}]}], "}"}]}], 
   "]"}]}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Examples of subsections 3.3 and 3.4 in TDS paper", "Section",
 CellChangeTimes->{{3.7262064656731896`*^9, 3.726206477810011*^9}, {
   3.7262065169660797`*^9, 3.7262065260140953`*^9}, {3.726208087222038*^9, 
   3.726208094897251*^9}, 3.726213154613912*^9}],

Cell[TextData[{
 "First we need to introduce to the package the coefficients ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["A", "0"], ",", " ", 
    FormBox[
     SubscriptBox["A", "1"],
     TraditionalForm], ",", 
    FormBox[
     SubscriptBox["H", "1"],
     TraditionalForm], ",", " ", 
    FormBox[
     SubscriptBox["H", "2"],
     TraditionalForm], ",", 
    RowBox[{
     FormBox[
      RowBox[{"\[CapitalPhi]", ","}],
      TraditionalForm], "  ", 
     FormBox["\[CapitalTheta]",
      TraditionalForm]}], " ", ","}], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   OverscriptBox["\[CapitalTheta]", "~"], TraditionalForm]]],
 " which we use in our examples as elements of the coefficient ring ",
 Cell[BoxData[
  FormBox["R", TraditionalForm]]],
 ", the parameter ",
 Cell[BoxData[
  FormBox["h", TraditionalForm]]],
 " and the notation ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[Delta]", "=", 
    SubscriptBox["\[Sigma]", 
     RowBox[{"1", ",", "h"}]]}], TraditionalForm]]],
 "."
}], "Text",
 CellChangeTimes->{{3.7262084976275587`*^9, 3.7262087354977765`*^9}, {
   3.726208812139111*^9, 3.7262088621215987`*^9}, {3.726208964754179*^9, 
   3.7262089854554157`*^9}, {3.72620903940031*^9, 3.7262090630655518`*^9}, {
   3.726209457905532*^9, 3.726209489183586*^9}, {3.726209824676776*^9, 
   3.726209944436986*^9}, {3.7262100416095567`*^9, 3.726210166055375*^9}, {
   3.726210205305044*^9, 3.7262102119038553`*^9}, {3.7262102668471518`*^9, 
   3.726210302165614*^9}, {3.739601200938654*^9, 3.7396012016336937`*^9}, {
   3.739601489124137*^9, 3.7396015159946737`*^9}, {3.739784056749926*^9, 
   3.7397840861116056`*^9}, 3.7397871934883375`*^9, {3.739872130697114*^9, 
   3.7398721311409283`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", 
   RowBox[{
    SubscriptBox["A", "0"], "|", 
    SubscriptBox["A", "1"], "|", 
    SubscriptBox["H", "1"], "|", 
    SubscriptBox["H", "2"], "|", "\[CapitalPhi]", "|", "\[CapitalTheta]", "|",
     "\[CapitalTheta]\[CapitalTheta]"}], "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "Z"], "[", "h", "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{"\[Delta]", ":=", 
  RowBox[{"S", "[", 
   RowBox[{"1", ",", "h"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.725277857882575*^9, 3.725277864840187*^9}, 
   3.726209072019967*^9, {3.7262094965624*^9, 3.7262094976544013`*^9}, {
   3.7262097905247154`*^9, 3.7262098068303447`*^9}, {3.72620985559483*^9, 
   3.7262098579972343`*^9}, {3.7262103255500555`*^9, 3.726210341430883*^9}, 
   3.739800920602873*^9}],

Cell[CellGroupData[{

Cell["Ex.8) Variation of constants with square coefficients ", "Subsection",
 CellChangeTimes->{{3.7229249255965047`*^9, 3.722924961060533*^9}, {
   3.723892834583496*^9, 3.7238928637399473`*^9}, 3.725257923396613*^9, {
   3.725263302195327*^9, 3.7252633191369567`*^9}, {3.7252652895034175`*^9, 
   3.7252652910790205`*^9}, {3.725265717154814*^9, 3.725265762051693*^9}, 
   3.7262107206081495`*^9, {3.7397861331326885`*^9, 3.73978613437976*^9}}],

Cell[TextData[{
 "Consider the ",
 "inhomogeneous",
 " differential system\n\n                                                    \
             ",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", Cell[TextData[Cell[BoxData[
     FormBox[Cell[TextData[Cell[BoxData[
       FormBox[Cell[TextData[Cell[BoxData[
         FormBox[Cell[TextData[Cell[BoxData[
           FormBox[
            RowBox[{
             RowBox[{
              RowBox[{
               OverscriptBox["x", "."], " ", 
               RowBox[{"(", "t", ")"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{
                SubscriptBox["A", "0"], "(", "t", ")"}], " ", 
               RowBox[{"x", "(", "t", ")"}]}]}], " ", "=", " ", 
             RowBox[{"f", "(", "t", ")"}]}], TraditionalForm]]]]], 
          TraditionalForm]]]]], TraditionalForm]]]]], TraditionalForm]]]]]}], 
   TraditionalForm]]],
 "\n\nwhich corresponds to the operator ",
 Cell[BoxData[
  FormBox[
   RowBox[{"L", " ", ":=", " ", 
    RowBox[{"\[PartialD]", 
     RowBox[{"-", 
      SubscriptBox["A", "0"]}]}]}], TraditionalForm]]],
 ". "
}], "Text",
 CellChangeTimes->{{3.725262124525859*^9, 3.725262336647231*^9}, {
   3.7252633340349827`*^9, 3.725263336983388*^9}, {3.7252664952559805`*^9, 
   3.7252665964533587`*^9}, 3.7252673153957095`*^9, {3.725273143101609*^9, 
   3.725273143101609*^9}, {3.7252731934740973`*^9, 3.725273210946128*^9}, {
   3.7252793551490655`*^9, 3.7252794612956524`*^9}, {3.7252798176416793`*^9, 
   3.725279861961357*^9}, {3.7262107406853848`*^9, 3.726210750341801*^9}, {
   3.739784103460598*^9, 3.7397841080528603`*^9}, {3.7397847132774773`*^9, 
   3.739784714604553*^9}, {3.7397872033929043`*^9, 3.7397872033929043`*^9}, 
   3.739854839799827*^9}],

Cell[BoxData[
 RowBox[{"OL", ":=", 
  RowBox[{
   RowBox[{"Prod", "[", "Diff", "]"}], "-", 
   RowBox[{"Prod", "[", 
    SubscriptBox["A", "0"], "]"}]}]}]], "Input",
 CellChangeTimes->{3.7262107565038123`*^9, 3.739857518046014*^9}],

Cell[TextData[{
 "Our goal is to construct a solution operator ",
 Cell[BoxData[
  FormBox[
   RowBox[{"H", " ", ":=", " ", 
    RowBox[{
     SubscriptBox["H", "1"], "\[CenterDot]", 
     RowBox[{"\[Integral]", 
      RowBox[{"\[CenterDot]", " ", 
       SubscriptBox["H", "2"]}]}]}]}], TraditionalForm]]],
 " with the unknowns ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["H", "1"], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["H", "2"], TraditionalForm]]],
 " such that  ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"L", "\[CenterDot]", "H"}], "=", "1"}], TraditionalForm]]],
 "."
}], "Text",
 CellChangeTimes->{{3.725266609073781*^9, 3.725266777834877*^9}, 
   3.7252673770782175`*^9, {3.725279473557274*^9, 3.7252795100467377`*^9}, {
   3.7397858978842335`*^9, 3.7397859264628677`*^9}, {3.7397872194788237`*^9, 
   3.7397872266682353`*^9}}],

Cell[BoxData[
 RowBox[{"OH", ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{
    SubscriptBox["H", "1"], ",", "Int", ",", 
    SubscriptBox["H", "2"]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.725260850156021*^9, 3.7252608712472577`*^9}, 
   3.7252610169359136`*^9, 3.725261047964368*^9, {3.725261080474825*^9, 
   3.7252610994600587`*^9}, {3.7252634795052385`*^9, 3.72526350897369*^9}, 
   3.7252636071446624`*^9, 3.7252648589884615`*^9, 3.7252649051021423`*^9, 
   3.739857522598274*^9}],

Cell[TextData[{
 " We apply the reduction system to ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"L", "\[CenterDot]", "H"}], "-", "1"}], TraditionalForm]]],
 "  and extract its left coefficients."
}], "Text",
 CellChangeTimes->{{3.725266794870107*^9, 3.725266860047022*^9}, {
   3.7252668948662825`*^9, 3.725266905879902*^9}, 3.7252674934490767`*^9, 
   3.725279513946745*^9, 3.7397841527004147`*^9, {3.739788518989152*^9, 
   3.739788548188822*^9}, {3.739801059172798*^9, 3.739801060316864*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ApplyRules", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Prod", "[", 
     RowBox[{"OL", ",", "OH"}], "]"}], "-", 
    RowBox[{"Prod", "[", "]"}]}], ",", "RedSys"}], "]"}]], "Input",
 CellChangeTimes->{{3.725259110686346*^9, 3.7252591388911953`*^9}, {
   3.725259171713653*^9, 3.725259197219698*^9}, 3.725259307309091*^9, {
   3.7252596513036957`*^9, 3.725259657122506*^9}, 3.7252599908226924`*^9, 
   3.7252600912594876`*^9, 3.725260288429234*^9, {3.725260342639329*^9, 
   3.725260351078944*^9}, {3.7252604771905656`*^9, 3.7252604956609983`*^9}, 
   3.725260558232708*^9, {3.7252606603348875`*^9, 3.725260688165336*^9}, {
   3.725260755635455*^9, 3.7252607727174845`*^9}, 3.72526081552396*^9, {
   3.725260857768834*^9, 3.7252608783920703`*^9}, {3.7252609092645245`*^9, 
   3.7252609140381327`*^9}, {3.725260974176238*^9, 3.7252609941130733`*^9}, {
   3.7252611115032797`*^9, 3.725261136213723*^9}, {3.7252613789345493`*^9, 
   3.725261394768577*^9}, {3.7252635231541147`*^9, 3.7252635274753227`*^9}, {
   3.7252648453852377`*^9, 3.725264854339653*^9}, 3.7252649124497557`*^9, {
   3.739786737070232*^9, 3.739786744269644*^9}, {3.7398575294936686`*^9, 
   3.739857532125819*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   RowBox[{"Prod", "[", "]"}]}], "+", 
  RowBox[{"Prod", "[", 
   RowBox[{"mul", "[", 
    RowBox[{
     SubscriptBox["H", "1"], ",", 
     SubscriptBox["H", "2"]}], "]"}], "]"}], "+", 
  RowBox[{"Prod", "[", 
   RowBox[{
    RowBox[{"Diff", "[", 
     SubscriptBox["H", "1"], "]"}], ",", "Int", ",", 
    SubscriptBox["H", "2"]}], "]"}], "-", 
  RowBox[{"Prod", "[", 
   RowBox[{
    RowBox[{"mul", "[", 
     RowBox[{
      SubscriptBox["A", "0"], ",", 
      SubscriptBox["H", "1"]}], "]"}], ",", "Int", ",", 
    SubscriptBox["H", "2"]}], "]"}]}]], "Output",
 CellChangeTimes->{
  3.7252606890857377`*^9, {3.7252607281950064`*^9, 3.725260783512704*^9}, {
   3.7252608178795643`*^9, 3.7252608806696744`*^9}, {3.7252609247865515`*^9, 
   3.725260942476983*^9}, {3.725260985455058*^9, 3.725260994971075*^9}, {
   3.725261033534343*^9, 3.7252611371965246`*^9}, {3.72526138500296*^9, 
   3.725261426452233*^9}, 3.7252614660295024`*^9, 3.7252625082475324`*^9, 
   3.725263105338581*^9, 3.7252635564601736`*^9, {3.7252648363060217`*^9, 
   3.7252648749628897`*^9}, 3.725264928954584*^9, 3.725265100242885*^9, 
   3.7252651511301746`*^9, 3.7252660515122013`*^9, 3.7252664430426893`*^9, 
   3.7252750239395127`*^9, 3.7252765175620203`*^9, 3.7252771495513306`*^9, 
   3.725280312686949*^9, 3.725339674215427*^9, 3.725339854960345*^9, 
   3.726206349296985*^9, 3.726206395067466*^9, 3.7262077698988805`*^9, 
   3.7262081155828876`*^9, 3.726208199667035*^9, 3.726210366437727*^9, 
   3.726210531520217*^9, 3.7262106127495594`*^9, 3.726210837873555*^9, 
   3.7262127601028194`*^9, 3.726212819462923*^9, 3.7262128723470163`*^9, 
   3.7262130887817965`*^9, 3.7262132593992963`*^9, 3.7262133499418554`*^9, 
   3.726213395384735*^9, 3.7262301365032167`*^9, 3.726296147736108*^9, 
   3.739783927461531*^9, 3.7397846308047605`*^9, 3.7397867739173393`*^9, 
   3.739787148868785*^9, 3.739801001069475*^9, 3.7398015131317635`*^9, 
   3.7398015531790543`*^9, 3.73980162443713*^9, 3.7398016896928625`*^9, 
   3.73980193371482*^9, 3.7398019877199087`*^9, 3.739802089340721*^9, 
   3.7398554047481403`*^9, 3.739855467712742*^9, 3.7398555558077803`*^9, 
   3.7398561990155697`*^9, 3.739856381084984*^9, 3.739856555947985*^9, {
   3.739856626775036*^9, 3.7398566458191257`*^9}, 3.7398567786127205`*^9, 
   3.7398569580679855`*^9, {3.739857680108283*^9, 3.739857700940475*^9}, 
   3.739857951094783*^9, 3.7398583081282043`*^9, 3.7398587547517495`*^9, 
   3.739870775823196*^9, 3.7398745482719083`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"%", "//", "Coefficients"}], "//", "TableForm"}]], "Input",
 CellChangeTimes->{{3.722925187781501*^9, 3.7229252237895603`*^9}, {
   3.7229253310726967`*^9, 3.722925333485834*^9}, {3.7229254079500933`*^9, 
   3.7229254113412876`*^9}, 3.7229255318941827`*^9, 3.72292564303854*^9}],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{"Prod", "[", "]"}], 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      RowBox[{"mul", "[", 
       RowBox[{
        SubscriptBox["H", "1"], ",", 
        SubscriptBox["H", "2"]}], "]"}]}]},
    {
     RowBox[{"Prod", "[", 
      RowBox[{"Int", ",", 
       SubscriptBox["H", "2"]}], "]"}], 
     RowBox[{
      RowBox[{"Diff", "[", 
       SubscriptBox["H", "1"], "]"}], "-", 
      RowBox[{"mul", "[", 
       RowBox[{
        SubscriptBox["A", "0"], ",", 
        SubscriptBox["H", "1"]}], "]"}]}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.7229252268177333`*^9, 3.72292534250535*^9, 3.7229253792574525`*^9, {
   3.722925546929043*^9, 3.722925568855297*^9}, 3.722925644239609*^9, 
   3.7229262646670523`*^9, 3.722926681749385*^9, 3.7230149566391*^9, 
   3.723015240497198*^9, 3.7230155897662115`*^9, 3.7230158073625937`*^9, 
   3.7230159563996553`*^9, 3.7230160631506424`*^9, 3.7230161143187323`*^9, 
   3.7230191519979286`*^9, 3.723020276051216*^9, 3.723020768243905*^9, 
   3.7230245292847137`*^9, 3.723028508223179*^9, 3.723028539685979*^9, 
   3.7230288185109262`*^9, 3.7230289203897533`*^9, 3.723030147649949*^9, 
   3.7230335160448847`*^9, {3.7230335502401447`*^9, 3.7230335762297897`*^9}, 
   3.72303410022871*^9, 3.723034182550055*^9, 3.7230342197249203`*^9, 
   3.7230343354303236`*^9, 3.7230343757251945`*^9, {3.723893296612508*^9, 
   3.7238933515870037`*^9}, 3.7240822352308435`*^9, 3.724082270206105*^9, {
   3.724082438592801*^9, 3.724082493879298*^9}, 3.7243964798756733`*^9, 
   3.724396536185752*^9, {3.724399514645934*^9, 3.7243995406959705`*^9}, {
   3.7243996714971533`*^9, 3.724399692707183*^9}, {3.724399752677267*^9, 
   3.724399776787301*^9}, 3.724399874677438*^9, 3.72439991183749*^9, 
   3.725258513394853*^9, 3.7252586951829724`*^9, 3.725258962474386*^9, 
   3.7252590682542715`*^9, 3.725259246640585*^9, 3.725259529919883*^9, 
   3.7252596889465623`*^9, 3.725259853854452*^9, 3.72525992098137*^9, 
   3.7252600188569417`*^9, {3.7252601071871157`*^9, 3.7252601365629673`*^9}, 
   3.725260261519187*^9, 3.725260517891037*^9, 3.7252606466380634`*^9, 
   3.7252607835439034`*^9, 3.7252608353047943`*^9, {3.7252609248021517`*^9, 
   3.7252609425081825`*^9}, 3.7252609854862585`*^9, 3.725261033659143*^9, {
   3.725261074905616*^9, 3.7252611245293026`*^9}, {3.725261426514633*^9, 
   3.7252614660607023`*^9}, 3.725262508263132*^9, 3.7252631053541813`*^9, 
   3.7252635565069733`*^9, {3.7252648509700475`*^9, 3.7252648750096893`*^9}, 
   3.725264928954584*^9, 3.7252651002584853`*^9, 3.7252651511301746`*^9, 
   3.7252660515434017`*^9, 3.7252664430582895`*^9, 3.7252750239395127`*^9, 
   3.7252765175776205`*^9, 3.7252771495669303`*^9, 3.725280312686949*^9, 
   3.725339674231027*^9, 3.7253398549915447`*^9, 3.726206349328185*^9, 
   3.7262063950830655`*^9, 3.72620776991448*^9, 3.7262081155828876`*^9, 
   3.7262081996826353`*^9, 3.726210366437727*^9, 3.726210531535817*^9, 
   3.7262106127495594`*^9, 3.7262108378891554`*^9, 3.7262127601028194`*^9, 
   3.726212819462923*^9, 3.7262128723626165`*^9, 3.7262130887973967`*^9, 
   3.7262132593992963`*^9, 3.7262133499418554`*^9, 3.726213395384735*^9, 
   3.7262301365188165`*^9, 3.72629614778216*^9, 3.739783927475532*^9, 
   3.7397846308297615`*^9, 3.73978677392834*^9, 3.739787148897787*^9, 
   3.7398010011064773`*^9, 3.7398015131467648`*^9, 3.739801553213056*^9, 
   3.739801624474132*^9, 3.739801689709863*^9, 3.73980193373182*^9, 
   3.7398019877359095`*^9, 3.7398020893777227`*^9, 3.739855404777142*^9, 
   3.7398554677517443`*^9, 3.7398555558197813`*^9, 3.739856199041571*^9, 
   3.7398563810959845`*^9, 3.739856555957986*^9, {3.739856626804038*^9, 
   3.739856645852127*^9}, 3.7398567786237216`*^9, 3.7398569580939865`*^9, {
   3.739857680137285*^9, 3.7398577009674764`*^9}, 3.739857951106784*^9, 
   3.7398583081692066`*^9, 3.73985875476375*^9, 3.7398707758381968`*^9, 
   3.7398745482929096`*^9}]
}, Open  ]],

Cell[TextData[{
 "Then by coefficient comparison we obtain the conditions\n                   \
                            \n                                                \
         ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox["H", "1"], 
     SubscriptBox["H", "2"]}], "=", "1"}], TraditionalForm]]],
 "      and      ",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    RowBox[{
     RowBox[{
      RowBox[{"\[PartialD]", 
       SubscriptBox["H", "1"]}], " ", "-", " ", 
      RowBox[{
       SubscriptBox["A", "0"], " ", 
       SubscriptBox["H", "1"]}]}], "=", "0"}]}], TraditionalForm]]],
 ". \n\nA solution for this system is obtained by choosing an invertible ",
 Cell[BoxData[
  FormBox["\[CapitalPhi]", TraditionalForm]]],
 " s.t. ",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    RowBox[{
     RowBox[{
      RowBox[{"\[PartialD]", "\[CapitalPhi]"}], " ", "-", " ", 
      RowBox[{
       SubscriptBox["A", "0"], "\[CapitalPhi]"}]}], "=", "0"}]}], 
   TraditionalForm]]],
 ". Taking",
 Cell[BoxData[
  FormBox[
   RowBox[{"  ", 
    RowBox[{
     SubscriptBox["H", "1"], "=", "\[CapitalPhi]"}]}], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["H", "2"], "=", 
    SuperscriptBox["\[CapitalPhi]", 
     RowBox[{"-", "1"}]]}], TraditionalForm]]],
 " we obtain  \n\n                                                            \
          ",
 Cell[BoxData[
  FormBox[
   RowBox[{"H", "=", 
    RowBox[{"\[CapitalPhi]", "\[CenterDot]", 
     RowBox[{"\[Integral]", 
      RowBox[{"\[CenterDot]", " ", 
       SuperscriptBox["\[CapitalPhi]", 
        RowBox[{"-", "1"}]]}]}]}]}], TraditionalForm]]],
 "."
}], "Text",
 CellChangeTimes->{{3.7252669614628*^9, 3.7252672435263834`*^9}, {
  3.7252796429277725`*^9, 3.7252797871592255`*^9}, {3.7262127861860647`*^9, 
  3.726212791334074*^9}, {3.726295897411296*^9, 3.72629598881643*^9}, {
  3.7396012360586624`*^9, 3.739601250756503*^9}, {3.739601302068438*^9, 
  3.7396013133240814`*^9}, {3.739601526964301*^9, 3.739601526964301*^9}, {
  3.739786710238697*^9, 3.7397867108927345`*^9}, {3.7397868292535048`*^9, 
  3.7397868995965276`*^9}, {3.739788650597679*^9, 3.7397887215887394`*^9}, {
  3.7397887583488426`*^9, 3.7397888047724977`*^9}, {3.7397888466848946`*^9, 
  3.7397888756445513`*^9}, {3.7398010867073736`*^9, 3.7398010969189577`*^9}, {
  3.7398011657648954`*^9, 3.7398011842159505`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Diff", "[", "\[CapitalPhi]", "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{
    SubscriptBox["A", "0"], ",", "\[CapitalPhi]"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"OH", "=", 
   RowBox[{"(", 
    RowBox[{"OH", "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        SubscriptBox["H", "1"], "\[Rule]", " ", "\[CapitalPhi]"}], ",", 
       RowBox[{
        SubscriptBox["H", "2"], "\[Rule]", " ", 
        RowBox[{"inv", "[", "\[CapitalPhi]", "]"}]}]}], "}"}]}], ")"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.739855346325799*^9, 3.739855351781111*^9}, {
  3.7398555364296722`*^9, 3.7398555419809895`*^9}, {3.739857540326288*^9, 
  3.739857543573474*^9}}],

Cell[TextData[{
 "We can also check the operator ",
 Cell[BoxData[
  FormBox[
   RowBox[{"H", "=", 
    RowBox[{"\[CapitalPhi]", "\[CenterDot]", 
     RowBox[{"\[Integral]", 
      RowBox[{"\[CenterDot]", 
       SuperscriptBox["\[CapitalPhi]", 
        RowBox[{"-", "1"}]]}]}]}]}], TraditionalForm]]],
 "  satisfies the identity ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"L", "\[CenterDot]", "H"}], "=", "1"}], TraditionalForm]]],
 "."
}], "Text",
 CellChangeTimes->{
  3.7397869995972476`*^9, {3.7398696360340033`*^9, 3.739869640828278*^9}, {
   3.7398715052089148`*^9, 3.7398715052089148`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ApplyRules", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Prod", "[", 
     RowBox[{"OL", ",", "OH"}], "]"}], "-", 
    RowBox[{"Prod", "[", "]"}]}], ",", "RedSys"}], "]"}]], "Input",
 CellChangeTimes->{{3.725277918956682*^9, 3.725277956786749*^9}, {
   3.725277990560808*^9, 3.7252779933064127`*^9}, {3.725339744621351*^9, 
   3.7253397592073765`*^9}, {3.726296032786256*^9, 3.726296035058813*^9}, {
   3.7398009437111945`*^9, 3.7398009460293274`*^9}, 3.739801467845173*^9, {
   3.739857547685709*^9, 3.7398575499898415`*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.7252779704367723`*^9, 3.7252779952720165`*^9}, 
   3.7252803127181487`*^9, 3.725339674262227*^9, 3.7253397608141794`*^9, 
   3.725339855038345*^9, 3.7262063493437853`*^9, 3.7262063950986657`*^9, 
   3.7262077699456806`*^9, 3.7262081156140876`*^9, 3.7262081996982355`*^9, 
   3.726210366468927*^9, 3.7262105315514174`*^9, 3.72621061278076*^9, 
   3.726210837920355*^9, 3.726212760134019*^9, 3.7262128194941235`*^9, 
   3.7262128723782167`*^9, 3.7262130888285966`*^9, 3.726213259430496*^9, 
   3.726213349973055*^9, 3.7262133954159355`*^9, 3.7262301365812163`*^9, 
   3.726296147880144*^9, 3.7397839275175343`*^9, 3.7397846308577633`*^9, 
   3.7397867739563417`*^9, 3.7397871489437895`*^9, 3.7398010011464796`*^9, {
   3.739801513201768*^9, 3.739801553249058*^9}, 3.739801624530135*^9, 
   3.73980168983687*^9, 3.7398019337698226`*^9, 3.739801987774912*^9, 
   3.739802089417725*^9, 3.7398554048061438`*^9, 3.739855467776745*^9, 
   3.739855555839782*^9, 3.739856199061572*^9, 3.739856381112985*^9, 
   3.7398565559759865`*^9, {3.7398566268220387`*^9, 3.7398566458701286`*^9}, 
   3.7398567786417227`*^9, 3.7398569581119876`*^9, {3.7398576801562862`*^9, 
   3.7398577009844775`*^9}, 3.7398579511237845`*^9, 3.7398583081872077`*^9, 
   3.7398587547797513`*^9, 3.739870775864198*^9, 3.739874548312911*^9}]
}, Open  ]],

Cell[TextData[{
 "The equation ",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    RowBox[{
     RowBox[{"L", " ", "x"}], "=", "f"}]}], TraditionalForm]]],
 " from example above is equivalent to the equation ",
 Cell[BoxData[
  FormBox[Cell[TextData[Cell[BoxData[
    FormBox[
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"H", "\[CenterDot]", "L"}], ")"}], "x"}], "=", 
      RowBox[{"H", " ", "f"}]}], TraditionalForm]]]]], TraditionalForm]]],
 ". Let ",
 Cell[BoxData[
  FormBox["H", TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox["\[CapitalPhi]", TraditionalForm]]],
 " be defined as above. Applying the reduction system, we can easily find ",
 Cell[BoxData[
  FormBox[
   RowBox[{"1", "-", 
    RowBox[{"\[CapitalPhi]", " ", "E", " ", 
     RowBox[{
      SuperscriptBox["\[CapitalPhi]", 
       RowBox[{"-", "1"}]], "\[CenterDot]", "E"}]}]}], TraditionalForm]]],
 "  as the irreducible form of ",
 Cell[BoxData[
  FormBox[
   RowBox[{"H", "\[CenterDot]", "L"}], TraditionalForm]]],
 "."
}], "Text",
 CellChangeTimes->{{3.725272406193515*^9, 3.7252725244261227`*^9}, {
   3.725272559198583*^9, 3.7252725977618513`*^9}, {3.725276060190817*^9, 
   3.725276080907653*^9}, 3.725276126319333*^9, {3.72527979544284*^9, 
   3.725279805738858*^9}, {3.725279869886171*^9, 3.7252798828185935`*^9}, {
   3.72629599919975*^9, 3.726296028034071*^9}, {3.7396012624761734`*^9, 
   3.739601267187443*^9}, {3.7397841653081355`*^9, 3.7397841807960215`*^9}, {
   3.7397872464843683`*^9, 3.739787247924451*^9}, {3.7398016032949204`*^9, 
   3.7398016038589525`*^9}, {3.739872259160368*^9, 3.739872262416472*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ApplyRules", "[", 
  RowBox[{
   RowBox[{"Prod", "[", 
    RowBox[{"OH", ",", "OL"}], "]"}], ",", "RedSys"}], "]"}]], "Input",
 CellChangeTimes->{
  3.725262469216264*^9, {3.725265087248062*^9, 3.725265133611344*^9}, {
   3.7253397997830477`*^9, 3.7253398007190495`*^9}, {3.7262960456221247`*^9, 
   3.726296047973341*^9}, {3.7398575538380613`*^9, 3.739857555822175*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Prod", "[", "]"}], "-", 
  RowBox[{"Prod", "[", 
   RowBox[{
    RowBox[{"mul", "[", 
     RowBox[{"\[CapitalPhi]", ",", 
      RowBox[{"Eval", "[", 
       RowBox[{"inv", "[", "\[CapitalPhi]", "]"}], "]"}]}], "]"}], ",", 
    "Eval"}], "]"}]}]], "Output",
 CellChangeTimes->{
  3.7252625083099327`*^9, 3.725263105400981*^9, 3.7252635565381737`*^9, 
   3.7252648750408897`*^9, 3.7252649289857845`*^9, {3.7252651002896852`*^9, 
   3.725265116248513*^9}, 3.725265151176975*^9, 3.7252660515902014`*^9, 
   3.725266443089489*^9, 3.725275023986313*^9, 3.7252765176088204`*^9, 
   3.72527714959813*^9, 3.725280312733749*^9, 3.7253396742778273`*^9, 
   3.725339803246254*^9, 3.7253398550539446`*^9, 3.7262063493593855`*^9, 
   3.7262063951298656`*^9, 3.7262077699612803`*^9, 3.7262081156296873`*^9, 
   3.726208199729436*^9, 3.726210366484527*^9, 3.7262105315826173`*^9, 
   3.72621061279636*^9, 3.726210837935955*^9, 3.726212760149619*^9, 
   3.7262128195097237`*^9, 3.7262128723938165`*^9, 3.7262130888441963`*^9, 
   3.7262132594460964`*^9, 3.726213349988655*^9, 3.7262133954315352`*^9, 
   3.7262301366280165`*^9, 3.726296147967147*^9, 3.7397839275685377`*^9, 
   3.7397846308937654`*^9, 3.739786773978343*^9, 3.739787148982792*^9, 
   3.7398010011964827`*^9, 3.7398015132477703`*^9, 3.7398015532960606`*^9, 
   3.739801624565137*^9, 3.7398016898708725`*^9, 3.7398019338058248`*^9, 
   3.7398019878109136`*^9, 3.7398020894537272`*^9, 3.7398554048361454`*^9, 
   3.7398554678167477`*^9, 3.7398555558697844`*^9, 3.739856199089574*^9, 
   3.7398563811389866`*^9, 3.739856555999988*^9, {3.7398566268520403`*^9, 
   3.73985664590113*^9}, 3.7398567786767244`*^9, 3.7398569581389894`*^9, {
   3.739857680184288*^9, 3.739857701010479*^9}, 3.739857951148786*^9, 
   3.7398583082252097`*^9, 3.7398587548057528`*^9, 3.739870775881199*^9, 
   3.739874548332912*^9}]
}, Open  ]],

Cell[TextData[{
 "Let us define ",
 Cell[BoxData[
  FormBox[
   RowBox[{"P", ":=", 
    RowBox[{
     FormBox[
      RowBox[{"\[CapitalPhi]", " ", "E", " ", 
       SuperscriptBox["\[CapitalPhi]", 
        RowBox[{"-", "1"}]]}],
      TraditionalForm], "\[CenterDot]", "E"}]}], TraditionalForm]]],
 "  where ",
 Cell[BoxData[
  FormBox["P", TraditionalForm]]],
 " is a projector."
}], "Text",
 CellChangeTimes->{{3.725272905559992*^9, 3.725272948990468*^9}, {
  3.72527299593095*^9, 3.7252730043237653`*^9}, {3.7252731024323378`*^9, 
  3.7252731067535453`*^9}, {3.7252799245330667`*^9, 3.725279942925499*^9}, {
  3.7262300139026012`*^9, 3.7262300202050123`*^9}, {3.7396012799081707`*^9, 
  3.739601291867854*^9}, {3.7397842037403336`*^9, 3.739784258461464*^9}, {
  3.7397843292845144`*^9, 3.739784380854464*^9}, {3.7397844406128817`*^9, 
  3.7397845017963815`*^9}, {3.7397864470686445`*^9, 3.7397864490437574`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"OP", ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{
    RowBox[{"mul", "[", 
     RowBox[{"\[CapitalPhi]", ",", 
      RowBox[{"Eval", "[", 
       RowBox[{"inv", "[", "\[CapitalPhi]", "]"}], "]"}]}], "]"}], ",", 
    "Eval"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"ApplyRules", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Prod", "[", 
     RowBox[{"OP", ",", "OP"}], "]"}], "-", "OP"}], ",", "RedSys"}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.723015357013803*^9, 3.723015370741827*^9}, {
   3.7230157885177603`*^9, 3.723015790124563*^9}, 3.7230159795500956`*^9, 
   3.7243995994460526`*^9, 3.725263082609341*^9, 3.739784403581764*^9, {
   3.7397845678751607`*^9, 3.7397845736044884`*^9}, {3.739800960485154*^9, 
   3.7398009631613073`*^9}, 3.739801670975792*^9, {3.7398575752942886`*^9, 
   3.739857583117736*^9}, {3.739870714245674*^9, 3.7398707181658983`*^9}, {
   3.7398744632020426`*^9, 3.739874465000146*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.739784630919767*^9, 3.7397867739883432`*^9, 3.7397871489937925`*^9, 
   3.7398010012324843`*^9, 3.739801513370777*^9, 3.7398015534160676`*^9, 
   3.7398016246951447`*^9, 3.739801689902874*^9, 3.739801933840827*^9, 
   3.7398019878449154`*^9, 3.739802089571734*^9, 3.739855404848146*^9, 
   3.73985546785575*^9, 3.7398555558977857`*^9, 3.739856199115576*^9, 
   3.7398563811489873`*^9, 3.7398565560249896`*^9, {3.7398566268620415`*^9, 
   3.739856645933132*^9}, 3.739856778686725*^9, 3.7398569581679907`*^9, {
   3.739857680198289*^9, 3.7398577010354805`*^9}, 3.739857951175788*^9, 
   3.7398583082642117`*^9, 3.7398587548307543`*^9, 3.7398707758962*^9, 
   3.739874548351913*^9}]
}, Open  ]],

Cell[TextData[{
 "Considering the operator ",
 Cell[BoxData[
  FormBox["P", TraditionalForm]]],
 " allows us to write  ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"H", "\[CenterDot]", "L"}], ")"}], "x"}], "=", 
    RowBox[{"H", " ", "f"}]}], TraditionalForm]]],
 " as the following recurrence equation.\n \n                                 \
                                  ",
 Cell[BoxData[
  FormBox[
   RowBox[{"x", "=", " ", 
    RowBox[{
     RowBox[{"P", " ", "x"}], "+", 
     RowBox[{"H", " ", "f"}]}]}], TraditionalForm]]]
}], "Text",
 CellChangeTimes->{{3.739784517964306*^9, 3.7397845463559303`*^9}, {
  3.739784585372162*^9, 3.7397846157398987`*^9}, {3.739784739883999*^9, 
  3.7397847409560604`*^9}, {3.7397864705019846`*^9, 3.739786471972069*^9}, {
  3.7397870589406414`*^9, 3.7397870862502036`*^9}, {3.739801750516341*^9, 
  3.7398017511703787`*^9}, {3.739853327156309*^9, 3.739853330167481*^9}, {
  3.739874358536056*^9, 3.7398743603921623`*^9}, {3.739874570639188*^9, 
  3.7398745750554404`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Ex.9) Differential time delay systems (method of steps)", "Subsection",
 CellChangeTimes->{{3.7229249255965047`*^9, 3.722924961060533*^9}, {
   3.723892834583496*^9, 3.7238928637399473`*^9}, 3.725257923396613*^9, {
   3.7252632089695635`*^9, 3.7252632204511833`*^9}, {3.725267289031663*^9, 
   3.7252672960828753`*^9}, 3.726212933670724*^9, {3.726230058331479*^9, 
   3.7262300683154964`*^9}, 3.7397861447403526`*^9}],

Cell[BoxData[{
 FormBox[
  RowBox[{
   RowBox[{
   "Consider", " ", "the", " ", "differential", " ", "time", " ", "delay", 
    " ", "system"}], "       ", "\[IndentingNewLine]", 
   "                                          "}], 
  TraditionalForm], "\[IndentingNewLine]", 
 FormBox[
  RowBox[{
   "                                                                          \
               ", 
   RowBox[{Cell[TextData[Cell[BoxData[
     RowBox[{"    ", Cell[TextData[Cell[BoxData[
       FormBox[
        RowBox[{
         RowBox[{
          RowBox[{
           OverscriptBox["x", "."], " ", 
           RowBox[{"(", "t", ")"}]}], " ", "-", " ", 
          RowBox[{
           RowBox[{
            SubscriptBox["A", "0"], "(", "t", ")"}], 
           RowBox[{"x", "(", "t", ")"}]}], "+", 
          RowBox[{
           SubscriptBox["A", "1"], " ", 
           RowBox[{"(", "t", ")"}], 
           RowBox[{"x", "(", 
            RowBox[{"t", "-", "h"}], ")"}]}]}], " ", "=", " ", 
         RowBox[{"f", "(", "t", ")"}]}], TraditionalForm]], "Text",
       CellChangeTimes->{{3.725272619492689*^9, 3.7252726469955378`*^9}, {
         3.7252732177945404`*^9, 3.725273330957139*^9}, {
         3.7252745364386563`*^9, 3.725274715745372*^9}, 
         3.7252764647091274`*^9, 3.7252773100600123`*^9}]]]}]],
     CellChangeTimes->{{3.725272619492689*^9, 3.7252726469955378`*^9}, {
       3.7252732177945404`*^9, 3.725273330957139*^9}, {3.7252745364386563`*^9,
        3.725274715745372*^9}, 3.7252764647091274`*^9, 
       3.7252773100600123`*^9, {3.725277347422078*^9, 
       3.7252773750029263`*^9}, {3.725279951708315*^9, 
       3.7252799594771285`*^9}}]]], ",", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{
    "which", " ", "corresponds", " ", "to", " ", "the", " ", "operator", "  ",
      Cell[TextData[Cell[BoxData[
      FormBox[
       RowBox[{"R", ":=", 
        RowBox[{"L", "+", "S"}]}], TraditionalForm]]]]], "  ", "where", " ", 
     "the", " ", "operator", " ", Cell[TextData[Cell[BoxData[
      FormBox["L", TraditionalForm]]]]], " ", "is", " ", "defined", " ", 
     "like", " ", "above", " ", "and", " ", Cell[TextData[Cell[BoxData[
      FormBox[Cell[TextData[Cell[BoxData[
        FormBox[
         RowBox[{"S", ":=", 
          RowBox[{
           RowBox[{"-", 
            SubscriptBox["A", "1"]}], "\[CenterDot]", 
           RowBox[{"\[Delta]", "."}]}]}], TraditionalForm]]]]], 
       TraditionalForm]]]]]}]}]}], TraditionalForm]}], "Text",
 CellChangeTimes->{{3.725272619492689*^9, 3.7252726469955378`*^9}, {
   3.7252732177945404`*^9, 3.725273330957139*^9}, {3.7252745364386563`*^9, 
   3.725274715745372*^9}, 3.7252764647091274`*^9, 3.7252773100600123`*^9, {
   3.725277347422078*^9, 3.7252773750029263`*^9}, {3.725279951708315*^9, 
   3.7252800209352365`*^9}, {3.72621294855315*^9, 3.726212957585566*^9}, {
   3.7262129925452275`*^9, 3.72621299972124*^9}, {3.739601132220723*^9, 
   3.7396011476846075`*^9}, {3.7396015438372664`*^9, 
   3.7396015438372664`*^9}, {3.739784734284679*^9, 3.7397847381969028`*^9}, {
   3.739784911604821*^9, 3.739784987428158*^9}, {3.7397873869554033`*^9, 
   3.7397873893795414`*^9}, 3.739800536881925*^9, {3.73985354869198*^9, 
   3.739853550916107*^9}, {3.739855090526168*^9, 3.7398551984693418`*^9}, {
   3.739855263013034*^9, 3.739855268757362*^9}, {3.7398589822467613`*^9, 
   3.7398589827817917`*^9}, {3.7398712552306166`*^9, 3.7398712761658134`*^9}}],

Cell[BoxData[{
 RowBox[{"OS", ":=", 
  RowBox[{"-", 
   RowBox[{"Prod", "[", 
    RowBox[{
     SubscriptBox["A", "1"], ",", "\[Delta]"}], "]"}]}]}], "\n", 
 RowBox[{"OR", ":=", 
  RowBox[{"OL", "+", "OS"}]}]}], "Input",
 CellChangeTimes->{{3.7398552313742237`*^9, 3.7398552386526403`*^9}, {
  3.7398575925902777`*^9, 3.7398575988696365`*^9}, {3.739870686301076*^9, 
  3.739870695878623*^9}, {3.7398747548347235`*^9, 3.739874760063022*^9}}],

Cell[TextData[{
 "Our goal is to reproduce \[OpenCurlyDoubleQuote]method of steps\
\[CloseCurlyDoubleQuote]  for general solution of  this system. We apply the \
reduction system to the operator ",
 Cell[BoxData[
  FormBox[
   RowBox[{Cell[TextData[Cell[BoxData[
     FormBox[
      RowBox[{"H", "\[CenterDot]", "R"}], TraditionalForm]]]]], " ", "."}], 
   TraditionalForm]]],
 " "
}], "Text",
 CellChangeTimes->{{3.7252733828428297`*^9, 3.7252734115468807`*^9}, {
   3.725273446568942*^9, 3.725273474617791*^9}, {3.7252735050066447`*^9, 
   3.7252735653007507`*^9}, {3.725273640149682*^9, 3.7252736803509526`*^9}, {
   3.7252742990676394`*^9, 3.7252742996760406`*^9}, {3.7252743313128963`*^9, 
   3.7252743946802073`*^9}, {3.7252744989039907`*^9, 3.725274500760394*^9}, 
   3.7252773004815955`*^9, {3.725280026395246*^9, 3.7252800273624477`*^9}, {
   3.739601118129917*^9, 3.739601120868074*^9}, {3.739785080912505*^9, 
   3.739785142276015*^9}, {3.7398020549237523`*^9, 3.7398020626371937`*^9}, {
   3.7398552749947186`*^9, 3.739855277277849*^9}, 3.7398712208076477`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ApplyRules", "[", 
  RowBox[{
   RowBox[{"Prod", "[", 
    RowBox[{"OH", ",", "OR"}], "]"}], ",", "RedSys"}], "]"}]], "Input",
 CellChangeTimes->{{3.725259110686346*^9, 3.7252591388911953`*^9}, {
   3.725259171713653*^9, 3.725259197219698*^9}, 3.725259307309091*^9, {
   3.7252596513036957`*^9, 3.725259657122506*^9}, 3.7252599908226924`*^9, 
   3.7252600912594876`*^9, 3.725260288429234*^9, {3.725260342639329*^9, 
   3.725260351078944*^9}, {3.7252604771905656`*^9, 3.7252604956609983`*^9}, 
   3.725260558232708*^9, {3.7252606603348875`*^9, 3.725260688165336*^9}, {
   3.725260755635455*^9, 3.7252607727174845`*^9}, 3.72526081552396*^9, {
   3.725260857768834*^9, 3.7252608783920703`*^9}, {3.7252609092645245`*^9, 
   3.7252609140381327`*^9}, {3.725260974176238*^9, 3.7252609941130733`*^9}, {
   3.7252611115032797`*^9, 3.725261136213723*^9}, {3.7252613789345493`*^9, 
   3.725261394768577*^9}, 3.725265130522538*^9, 3.7252765417420626`*^9, {
   3.725276630085018*^9, 3.7252766309742193`*^9}, {3.725339821513886*^9, 
   3.7253398224654875`*^9}, {3.726296061045779*^9, 3.7262960628348923`*^9}, 
   3.7398579372379904`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Prod", "[", "]"}], "-", 
  RowBox[{"Prod", "[", 
   RowBox[{
    RowBox[{"mul", "[", 
     RowBox[{"\[CapitalPhi]", ",", 
      RowBox[{"Eval", "[", 
       RowBox[{"inv", "[", "\[CapitalPhi]", "]"}], "]"}]}], "]"}], ",", 
    "Eval"}], "]"}], "-", 
  RowBox[{"Prod", "[", 
   RowBox[{"\[CapitalPhi]", ",", 
    RowBox[{"S", "[", 
     RowBox[{"1", ",", "h"}], "]"}], ",", "Int", ",", 
    RowBox[{"mul", "[", 
     RowBox[{
      RowBox[{"inv", "[", 
       RowBox[{
        RowBox[{"S", "[", 
         RowBox[{"1", ",", 
          RowBox[{"-", "h"}]}], "]"}], "[", "\[CapitalPhi]", "]"}], "]"}], 
      ",", 
      RowBox[{
       RowBox[{"S", "[", 
        RowBox[{"1", ",", 
         RowBox[{"-", "h"}]}], "]"}], "[", 
       SubscriptBox["A", "1"], "]"}]}], "]"}]}], "]"}], "+", 
  RowBox[{"Prod", "[", 
   RowBox[{"\[CapitalPhi]", ",", "Eval", ",", 
    RowBox[{"S", "[", 
     RowBox[{"1", ",", "h"}], "]"}], ",", "Int", ",", 
    RowBox[{"mul", "[", 
     RowBox[{
      RowBox[{"inv", "[", 
       RowBox[{
        RowBox[{"S", "[", 
         RowBox[{"1", ",", 
          RowBox[{"-", "h"}]}], "]"}], "[", "\[CapitalPhi]", "]"}], "]"}], 
      ",", 
      RowBox[{
       RowBox[{"S", "[", 
        RowBox[{"1", ",", 
         RowBox[{"-", "h"}]}], "]"}], "[", 
       SubscriptBox["A", "1"], "]"}]}], "]"}]}], "]"}]}]], "Output",
 CellChangeTimes->{
  3.7252606890857377`*^9, {3.7252607281950064`*^9, 3.725260783512704*^9}, {
   3.7252608178795643`*^9, 3.7252608806696744`*^9}, {3.7252609247865515`*^9, 
   3.725260942476983*^9}, {3.725260985455058*^9, 3.725260994971075*^9}, {
   3.725261033534343*^9, 3.7252611371965246`*^9}, {3.72526138500296*^9, 
   3.725261426452233*^9}, 3.7252614660295024`*^9, 3.7252625083255324`*^9, 
   3.7252631054321814`*^9, 3.7252635565693736`*^9, 3.7252648750720897`*^9, 
   3.7252649290169845`*^9, {3.7252651002896852`*^9, 3.7252651512081747`*^9}, 
   3.725266051621402*^9, 3.7252664431206894`*^9, 3.725275024033113*^9, {
   3.7252765176556206`*^9, 3.7252765429120646`*^9}, 3.7252771496449304`*^9, 
   3.725280312764949*^9, 3.7253396743558273`*^9, 3.72533982352629*^9, 
   3.7253398551007447`*^9, 3.726206349390585*^9, 3.7262063951610656`*^9, 
   3.7262077699924803`*^9, 3.726208115676488*^9, 3.7262081997606354`*^9, 
   3.7262103665313272`*^9, 3.726210531613817*^9, 3.7262106128431597`*^9, 
   3.7262108379671555`*^9, 3.7262127601808195`*^9, 3.7262128195409236`*^9, 
   3.7262128724406166`*^9, 3.726213088890997*^9, 3.726213259492896*^9, 
   3.726213350035455*^9, 3.7262133954783354`*^9, 3.7262301367216167`*^9, 
   3.726296148108201*^9, 3.7397839276875443`*^9, 3.73978463097377*^9, 
   3.739786774071348*^9, 3.7397871490477953`*^9, 3.739801001311489*^9, 
   3.7398015134457817`*^9, 3.739801553492072*^9, 3.7398016247711487`*^9, 
   3.7398016899758787`*^9, 3.739801934016837*^9, 3.739801988011925*^9, 
   3.739802089696741*^9, 3.7398554049111495`*^9, 3.739855467908753*^9, 
   3.7398555559557886`*^9, 3.739856199161578*^9, 3.7398563811949897`*^9, 
   3.739856556069992*^9, {3.739856626908044*^9, 3.739856645980135*^9}, 
   3.739856778737728*^9, 3.7398569582149935`*^9, {3.73985768021729*^9, 
   3.739857701053481*^9}, 3.739857951233791*^9, 3.7398583083162146`*^9, 
   3.739858754880757*^9, 3.7398707759542036`*^9, 3.7398745483969154`*^9}]
}, Open  ]],

Cell[TextData[{
 "The identity ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{Cell[""], 
     RowBox[{"H", "\[CenterDot]", "R"}]}], "=", 
    RowBox[{
     RowBox[{
      RowBox[{"H", "\[CenterDot]", "L"}], "+", 
      RowBox[{"H", "\[CenterDot]", "S"}]}], "=", 
     RowBox[{
      RowBox[{"1", "-", "P", "+", 
       RowBox[{"H", "\[CenterDot]", "S"}]}], "=", 
      RowBox[{"1", "-", 
       RowBox[{"(", 
        RowBox[{"P", "-", 
         RowBox[{"H", "\[CenterDot]", "S"}]}], ")"}]}]}]}]}], 
   TraditionalForm]]],
 " allows us to define an operator ",
 Cell[BoxData[
  FormBox[Cell[TextData[Cell[BoxData[
    FormBox[Cell[TextData[Cell[BoxData[
      FormBox["G", TraditionalForm]]]]], TraditionalForm]]]]], 
   TraditionalForm]]],
 " as follows.\n\n                                                            \
         ",
 Cell[BoxData[
  FormBox[Cell[TextData[Cell[BoxData[
    FormBox[Cell[TextData[Cell[BoxData[
      FormBox[
       RowBox[{"G", ":=", 
        RowBox[{"P", "-", 
         RowBox[{"H", "\[CenterDot]", "S"}]}]}], TraditionalForm]]]]], 
     TraditionalForm]]]]], TraditionalForm]]]
}], "Text",
 CellChangeTimes->{{3.725273613567235*^9, 3.7252736256104565`*^9}, {
  3.725274399032615*^9, 3.725274508623808*^9}, {3.725274746742626*^9, 
  3.72527476619586*^9}, {3.725277286800371*^9, 3.7252772954271865`*^9}, {
  3.725280033368458*^9, 3.7252800337896585`*^9}, {3.7397850158147817`*^9, 
  3.739785070942935*^9}, {3.7397852441238403`*^9, 3.73978524971616*^9}, {
  3.7397853524840384`*^9, 3.739785415619649*^9}, {3.739785451189684*^9, 
  3.739785458932126*^9}, {3.7397864946523666`*^9, 3.7397864994926434`*^9}, {
  3.739787380556037*^9, 3.7397873815000916`*^9}, {3.739788913505717*^9, 
  3.7397889230122604`*^9}, {3.739853285438923*^9, 3.7398532860839596`*^9}, {
  3.739856072054308*^9, 3.7398560919814477`*^9}}],

Cell[BoxData[
 RowBox[{"OG", ":=", 
  RowBox[{"OP", "-", 
   RowBox[{"Prod", "[", 
    RowBox[{"OH", ",", "OS"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.7252625449855967`*^9, 3.7252625691188393`*^9}, 
   3.725265168368205*^9, 3.7397852327801914`*^9, {3.7398560034703856`*^9, 
   3.7398560288458366`*^9}, {3.7398561507338085`*^9, 
   3.7398561530699415`*^9}, {3.739857603797919*^9, 3.7398576108773236`*^9}, {
   3.739870672477285*^9, 3.739870676463513*^9}, {3.739874505593467*^9, 
   3.7398745104957476`*^9}}],

Cell[TextData[{
 "We can also check for the operator ",
 Cell[BoxData[
  FormBox["G", TraditionalForm]]],
 " the identity",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    RowBox[{
     RowBox[{"H", "\[CenterDot]", "R"}], " ", "=", " ", 
     RowBox[{"1", "-", "G"}]}]}], TraditionalForm]]],
 " holds."
}], "Text",
 CellChangeTimes->{{3.7252747705482674`*^9, 3.725274803027525*^9}, {
   3.7252748407171907`*^9, 3.7252748536652136`*^9}, {3.7252772434790955`*^9, 
   3.725277245444699*^9}, 3.7252800381420665`*^9, {3.7397855335083923`*^9, 
   3.7397856382203813`*^9}, {3.7398744341273794`*^9, 3.739874434727414*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ApplyRules", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Prod", "[", 
     RowBox[{"OH", ",", "OR"}], "]"}], "-", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Prod", "[", "]"}], "-", "OG"}], ")"}]}], ",", "RedSys"}], 
  "]"}]], "Input",
 CellChangeTimes->{
  3.72526517128541*^9, {3.7252770704269915`*^9, 3.725277123514885*^9}, {
   3.7253398295167*^9, 3.7253398302187014`*^9}, {3.726296069685801*^9, 
   3.726296071767366*^9}, {3.7398576279022975`*^9, 3.7398576320375338`*^9}, {
   3.7398707328617387`*^9, 3.7398707379580297`*^9}, {3.739872545988948*^9, 
   3.739872546552291*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.725262772231196*^9, 3.725263105494581*^9, 3.725263556631774*^9, 
   3.72526487513449*^9, 3.725264929079385*^9, 3.7252651003364854`*^9, {
   3.7252651512705746`*^9, 3.725265174749616*^9}, 3.725266051699402*^9, 
   3.7252664431830893`*^9, 3.725275024064313*^9, 3.7252765176868205`*^9, {
   3.7252771274928913`*^9, 3.7252771496917305`*^9}, 3.725280312796149*^9, 
   3.7253396743870273`*^9, {3.7253398319815044`*^9, 3.725339855147545*^9}, 
   3.7262063494373856`*^9, 3.7262063951922655`*^9, 3.7262077700236807`*^9, 
   3.726208115692088*^9, 3.7262081998074355`*^9, 3.726210366562527*^9, 
   3.726210531645017*^9, 3.72621061287436*^9, 3.726210838013955*^9, 
   3.726212760212019*^9, 3.7262128195721235`*^9, 3.7262128724562163`*^9, 
   3.7262130889377966`*^9, 3.7262132595396967`*^9, 3.726213350066655*^9, 
   3.726213395525135*^9, 3.7262301368464165`*^9, 3.72629614823351*^9, 
   3.7397839277775497`*^9, 3.7397846310367737`*^9, 3.739786774201356*^9, 
   3.7397871491117992`*^9, 3.739801001396494*^9, 3.7398015135277863`*^9, 
   3.7398015535760765`*^9, 3.7398016248531537`*^9, 3.7398016900578833`*^9, 
   3.7398019341028414`*^9, 3.73980198809993*^9, 3.7398020897427435`*^9, 
   3.739855405024156*^9, 3.739855467960756*^9, 3.739855555989791*^9, 
   3.739856199335588*^9, 3.739856381304996*^9, 3.739856556212*^9, {
   3.7398566270800533`*^9, 3.739856646153145*^9}, 3.7398567789147377`*^9, 
   3.739856958352001*^9, {3.7398576808573265`*^9, 3.7398577016695166`*^9}, 
   3.739857951894829*^9, 3.7398583088702464`*^9, 3.7398587549137588`*^9, 
   3.7398707759802046`*^9, 3.7398745484239173`*^9}]
}, Open  ]],

Cell[TextData[{
 "Considering the operator ",
 Cell[BoxData[
  FormBox["G", TraditionalForm]]],
 " allows us to rewrite ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"H", "\[CenterDot]", "R"}], ")"}], "x"}], " ", "=", " ", 
    RowBox[{"H", " ", "f"}]}], TraditionalForm]]],
 " as the following recurrence equation.\n\n                                  \
                                   ",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    RowBox[{"x", " ", "=", " ", 
     RowBox[{
      RowBox[{"G", " ", "x"}], " ", "+", " ", 
      RowBox[{"H", " ", "f"}]}]}]}], TraditionalForm]]]
}], "Text",
 CellChangeTimes->{{3.725274883414466*^9, 3.72527499950987*^9}, 
   3.7252769527871847`*^9, {3.7252771917962046`*^9, 3.725277235164281*^9}, {
   3.7252800441012774`*^9, 3.725280048640885*^9}, {3.726296079651155*^9, 
   3.726296086972534*^9}, {3.739601334485292*^9, 3.7396013371634455`*^9}, {
   3.739785667806073*^9, 3.7397856731963816`*^9}, {3.739787303124608*^9, 
   3.739787374291679*^9}, {3.7397889339408855`*^9, 3.739788935508975*^9}, {
   3.7398017366585484`*^9, 3.7398017378446164`*^9}, {3.739853337384894*^9, 
   3.739853340936097*^9}, {3.739860962942051*^9, 3.7398609657912135`*^9}, {
   3.739870331013754*^9, 3.7398703315727863`*^9}, {3.739870551509366*^9, 
   3.739870571021482*^9}, {3.7398744253128757`*^9, 3.73987442591191*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Ex.10) Variation of constants with rectangular coefficients ", \
"Subsection",
 CellChangeTimes->{{3.7229249255965047`*^9, 3.722924961060533*^9}, {
   3.723892834583496*^9, 3.7238928637399473`*^9}, 3.725257923396613*^9, {
   3.725263302195327*^9, 3.7252633191369567`*^9}, {3.7252652895034175`*^9, 
   3.7252652910790205`*^9}, {3.725265717154814*^9, 3.725265790084942*^9}, {
   3.7262131349110775`*^9, 3.726213135987479*^9}, 3.739786149308614*^9}],

Cell[TextData[{
 "Consider the inhomogeneous differential system \n\n                         \
                                 ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       SubscriptBox["A", "1"], "(", "t", ")"}], 
      OverscriptBox["x", "."], " ", 
      RowBox[{"(", "t", ")"}]}], " ", "-", " ", 
     RowBox[{
      RowBox[{
       SubscriptBox["A", "0"], "(", "t", ")"}], 
      RowBox[{"x", "(", "t", ")"}]}]}], " ", "=", 
    RowBox[{"f", "(", "t", ")"}]}], TraditionalForm]]],
 ",\n            \nwhich corresponds to the operator  ",
 Cell[BoxData[
  FormBox[
   RowBox[{"L", ":=", 
    RowBox[{
     SubscriptBox["A", "1"], "\[CenterDot]", 
     RowBox[{"\[PartialD]", 
      RowBox[{"-", 
       SubscriptBox["A", "0"]}]}]}]}], TraditionalForm]]],
 " with rectangular coefficients ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["A", "0"], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["A", "1"], TraditionalForm]]],
 ". "
}], "Text",
 CellChangeTimes->{{3.725262124525859*^9, 3.725262336647231*^9}, {
   3.7252633340349827`*^9, 3.725263336983388*^9}, {3.7252659611568427`*^9, 
   3.7252659703296585`*^9}, {3.7252673376101484`*^9, 
   3.7252673678274016`*^9}, {3.725267407913184*^9, 3.725267443210203*^9}, {
   3.725273135847596*^9, 3.725273135847596*^9}, {3.725277443331046*^9, 
   3.725277452784663*^9}, {3.7252800593113036`*^9, 3.7252800857689505`*^9}, {
   3.7262131742699466`*^9, 3.7262131883411713`*^9}, {3.739600912091132*^9, 
   3.739600913986241*^9}, {3.739785702053032*^9, 3.7397857044361687`*^9}, 
   3.739786511628337*^9, 3.739800562093367*^9, {3.739851516420741*^9, 
   3.739851530905569*^9}, {3.7398515665266066`*^9, 3.7398515665266066`*^9}, 
   3.7398549131730237`*^9}],

Cell[BoxData[
 RowBox[{"OL", ":=", 
  RowBox[{
   RowBox[{"Prod", "[", 
    RowBox[{
     SubscriptBox["A", "1"], ",", "Diff"}], "]"}], "-", 
   RowBox[{"Prod", "[", 
    SubscriptBox["A", "0"], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.7252660030741167`*^9, 3.7252660043845186`*^9}, 
   3.7262132038475986`*^9, 3.7398576475024185`*^9}],

Cell[TextData[{
 "Our goal is to construct a solution operator ",
 Cell[BoxData[
  FormBox[
   RowBox[{"H", " ", "=", " ", 
    RowBox[{
     SubscriptBox["H", "1"], "\[CenterDot]", 
     RowBox[{"\[Integral]", 
      RowBox[{"\[CenterDot]", " ", 
       SubscriptBox["H", "2"], " "}]}]}]}], TraditionalForm]]],
 " with unknowns ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["H", "1"], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["H", "2"], TraditionalForm]]],
 " such that the identity ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"L", "\[CenterDot]", "H"}], "=", "1"}], TraditionalForm]]],
 " holds. "
}], "Text",
 CellChangeTimes->{{3.7252673870310354`*^9, 3.725267397249053*^9}, {
  3.725280098326972*^9, 3.725280117577406*^9}, {3.7397859446289067`*^9, 
  3.739785946532016*^9}, {3.7397860708441257`*^9, 3.7397860801886606`*^9}}],

Cell[BoxData[
 RowBox[{"OH", ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{
    SubscriptBox["H", "1"], ",", "Int", ",", 
    SubscriptBox["H", "2"]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.725260850156021*^9, 3.7252608712472577`*^9}, 
   3.7252610169359136`*^9, 3.725261047964368*^9, {3.725261080474825*^9, 
   3.7252610994600587`*^9}, {3.7252634795052385`*^9, 3.72526350897369*^9}, 
   3.7252636071446624`*^9, 3.7252648589884615`*^9, 3.7252649051021423`*^9, 
   3.7398576511256256`*^9}],

Cell[TextData[{
 "We apply the reduction system to ",
 Cell[BoxData[
  FormBox[
   RowBox[{"L", "\[CenterDot]", "H"}], TraditionalForm]]],
 "  and extract its left coefficients."
}], "Text",
 CellChangeTimes->{{3.725267473836955*^9, 3.7252674876817465`*^9}, 
   3.725280122210614*^9, 3.739788984236762*^9, 3.7397890155505533`*^9, 
   3.7398533607172284`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ApplyRules", "[", 
  RowBox[{
   RowBox[{"Prod", "[", 
    RowBox[{"OL", ",", "OH"}], "]"}], ",", "RedSys"}], "]"}]], "Input",
 CellChangeTimes->{{3.725259110686346*^9, 3.7252591388911953`*^9}, {
   3.725259171713653*^9, 3.725259197219698*^9}, 3.725259307309091*^9, {
   3.7252596513036957`*^9, 3.725259657122506*^9}, 3.7252599908226924`*^9, 
   3.7252600912594876`*^9, 3.725260288429234*^9, {3.725260342639329*^9, 
   3.725260351078944*^9}, {3.7252604771905656`*^9, 3.7252604956609983`*^9}, 
   3.725260558232708*^9, {3.7252606603348875`*^9, 3.725260688165336*^9}, {
   3.725260755635455*^9, 3.7252607727174845`*^9}, 3.72526081552396*^9, {
   3.725260857768834*^9, 3.7252608783920703`*^9}, {3.7252609092645245`*^9, 
   3.7252609140381327`*^9}, {3.725260974176238*^9, 3.7252609941130733`*^9}, {
   3.7252611115032797`*^9, 3.725261136213723*^9}, {3.7252613789345493`*^9, 
   3.725261394768577*^9}, {3.7252635231541147`*^9, 3.7252635274753227`*^9}, {
   3.7252648453852377`*^9, 3.725264854339653*^9}, 3.7252649124497557`*^9, {
   3.7253398368175125`*^9, 3.7253398373167133`*^9}, {3.7262960947283773`*^9, 
   3.726296096370689*^9}, {3.739857656413928*^9, 3.739857658494047*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Prod", "[", 
   RowBox[{"mul", "[", 
    RowBox[{
     SubscriptBox["A", "1"], ",", 
     SubscriptBox["H", "1"], ",", 
     SubscriptBox["H", "2"]}], "]"}], "]"}], "-", 
  RowBox[{"Prod", "[", 
   RowBox[{
    RowBox[{"mul", "[", 
     RowBox[{
      SubscriptBox["A", "0"], ",", 
      SubscriptBox["H", "1"]}], "]"}], ",", "Int", ",", 
    SubscriptBox["H", "2"]}], "]"}], "+", 
  RowBox[{"Prod", "[", 
   RowBox[{
    RowBox[{"mul", "[", 
     RowBox[{
      SubscriptBox["A", "1"], ",", 
      RowBox[{"Diff", "[", 
       SubscriptBox["H", "1"], "]"}]}], "]"}], ",", "Int", ",", 
    SubscriptBox["H", "2"]}], "]"}]}]], "Output",
 CellChangeTimes->{
  3.7252606890857377`*^9, {3.7252607281950064`*^9, 3.725260783512704*^9}, {
   3.7252608178795643`*^9, 3.7252608806696744`*^9}, {3.7252609247865515`*^9, 
   3.725260942476983*^9}, {3.725260985455058*^9, 3.725260994971075*^9}, {
   3.725261033534343*^9, 3.7252611371965246`*^9}, {3.72526138500296*^9, 
   3.725261426452233*^9}, 3.7252614660295024`*^9, 3.7252625082475324`*^9, 
   3.725263105338581*^9, 3.7252635564601736`*^9, {3.7252648363060217`*^9, 
   3.7252648749628897`*^9}, 3.725264928954584*^9, 3.725265100242885*^9, 
   3.7252651511301746`*^9, 3.7252660517306023`*^9, 3.7252664432142897`*^9, 
   3.7252750241111135`*^9, 3.7252765177336206`*^9, 3.725277149722931*^9, 
   3.7252803128273487`*^9, 3.725339674418227*^9, 3.7253398551787453`*^9, 
   3.7262063494529853`*^9, 3.7262063952078657`*^9, 3.726207770039281*^9, 
   3.726208115723288*^9, 3.7262081998230357`*^9, 3.726210366593727*^9, 
   3.726210531676217*^9, 3.72621061290556*^9, 3.7262108380295553`*^9, 
   3.7262127602432194`*^9, 3.7262128195877237`*^9, 3.7262128724874163`*^9, 
   3.726213088953397*^9, 3.7262132595552964`*^9, 3.7262133500978556`*^9, 
   3.7262133955407352`*^9, 3.726230136893217*^9, 3.726296148279265*^9, 
   3.7397839278355527`*^9, 3.739784631079776*^9, 3.7397867742533584`*^9, 
   3.7397871491568017`*^9, 3.7398010014574976`*^9, 3.7398015135827894`*^9, 
   3.7398015536310797`*^9, 3.739801624909157*^9, 3.7398016901128864`*^9, 
   3.739801934160845*^9, 3.7398019881559334`*^9, 3.7398020897917466`*^9, 
   3.739855405076159*^9, 3.739855468099764*^9, 3.7398555560377936`*^9, 
   3.7398561993755903`*^9, 3.7398563813459983`*^9, 3.739856556255003*^9, {
   3.739856627131057*^9, 3.7398566462041473`*^9}, 3.739856778957741*^9, 
   3.7398569583930035`*^9, {3.739857680901329*^9, 3.7398577017115192`*^9}, 
   3.739857951935831*^9, 3.739858308918249*^9, 3.7398587549547615`*^9, 
   3.7398707761202126`*^9, 3.7398745484619193`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"%", "//", "Coefficients"}], "//", "TableForm"}]], "Input",
 CellChangeTimes->{{3.722925187781501*^9, 3.7229252237895603`*^9}, {
   3.7229253310726967`*^9, 3.722925333485834*^9}, {3.7229254079500933`*^9, 
   3.7229254113412876`*^9}, 3.7229255318941827`*^9, 3.72292564303854*^9}],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{"Prod", "[", "]"}], 
     RowBox[{"mul", "[", 
      RowBox[{
       SubscriptBox["A", "1"], ",", 
       SubscriptBox["H", "1"], ",", 
       SubscriptBox["H", "2"]}], "]"}]},
    {
     RowBox[{"Prod", "[", 
      RowBox[{"Int", ",", 
       SubscriptBox["H", "2"]}], "]"}], 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"mul", "[", 
        RowBox[{
         SubscriptBox["A", "0"], ",", 
         SubscriptBox["H", "1"]}], "]"}]}], "+", 
      RowBox[{"mul", "[", 
       RowBox[{
        SubscriptBox["A", "1"], ",", 
        RowBox[{"Diff", "[", 
         SubscriptBox["H", "1"], "]"}]}], "]"}]}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.7229252268177333`*^9, 3.72292534250535*^9, 3.7229253792574525`*^9, {
   3.722925546929043*^9, 3.722925568855297*^9}, 3.722925644239609*^9, 
   3.7229262646670523`*^9, 3.722926681749385*^9, 3.7230149566391*^9, 
   3.723015240497198*^9, 3.7230155897662115`*^9, 3.7230158073625937`*^9, 
   3.7230159563996553`*^9, 3.7230160631506424`*^9, 3.7230161143187323`*^9, 
   3.7230191519979286`*^9, 3.723020276051216*^9, 3.723020768243905*^9, 
   3.7230245292847137`*^9, 3.723028508223179*^9, 3.723028539685979*^9, 
   3.7230288185109262`*^9, 3.7230289203897533`*^9, 3.723030147649949*^9, 
   3.7230335160448847`*^9, {3.7230335502401447`*^9, 3.7230335762297897`*^9}, 
   3.72303410022871*^9, 3.723034182550055*^9, 3.7230342197249203`*^9, 
   3.7230343354303236`*^9, 3.7230343757251945`*^9, {3.723893296612508*^9, 
   3.7238933515870037`*^9}, 3.7240822352308435`*^9, 3.724082270206105*^9, {
   3.724082438592801*^9, 3.724082493879298*^9}, 3.7243964798756733`*^9, 
   3.724396536185752*^9, {3.724399514645934*^9, 3.7243995406959705`*^9}, {
   3.7243996714971533`*^9, 3.724399692707183*^9}, {3.724399752677267*^9, 
   3.724399776787301*^9}, 3.724399874677438*^9, 3.72439991183749*^9, 
   3.725258513394853*^9, 3.7252586951829724`*^9, 3.725258962474386*^9, 
   3.7252590682542715`*^9, 3.725259246640585*^9, 3.725259529919883*^9, 
   3.7252596889465623`*^9, 3.725259853854452*^9, 3.72525992098137*^9, 
   3.7252600188569417`*^9, {3.7252601071871157`*^9, 3.7252601365629673`*^9}, 
   3.725260261519187*^9, 3.725260517891037*^9, 3.7252606466380634`*^9, 
   3.7252607835439034`*^9, 3.7252608353047943`*^9, {3.7252609248021517`*^9, 
   3.7252609425081825`*^9}, 3.7252609854862585`*^9, 3.725261033659143*^9, {
   3.725261074905616*^9, 3.7252611245293026`*^9}, {3.725261426514633*^9, 
   3.7252614660607023`*^9}, 3.725262508263132*^9, 3.7252631053541813`*^9, 
   3.7252635565069733`*^9, {3.7252648509700475`*^9, 3.7252648750096893`*^9}, 
   3.725264928954584*^9, 3.7252651002584853`*^9, 3.7252651511301746`*^9, 
   3.725266051746202*^9, 3.72526644322989*^9, 3.7252750241267133`*^9, 
   3.725276517749221*^9, 3.725277149738531*^9, 3.725280312842949*^9, 
   3.7253396744338274`*^9, 3.7253398551943455`*^9, 3.7262063494529853`*^9, 
   3.7262063952078657`*^9, 3.7262077700548806`*^9, 3.726208115723288*^9, 
   3.7262081998230357`*^9, 3.726210366593727*^9, 3.726210531676217*^9, 
   3.72621061290556*^9, 3.7262108380451555`*^9, 3.7262127602432194`*^9, 
   3.726212819603324*^9, 3.7262128724874163`*^9, 3.726213088968997*^9, 
   3.726213259570896*^9, 3.7262133500978556`*^9, 3.7262133955563354`*^9, 
   3.7262301369088173`*^9, 3.726296148309494*^9, 3.7397839278525534`*^9, 
   3.739784631092777*^9, 3.73978677427236*^9, 3.7397871491698027`*^9, 
   3.7398010014724984`*^9, 3.7398015135977902`*^9, 3.739801553647081*^9, 
   3.739801624926158*^9, 3.739801690130887*^9, 3.739801934176846*^9, 
   3.739801988171934*^9, 3.7398020898167477`*^9, 3.73985540509016*^9, 
   3.7398554681117644`*^9, 3.739855556051794*^9, 3.739856199387591*^9, 
   3.7398563813589993`*^9, 3.739856556266003*^9, {3.739856627143057*^9, 
   3.7398566462911525`*^9}, 3.739856778969741*^9, 3.739856958404004*^9, {
   3.7398576809133296`*^9, 3.7398577017235193`*^9}, 3.739857951949832*^9, 
   3.73985830893025*^9, 3.739858754965762*^9, 3.739870776136214*^9, 
   3.73987454847192*^9}]
}, Open  ]],

Cell[TextData[{
 "Comparing coefficients in",
 Cell[BoxData[
  FormBox[
   RowBox[{"  ", 
    RowBox[{
     RowBox[{"L", "\[CenterDot]", "H"}], "=", "1"}]}], TraditionalForm]]],
 " yields\n\n                                                     ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox["A", "1"], 
     SubscriptBox["H", "1"], 
     SubscriptBox["H", "2"]}], "=", "1"}], TraditionalForm]]],
 "    and     ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox["A", "1"], 
      RowBox[{"\[PartialD]", 
       SubscriptBox["H", "1"]}]}], "-", " ", 
     RowBox[{
      SubscriptBox["A", "0"], " ", 
      SubscriptBox["H", "1"]}]}], "=", "0"}], TraditionalForm]]],
 ".\n \nA solution is obtained by choosing ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[CapitalTheta]", "  "}], TraditionalForm]]],
 "and ",
 Cell[BoxData[
  FormBox[
   OverscriptBox["\[CapitalTheta]", "~"], TraditionalForm]]],
 " s.t. ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox["A", "1"], "\[CapitalTheta]", 
     OverscriptBox["\[CapitalTheta]", "~"]}], " ", "=", "1"}], 
   TraditionalForm]]],
 "  and ",
 Cell[BoxData[
  FormBox[Cell[TextData[Cell[BoxData[
    FormBox[
     RowBox[{
      RowBox[{
       SubscriptBox["A", "1"], 
       RowBox[{"\[PartialD]", " ", "\[CapitalTheta]"}]}], "-", 
      RowBox[{
       FormBox[
        SubscriptBox["A", "0"],
        TraditionalForm], "\[CapitalTheta]", 
       FormBox[
        RowBox[{"=", "0"}],
        TraditionalForm]}]}], TraditionalForm]]]]], TraditionalForm]]],
 ". Taking ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["H", "1"], "=", "\[CapitalTheta]"}], TraditionalForm]]],
 "  and ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["H", "2"], "=", 
    OverscriptBox["\[CapitalTheta]", "~"]}], TraditionalForm]]],
 "  we obtain \n\n                                                            \
              ",
 Cell[BoxData[
  FormBox[
   RowBox[{"H", "=", 
    RowBox[{"\[CapitalTheta]", "\[CenterDot]", 
     RowBox[{"\[Integral]", 
      RowBox[{"\[CenterDot]", 
       OverscriptBox["\[CapitalTheta]", "~"]}]}]}]}], TraditionalForm]]],
 "."
}], "Text",
 CellChangeTimes->{{3.7252675253459015`*^9, 3.725267583429223*^9}, {
   3.725267636537261*^9, 3.725267797106759*^9}, {3.7252678768473206`*^9, 
   3.7252679179466715`*^9}, 3.72527775275399*^9, 3.725279314323794*^9, {
   3.725280127748624*^9, 3.7252802655748663`*^9}, {3.7262132232072325`*^9, 
   3.7262132320524483`*^9}, {3.7396009334623547`*^9, 
   3.7396010869891357`*^9}, {3.7396015672716064`*^9, 
   3.7396015672716064`*^9}, {3.7397839897080917`*^9, 
   3.7397839992096353`*^9}, {3.7397859799929295`*^9, 3.739786011102709*^9}, {
   3.7397860472067738`*^9, 3.739786056686316*^9}, {3.739786530647425*^9, 
   3.7397865329005537`*^9}, {3.7397873950448656`*^9, 3.739787397620013*^9}, {
   3.7397890500575275`*^9, 3.739789070094673*^9}, {3.7398021164042687`*^9, 
   3.739802120781519*^9}, {3.7398534310472507`*^9, 3.7398534434279594`*^9}, {
   3.739872283233046*^9, 3.739872298913183*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    SubscriptBox["A", "1"], ",", "\[CapitalTheta]", ",", 
    "\[CapitalTheta]\[CapitalTheta]", ",", "b___"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", "b"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    SubscriptBox["A", "1"], ",", 
    RowBox[{"Diff", "[", "\[CapitalTheta]", "]"}], ",", "b___"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", 
    SubscriptBox["A", "0"], ",", "\[CapitalTheta]", ",", "b"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"OH", "=", 
   RowBox[{"(", 
    RowBox[{"OH", "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        SubscriptBox["H", "1"], "\[Rule]", " ", "\[CapitalTheta]"}], ",", 
       RowBox[{
        SubscriptBox["H", "2"], "\[Rule]", " ", 
        "\[CapitalTheta]\[CapitalTheta]"}]}], "}"}]}], ")"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.739855371055213*^9, 3.739855389669278*^9}, {
  3.7398555096541405`*^9, 3.739855518900669*^9}, {3.73985766361434*^9, 
  3.7398576665975103`*^9}}],

Cell[TextData[{
 "We can easily check the operator ",
 Cell[BoxData[
  FormBox[
   RowBox[{"H", "=", 
    RowBox[{"\[CapitalTheta]", "\[CenterDot]", 
     RowBox[{"\[Integral]", 
      RowBox[{"\[CenterDot]", 
       OverscriptBox["\[CapitalTheta]", "~"]}]}]}]}], TraditionalForm]]],
 "  satisfies the identity ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"L", "\[CenterDot]", "H"}], "=", "1"}], TraditionalForm]]],
 "."
}], "Text",
 CellChangeTimes->{{3.7397857875879245`*^9, 3.739785844908203*^9}, 
   3.739785958780716*^9, 3.739786260490973*^9, {3.7397865929569893`*^9, 
   3.7397865982842937`*^9}, {3.7397891034125786`*^9, 3.739789108907893*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ApplyRules", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Prod", "[", 
     RowBox[{"OL", ",", "OH"}], "]"}], "-", 
    RowBox[{"Prod", "[", "]"}]}], ",", "RedSys"}], "]"}]], "Input",
 CellChangeTimes->{{3.7252778242333155`*^9, 3.7252778297713256`*^9}, {
  3.7253398426987233`*^9, 3.725339843135524*^9}, {3.726296104550228*^9, 
  3.726296106001169*^9}, {3.73980196607267*^9, 3.7398019680777845`*^9}, {
  3.7398576878387256`*^9, 3.7398577119501047`*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.7252778325949306`*^9, 3.725277885494623*^9, 3.7252803128741493`*^9, 
   3.7253396744962273`*^9, 3.725339855225545*^9, 3.7262063494997854`*^9, 
   3.726206395254666*^9, 3.7262077700860806`*^9, 3.726208115770088*^9, 
   3.726208199869836*^9, 3.7262103666249275`*^9, 3.7262105317230177`*^9, 
   3.72621061295236*^9, 3.7262108380763555`*^9, 3.7262127602900195`*^9, 
   3.7262128196345234`*^9, 3.726212872534217*^9, 3.7262130890001965`*^9, 
   3.7262132596020966`*^9, 3.7262133501446557`*^9, 3.7262133955875354`*^9, 
   3.726230137002417*^9, 3.726296148416889*^9, 3.7397839280055623`*^9, 
   3.7397846311447797`*^9, 3.739786774351364*^9, 3.739787149232806*^9, 
   3.7398010015635033`*^9, 3.7398015136847954`*^9, 3.7398015537160845`*^9, 
   3.7398016250121627`*^9, 3.7398016902268925`*^9, 3.7398019342458496`*^9, 
   3.739801988239938*^9, 3.7398020898707514`*^9, 3.7398554051301622`*^9, 
   3.7398554681667676`*^9, 3.7398555560937967`*^9, 3.739856199422593*^9, 
   3.7398563813910007`*^9, 3.7398565562990055`*^9, {3.7398566272550635`*^9, 
   3.7398566463331547`*^9}, 3.739856779069747*^9, 3.7398569584380064`*^9, {
   3.7398576809293303`*^9, 3.7398577131291723`*^9}, 3.7398579519678326`*^9, 
   3.7398583089722524`*^9, 3.7398587549837627`*^9, 3.7398707761612153`*^9, 
   3.7398745485509243`*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1920, 998},
WindowMargins->{{-8, Automatic}, {Automatic, -8}},
PrintingCopies->1,
PrintingPageRange->{1, Automatic},
Magnification:>1.5 Inherited,
FrontEndVersion->"10.2 for Microsoft Windows (64-bit) (July 29, 2015)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Info-6570581b-3d56-4a7f-b205-59545445794e"->{
  Cell[1869, 50, 290, 5, 63, "Print",
   CellTags->"Info-6570581b-3d56-4a7f-b205-59545445794e"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Info-6570581b-3d56-4a7f-b205-59545445794e", 122685, 3234}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 383, 7, 45, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[988, 33, 878, 15, 83, "Print"],
Cell[1869, 50, 290, 5, 63, "Print",
 CellTags->"Info-6570581b-3d56-4a7f-b205-59545445794e"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[2208, 61, 231, 4, 93, "Section",
 InitializationCell->True],
Cell[2442, 67, 875, 23, 540, "Text"],
Cell[3320, 92, 1009, 23, 252, "Input"],
Cell[4332, 117, 798, 20, 211, "Input"],
Cell[CellGroupData[{
Cell[5155, 141, 105, 1, 324, "Subsection"],
Cell[5263, 144, 3280, 91, 964, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8580, 240, 160, 2, 324, "Subsection"],
Cell[8743, 244, 102, 1, 225, "Text"],
Cell[8848, 247, 436, 10, 211, "Input"],
Cell[9287, 259, 1019, 26, 231, "Text"],
Cell[10309, 287, 1915, 49, 859, "Input"],
Cell[12227, 338, 205, 2, 231, "Text"],
Cell[12435, 342, 3163, 92, 1486, "Input"],
Cell[15601, 436, 157, 2, 231, "Text"],
Cell[15761, 440, 570, 13, 346, "Input"],
Cell[16334, 455, 110, 1, 231, "Text"],
Cell[16447, 458, 545, 16, 346, "Input"],
Cell[16995, 476, 182, 2, 231, "Text"],
Cell[17180, 480, 543, 17, 600, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[17760, 502, 155, 2, 325, "Subsection"],
Cell[CellGroupData[{
Cell[17940, 508, 105, 1, 262, "Subsubsection"],
Cell[18048, 511, 3297, 90, 1486, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[21382, 606, 134, 2, 262, "Subsubsection"],
Cell[21519, 610, 3177, 75, 1107, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24733, 690, 134, 2, 262, "Subsubsection"],
Cell[24870, 694, 2878, 82, 1107, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[27785, 781, 137, 2, 262, "Subsubsection"],
Cell[27925, 785, 1402, 36, 729, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[29364, 826, 134, 2, 262, "Subsubsection"],
Cell[29501, 830, 858, 20, 474, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[30396, 855, 104, 1, 262, "Subsubsection"],
Cell[30503, 858, 6933, 232, 2580, "Input"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[37485, 1096, 180, 2, 325, "Subsection"],
Cell[37668, 1100, 792, 20, 346, "Input"],
Cell[38463, 1122, 1659, 46, 729, "Input"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[40171, 1174, 341, 5, 70, "Section",
 InitializationCell->True],
Cell[40515, 1181, 4818, 143, 1864, "Input"],
Cell[45336, 1326, 2840, 88, 1318, "Input"],
Cell[48179, 1416, 3465, 107, 729, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[51681, 1528, 107, 2, 70, "Section",
 InitializationCell->True],
Cell[51791, 1532, 2650, 74, 1005, "Input"],
Cell[54444, 1608, 2112, 58, 1005, "Input"],
Cell[56559, 1668, 421, 14, 1005, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[57017, 1687, 261, 3, 70, "Section"],
Cell[57281, 1692, 1729, 48, 79, "Text"],
Cell[59013, 1742, 886, 22, 104, "Input"],
Cell[CellGroupData[{
Cell[59924, 1768, 445, 5, 65, "Subsection"],
Cell[60372, 1775, 1732, 41, 159, "Text"],
Cell[62107, 1818, 231, 6, 45, "Input"],
Cell[62341, 1826, 881, 28, 51, "Text"],
Cell[63225, 1856, 485, 10, 45, "Input"],
Cell[63713, 1868, 504, 11, 45, "Text"],
Cell[CellGroupData[{
Cell[64242, 1883, 1203, 20, 45, "Input"],
Cell[65448, 1905, 2516, 47, 44, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[68001, 1957, 312, 5, 45, "Input"],
Cell[68316, 1964, 4385, 80, 66, "Output"]
}, Open  ]],
Cell[72716, 2047, 2411, 68, 225, "Text"],
Cell[75130, 2117, 706, 20, 75, "Input"],
Cell[75839, 2139, 608, 19, 52, "Text"],
Cell[CellGroupData[{
Cell[76472, 2162, 548, 11, 45, "Input"],
Cell[77023, 2175, 1352, 18, 44, "Output"]
}, Open  ]],
Cell[78390, 2196, 1622, 43, 76, "Text"],
Cell[CellGroupData[{
Cell[80037, 2243, 395, 8, 45, "Input"],
Cell[80435, 2253, 1885, 32, 44, "Output"]
}, Open  ]],
Cell[82335, 2288, 915, 22, 47, "Text"],
Cell[CellGroupData[{
Cell[83275, 2314, 943, 21, 75, "Input"],
Cell[84221, 2337, 732, 11, 44, "Output"]
}, Open  ]],
Cell[84968, 2351, 1058, 27, 102, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[86063, 2383, 423, 5, 65, "Subsection"],
Cell[86489, 2390, 3436, 70, 170, "Text"],
Cell[89928, 2462, 440, 10, 75, "Input"],
Cell[90371, 2474, 1073, 20, 45, "Text"],
Cell[CellGroupData[{
Cell[91469, 2498, 1147, 18, 45, "Input"],
Cell[92619, 2518, 3315, 70, 73, "Output"]
}, Open  ]],
Cell[95949, 2591, 1842, 45, 102, "Text"],
Cell[97794, 2638, 512, 10, 45, "Input"],
Cell[98309, 2650, 613, 16, 45, "Text"],
Cell[CellGroupData[{
Cell[98947, 2670, 607, 15, 45, "Input"],
Cell[99557, 2687, 1636, 23, 44, "Output"]
}, Open  ]],
Cell[101208, 2713, 1380, 31, 102, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[102625, 2749, 452, 6, 65, "Subsection"],
Cell[103080, 2757, 1764, 46, 159, "Text"],
Cell[104847, 2805, 337, 9, 45, "Input"],
Cell[105187, 2816, 868, 27, 51, "Text"],
Cell[106058, 2845, 487, 10, 45, "Input"],
Cell[106548, 2857, 358, 9, 45, "Text"],
Cell[CellGroupData[{
Cell[106931, 2870, 1199, 18, 45, "Input"],
Cell[108133, 2890, 2595, 49, 44, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[110765, 2944, 312, 5, 45, "Input"],
Cell[111080, 2951, 4473, 83, 66, "Output"]
}, Open  ]],
Cell[115568, 3037, 3082, 92, 225, "Text"],
Cell[118653, 3131, 1077, 30, 104, "Input"],
Cell[119733, 3163, 658, 18, 52, "Text"],
Cell[CellGroupData[{
Cell[120416, 3185, 474, 10, 45, "Input"],
Cell[120893, 3197, 1342, 19, 44, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
